--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package class_maint as

   procedure html;
   procedure new_codes (ccode varchar2, cdescr varchar2, scode varchar2, sdescr varchar2);
   procedure action (this_classification varchar2, this_sub_class varchar2);
   procedure save_ccode (this_code varchar2, descr varchar2);
   procedure save_scode (this_code varchar2, descr varchar2);
   procedure del (code number);
   procedure import;
   procedure import2 (conf_id integer);

   procedure add_session (fname integer, fvalue varchar2);
   procedure save_session (fname integer, fvalue varchar2, this_session varchar2);
   procedure del_session (ID integer, fname integer);

   function session_list (fname integer, fvalue varchar2) return varchar2;

ccode$	constant integer := 1;
scode$	constant integer := 3;
ecode$	constant integer := 2;

end class_maint;
/
show error
