set define off

Create or Replace PACKAGE BODY common as

crypto_string$		constant varchar2(16)	:= 'jacOwpwdcryPto01';
redirecting		boolean;
private_address$	constant integer	:= -1;
new_affil_pending$	constant integer	:= 0;

-- ****************************************************************************************

procedure JS$ is

begin

   htp.print ('<script language="JavaScript" src="' ||
		server || vdir$ || 'common.js"></script>');

end JS$;

-- ****************************************************************************************

procedure JS is

begin

   htp.print ('
function popUp(URL) {
day = new Date();
id = day.getTime();
eval("page" + id + " = window.open(URL, ''" + id + "'', ''toolbar=1,scrollbars=1,location=1,status=1,menubar=1,resizable=1,width=800,height=600,left=50,top=50'');");
}');

end JS;

-- *********************************************************************************************************

procedure CSS is

begin

-- owa_util.mime_header ('text/css', FALSE);
   htp.p ('body {font: 12px Verdana, Arial, Helvetica, sans-serif;}');
   htp.p ('table {font: 12px Verdana, Arial, Helvetica, sans-serif; border-collapse: collapse; border-spacing: 1px}');
   htp.p ('td{padding:2px 2px; vertical-align:top;}');
   htp.p ('td.boldtext {font: 12px Verdana, Arial, Helvetica, sans-serif; font-weight: bold; text-align:right;}');
   htp.p ('td.totals {font: 12px Verdana, Arial, Helvetica, sans-serif; font-weight: bold; background-color: #bbc8f9;}');
   htp.p ('table.profile{border-collapse: collapse; border-spacing: 1px; width: 80%; vertical-align: middle;}');
   htp.p ('table.profile td{ padding: 2px 2px; text-align:left}');
   htp.p ('table.profile tr{font: 12px Verdana, Arial, Helvetica, sans-serif; }');
   htp.p ('table.profile td.title{font:16px Verdana, Arial, Helvetica, sans-serif; font-weight:bold; text-align:center;}');
   htp.p ('table.general{border: 1px solid; border-collapse: collapse; width: 80%}');
   htp.p ('table.general td{padding: 2px 2px; text-align: center; border: 1px solid;}');
   htp.p ('A:link{text-decoration:underline;color:blue;}');
   htp.p ('A:link.list{text-decoration:underline;font:14px Verdana, Arial, Helvetica,  sans-serif; font-weight: bold;}');
   htp.p ('A:visited{text-decoration:underline;color:purple;}');
   htp.p ('A:hover{text-decoration:underline;color:red;}');
   htp.p ('LI.BULLET {margin-left: -14pt; list-style-image:url(' || LI_dot_URL$ || ')}');
   htp.p ('CITE {font-style:normal; background-color:#FFFF00}');
   htp.p ('.subtitle {font: 14px Verdana, Arial, Helvetica, sans-serif; font-weight: bold; color: red; }');
   htp.p ('.text {font: 12px Verdana, Arial, Helvetica, sans-serif;}');
   htp.p ('table.budget {font: 12px Verdana, Arial, Helvetica, sans-serif; border-collapse: collapse; border-spacing: 1px; width: 40%}');
   htp.p ('th.budget {font: 12px Verdana, Arial, Helvetica, sans-serif; font-weight: bold; text-align: left;  background-color: #ffffff}');
   htp.p ('table.counts {font: 12px Verdana, Arial, Helvetica, sans-serif; border-collapse: collapse; border-spacing: 1px; width: 60%}');
   htp.p ('table.filter {font: 12px Verdana, Arial, Helvetica, sans-serif; border-collapse: collapse; border-spacing: 1px; width: 350px}');
   htp.p ('table.voucher {font: 12px Verdana, Arial, Helvetica, sans-serif; border-collapse: collapse; border-spacing: 1px; width: 80%; vertical-align:middle;}');
   htp.p ('th.voucher{padding:6px 6px; vertical-align:top;background: #eee;}');
   htp.p ('td.voucher{padding:6px 6px; vertical-align:top;}');
   htp.p ('.font-1 {font-size: 75%}');
   htp.p ('.font2 {font-size: 150%}');
   htp.p ('.font3 {font-size: 200%}');
   htp.p ('.red {color: RED}');
   htp.p ('table.hoverTable tr:hover td {background: #99CCFF;}');
   htp.p ('.highlight {background-color: #ffffe0;}');

   owa_util.http_header_close;

end CSS;

-- *********************************************************************************************************

function font2 (buffer varchar2) return varchar2 is

begin

   return '<span class=font2>' || buffer || '</span>';

end font2;

-- *********************************************************************************************************

function red (buffer varchar2) return varchar2 is

begin

   return '<span class=red>' || buffer || '</span>';

end red;

-- *********************************************************************************************************

function get_server_name return varchar2 is

begin

   return lower (nvl (server_override$, owa_util.get_cgi_env ('SERVER_NAME')));

end get_server_name;

-- *********************************************************************************************************

function secure_login return boolean is

server	varchar2(100);

begin

   if use_SSL$ = 'N' then
      return true;
   end if;

   if lower(owa_util.get_cgi_env ('REQUEST_PROTOCOL'))	= 'https' then
      return true;
   end if;

   if lower(owa_util.get_cgi_env ('SERVER_NAME')) = 'appora.fnal.gov' AND
	lower(owa_util.get_cgi_env('HTTP_HOST')) = '127.0.0.1:7791' then
      return true;
   end if;

   if lower(owa_util.get_cgi_env ('HTTP_HOST')) like 'localhost:%' then
      return true;
   end if;

   server := '%' || lower (get_server_name) || '%';
   if lower(owa_util.get_cgi_env ('HTTP_REFERER')) like server then
      return true;
   end if;

   if owa_util.get_cgi_env('HTTP_X_FORWARDED_FOR') is not null then
      return true;
   end if;

   return false;

end secure_login;

-- *********************************************************************************************************

function server (override boolean default false) return varchar2 is

-- Uses the PL/SQL Toolkit to return the name of the server used in the URL.
-- This is helpful for building URLs with applications.  Production and development
-- use the same code.  This elimnates the need to hard-code the URL, which means the
-- code works on both platforms.

protocol$	constant varchar2(20)	:= lower (owa_util.get_cgi_env ('REQUEST_PROTOCOL'));
server$		constant varchar2(50)	:= get_server_name;

cport		varchar2(20)		:= null;
sport		varchar2(20)		:= null;

begin

   return sserver;

   if nvl (http_port$, 80) <> 80 then
      cport := ':' || http_port$;
   end if;

   if nvl (SSL_port$, 443) <> 443 then
      sport := ':' || SSL_port$;
   end if;

-- **********

   if override then
      return ('http://' || server$ || cport);

   elsif protocol$ = 'http' then
      return (protocol$ || '://' || server$ || cport);

   else
      return (protocol$ || '://' || server$ || sport);

   end if;

exception
   when others then
      return null;

end server;

-- *********************************************************************************************************

function sserver return varchar2 is

port	varchar2(10) := null;

begin

   if SSL_port$ <> 443 then
      port :=  ':' || SSL_port$;
   end if;

   return 'https://' || get_server_name || port;

end sserver;

-- *********************************************************************************************************

function stringTokenizer(PC$Chaine in long,PN$Pos in PLS_INTEGER, PC$Sep in varchar2 default ',') return varchar2 is

    LC$Chaine varchar2(32767) := PC$Sep || PC$Chaine ;
    LI$I      PLS_INTEGER ;
    LI$I2     PLS_INTEGER ;
    begin
      LI$I := INSTR( LC$Chaine, PC$Sep, 1, PN$Pos ) ;
      if LI$I > 0 then
	 LI$I2 := INSTR( LC$Chaine, PC$Sep, 1, PN$Pos + 1) ;
	 if LI$I2 = 0 then
	    LI$I2 := length( LC$Chaine ) + 1 ;
	end if ;
	return( SUBSTR( LC$Chaine, LI$I+1, LI$I2 - LI$I-1 ) ) ;
      else
	return null;
      end if ;
 end stringTokenizer;

-- *********************************************************************************************************

function yes_no (yn varchar2 default 'N') return varchar2 is

begin


   if upper(yn) = 'Y' then
      return ('Yes');
   elsif upper(yn) = 'N' then
      return ('No');
   elsif upper(yn) = '?' then
      return ('Unknown');
   else
      return (yn);
   end if;

   return null;

end yes_no;

-- *********************************************************************************************************

function decode_value (descr_field varchar2, user_table varchar2,
		       code_field varchar2,  code_value varchar2) return varchar2 is

return_value	varchar2(4000);
stmt		constant varchar2(2000) := 	'select ' || descr_field ||
						' from '  || user_table  ||
						' where ' || code_field  || ' = :1';

begin

   if code_value is null then
      return null;
   end if;

   execute immediate stmt into return_value Using code_value;
   return return_value;

exception when no_data_found then
   return null;

end decode_value;

-- *********************************************************************************************************

procedure show_data_sep (num_cols integer, sep_str varchar2 default htf.hr) is

begin

   htp.tableRowOpen ('CENTER', 'MIDDLE');
   htp.tableData (sep_str, ccolspan => num_cols);
   htp.tableRowClose;

end show_data_sep;

-- *********************************************************************************************************

procedure show_title_sep (num_cols integer, sep_str varchar2 default htf.hr) is

begin

   htp.tableRowOpen ();
   htp.tableData (sep_str, ccolspan => num_cols,cattributes=>'class="title"');
   htp.tableRowClose;

end show_title_sep;

-- *********************************************************************************************************

procedure show_data_rowl (label varchar2, data_value varchar2) is

begin

   htp.tableRowOpen;
   htp.tableData (font2(label), 'RIGHT', cnowrap=>'NOWRAP', cattributes=>'class=boldtext');
   htp.tableData(data_value);
   htp.tableRowClose;

end show_data_rowl;

-- *********************************************************************************************************

procedure show_data_row (label varchar2, data_value varchar2) is

begin

   htp.tableRowOpen('LEFT', 'TOP');
   htp.tableHeader (label, 'RIGHT', cnowrap=>'NOWRAP', cattributes=>'class=boldtext');
   htp.tableData(data_value);
   htp.tableRowClose;

end show_data_row;

-- *********************************************************************************************************

procedure show_data_row2 (label1 varchar2, data_value1 varchar2, label2 varchar2, data_value2 varchar2) is

begin

   htp.tableRowOpen;
   htp.tableHeader (label1, 'RIGHT', cnowrap=>'x');
   htp.tableData   (data_value1, 'LEFT');
   htp.tableHeader (label2, 'RIGHT', cnowrap=>'x');
   htp.tableData   (data_value2, 'LEFT');
   htp.tableRowClose;

end show_data_row2;

-- *********************************************************************************************************

procedure show_data_row (label varchar2, data_value date) is

local_date	date := data_value + replace (sessiontimezone,':','.')/24;

begin

   show_data_row (label, to_char (local_date, 'mm/dd/yyyy hh:mi:ss'));

end show_data_row;

-- ***********************************************************************************************

function valid_entry return boolean is

begin

   if gbl_pid is null then
      return false;
   else
      return true;
   end if;

end valid_entry;

-- ***********************************************************************************************

procedure access_denied is

begin

   public_header ('Access Denied', false);
   htp.header (2, 'You are not authorized to access this page.');
   footer;

end access_denied;

-- ***********************************************************************************************

function protected_app (buffer varchar2) return boolean is

cursor	driver is
select	1
from	applications
where	buffer	like application_name;

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end protected_app;

-- ***********************************************************************************************

function explicitly_protected (buffer varchar2) return varchar2 is

cursor	driver is
select	'Y'
from	applications
where	application_name = buffer;

explicit	char(1) := 'N';

begin

   open driver;
   fetch driver into explicit;
   close driver;

   return nvl (explicit, 'N');

end explicitly_protected;

-- ***********************************************************************************************

function get_alternate_name (buffer varchar2) return varchar2 is

cursor	driver is
select	alternate_URL
from	menu_item_subs
where	maint_tab_name = buffer;

rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into rec;
   close driver;

   return rec.alternate_URL;

end get_alternate_name;

-- ***********************************************************************************************

function has_privs_to_page (	app_name varchar2 default null,
				show_err_msg boolean default true) return boolean is

cursor	driver (app_name$ varchar2, wildcard$ varchar2) is
select	validate_ip_address
from	person_privs		pp,
	privilege_codes		pc,
	application_privs	ap,
	applications		apps
where	app_name$		like decode (wildcard$, 'Y', apps.application_name,
					replace (apps.application_name, '%', null))
and	ap.application_id	= apps.application_id
and	pc.privilege_code	= ap.privilege_code
and	pp.privilege_code	= pc.privilege_code
and	pp.person_id		= gbl_priv_pid
order by decode (pc.validate_ip_address, null,9, 'Y',0, 'N', 1);

validate_ip	varchar2(1);
rec_found	boolean;
buffer		varchar2(4000);
wildcard	char(1) := 'Y';
ipos		integer;

begin

   if gbl_priv_pid = admin_pid$ then -- "backdoor" account
      return true;
   end if;

   buffer := lower (nvl (app_name, substr (owa_util.get_cgi_env ('PATH_INFO'), 2)) );


   if buffer like 'maint.tab?tab_name=%' then -- find the table name
      buffer	:= substr (buffer, 20);
      ipos	:= instr (buffer, '&');
      if ipos = 0 then
	 ipos := length (buffer) + 1;
      end if;
      buffer	:= substr (buffer, 1, ipos-1);
      buffer	:= get_alternate_name (buffer);
   end if;

   ipos	  := instr (buffer, '?');
   if ipos <> 0 then
      buffer := substr (buffer, 1, ipos-1);
   end if;

   if NOT protected_app (buffer) then
      return true;
   end if;

   if explicitly_protected (buffer) = 'Y' then
      wildcard := 'N';
   end if;

   open driver (buffer, wildcard);
   fetch driver into validate_ip;
   rec_found := driver%FOUND;
   close driver;

   if NOT rec_found then
      if show_err_msg then
	 access_denied;
      end if;
      return false;
   end if;

   if validate_IP = 'Y' then
      if IP_addr_list$ is not null then
	 buffer := owa_util.get_cgi_env (nvl (IP_addr_var$, 'REMOTE_ADDR'));
	 if instr (IP_addr_list$, buffer) = 0 then
	    if show_err_msg then
	       access_denied;
	    end if;
	    return false;
	 end if;
      end if;
   end if;

   return true;

end has_privs_to_page;

-- ***********************************************************************************************

function has_privs_to_URL (app_name varchar2) return varchar2 is

begin

   if has_privs_to_page (app_name, false) then
      return 'Y';
   end if;

   return 'N';

end has_privs_to_URL;

-- ***********************************************************************************************

function  convert_date (this_date varchar2) return date is

cursor driver is
select to_date (this_date, 'mm/dd/yyyy') new_date
from   dual;

driver_rec  driver%ROWTYPE;

begin


  open driver;
  fetch driver into driver_rec;
  close driver;

  return (driver_rec.new_date);

  exception
     when value_error then return (null);
     when others      then return (null);

end convert_date;

-- ***********************************************************************************************

function validate_date (this_date varchar2, fmt_str varchar2 default 'mm/dd/yyyy')
				return boolean is

cursor driver is
select to_date (this_date, fmt_str) new_date
from   dual;

driver_rec  driver%ROWTYPE;

begin


  open driver;
  fetch driver into driver_rec;
  close driver;

  return (true);

  exception
     when value_error then return (false);
     when others      then return (false);

end validate_date;

-- ***********************************************************************************************

function validate_number (this_value varchar2) return boolean is

cursor driver is
select to_number(this_value) new_number
from   dual;

driver_rec  driver%ROWTYPE;

begin


  open driver;
  fetch driver into driver_rec;
  close driver;

  return (true);

  exception
     when value_error then return (false);
     when others      then return (false);

end validate_number;

-- ***********************************************************************************

procedure footer as

begin

   htp.hr;
   htp.tableOpen (cattributes=>'WIDTH="100%" CELLPADDING="0" CELLSPACING="0"');
   htp.tableRowOpen ('LEFT', 'TOP');

   if has_privs_to_page (editor_page$, false) then
      htp.tableData ('Email questions, problems or suggestions to the ' ||
		htf.mailto ('jacow-spms-users@lists.sourceforge.net', 'JACoW Users Mailing List'));
   else
      htp.tableData ('Please contact the '	||
		htf.mailto (editor_email$, conf_title$ || ' Database Administrator') ||
		' with questions, problems or suggestions.');
   end if;

   htp.tableData (local_time (get_UTC_time), 'RIGHT');
   htp.tableRowClose;

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableData (htf.address ('SPMS Author:' || space2$ ||
			'Matthew Arena &mdash; Fermi National Accelerator Laboratory'));
   htp.tableData (version_string$ || ' Version ' ||
			decode_value ('version', 'control', '1', '1'), 'RIGHT');
   htp.tableRowClose;

   if legal_footer_text$ || legal_footer_URL$ is NOT null then
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData (htf.address (credits_footer$) );
      htp.tableData (htf.anchor (legal_footer_URL$, legal_footer_text$), 'RIGHT' );
      htp.tableRowClose;
   end if;

   htp.tableClose;
   htp.bodyClose;
   htp.htmlClose;

   dbms_application_info.set_module ('Footer', owa_util.get_cgi_env ('REMOTE_ADDR'));

end footer;

-- ***********************************************************************************************

procedure formTableButton (script varchar2, buffer varchar2) is

begin

   htp.p ('<TD>');
   htp.formOpen (script);
   htp.formSubmit (null, buffer);
   htp.formClose;
   htp.p ('</TD>');

end formTableButton;

-- ***********************************************************************************************

procedure display_logo (irows integer) is

begin

   if logo_url$ is not null then
      if pubs_home_page$ is null then
	 htp.tableData (htf.img (logo_url$, 'RIGHT', conf_title$ || ' Logo'), 'RIGHT', crowspan=>irows);
      else
	 htp.tabledata (htf.anchor2 (pubs_home_page$,
			htf.img (logo_url$, 'RIGHT', conf_title$ || ' Logo', cattributes=>'BORDER="0"'),
			ctarget=>'_top'), 'RIGHT', crowspan=>irows);
      end if;
   else
      htp.tableData (space$);
   end if;

end display_logo;

-- ***********************************************************************************************

procedure header_body_open (this_title varchar2, print boolean default false,
			 JavaScript varchar2 default null, open_attribs varchar2 default null) is

proxy_for	varchar2(2000);
is_admin$	boolean := has_privs_to_page (repository_URL$, false);
is_editor$	boolean := has_privs_to_page (editor_page$, false);
is_qa$		boolean := has_privs_to_page (QA_page$, false);
irows		integer := 1;
show_search	boolean;

begin

   if is_admin$ OR is_editor$ OR is_qa$ then
      irows := 2;
   end if;

   htp.bodyOpen (cattributes=>'BGCOLOR="#FFFFFF" ' || open_attribs);

   if JavaScript is not null then
      htp.p ('<SCRIPT TYPE="text/javascript" language="JavaScript" src="' || JavaScript || '"></SCRIPT>');
   end if;

   htp.p ('<SCRIPT type="text/javascript" language="JavaScript">window.focus();</SCRIPT>');

-- **********

   htp.tableOpen (cattributes=>'WIDTH="100%"');
   htp.tableRowOpen ('RIGHT', 'TOP');

   htp.tableData ('<span class=font3>' || htf.bold (conf_title$ || ' ' || this_title) || '</span>', 'LEFT');

-- **********

   if gbl_priv_pid <> gbl_pid then
      proxy_for := htf.br || 'Proxy For: ' || get_user_name (gbl_pid) ||
			htf.br || htf.anchor ('profile.find_repo3?pid=' || gbl_priv_pid, 'Clear Proxy');
   end if;

   if gbl_priv_pid is null then
      htp.tableData (get_user_name (gbl_pid),cattributes => 'class=boldtext');
   elsif gbl_priv_pid = admin_pid$ then
      htp.tableData ('JACoW Administrator' || proxy_for,cattributes => 'class=boldtext' );
  else
      htp.tableData (get_user_name (gbl_priv_pid) || proxy_for, cattributes => 'class=boldtext');
  end if;

-- **********

   display_logo (irows);
   htp.tableRowClose;

-- **********

   htp.tableRowOpen ('RIGHT', 'TOP');
   htp.p ('<TD COLSPAN="2">');

   if lower (owa_util.get_cgi_env ('PATH_INFO')) NOT in ('/common.logout', '/profile.html') then
      if nvl (gbl_priv_pid, gbl_pid) is NOT null then
	 htp.p (htf.anchor2 ('common.logout', 'Logout', ctarget=>'_top'));
	 htp.p (space2$);
      end if;
   end if;

   if print then
      htp.p (htf.anchor ('javascript::void', 'Print', cattributes=>'onClick="window.print()"'));
      htp.p (space2$);
   end if;

-- **********

-- Don't hide if a privileged user is logged in
   show_search := common.has_privs_to_page ('search.html', false);
   if NOT show_search then
      if common.PC_mode$ = 'Y' then
         show_search := common.has_privs_to_page (common.set_proposal_page$, false)
			OR prog_cmtte.is_coordinator ('%');
      end if;
   end if;

   if show_search then
      htp.p (htf.anchor2 ('search.html', 'Search', ctarget=>'_top'));
      htp.p (space2$);
   end if;

   if gbl_pid is not null then
      htp.p (htf.anchor2 ('search.schedule', 'My Schedule', ctarget=>'_top'));
      htp.p (space2$);
   end if;

   if program_download_URL$ is not null AND hide_program_codes$ = 'N' AND
		lower (owa_util.get_cgi_env ('PATH_INFO')) NOT like '%registration.%' then
      htp.p (htf.anchor2 (program_download_URL$, 'Program Guide', ctarget=>'_top'));
      htp.p (space2$);
   end if;

   if NOT is_admin$ AND NOT is_editor$ AND NOT is_qa$ then
      htp.anchor2 ('jacow.html', 'Home', ctarget=>'_top');
      htp.p (space2$);
   end if;

-- **********

   if is_admin$ OR is_editor$ OR is_qa$ then
      if is_admin$ then
	 htp.anchor2 ('repository.html', 'Home', ctarget=>'_top');
	 htp.p (space2$);

	 if has_privs_to_page ('profile.find_repo', false) then
	    htp.anchor2 ('profile.find_repo', 'Find Profiles', ctarget=>'_top');
	    htp.p (space2$);
	 end if;

      elsif is_editor$ then
	 htp.p (htf.anchor2 ('editor.html', 'Home', ctarget=>'_top'));
	 htp.p (space2$);

      elsif is_qa$ then
	 htp.p (htf.anchor2 ('editor.qa', 'Home', ctarget=>'_top'));
	 htp.p (space2$);
      else
	 htp.p (htf.anchor2 ('jacow.html', 'Home', ctarget=>'_top'));
	 htp.p (space2$);

      end if;
   end if;

   htp.p ('</TD>');
   htp.tableRowClose;
   htp.tableClose;

end header_body_open;

-- ***********************************************************************************************

procedure get_gbl_pid (redirect boolean default true) is

/*	The purpose of this routine is two fold.  1st it sets the global PID variable
	based on the encrypted person ID created at login.  If the user is not logged in the
	browser is redirected to the login page, unless the user is in the process of
	creating a new account or searching for an existing one. */

cursor	driver (URL$ varchar2) is
select	1
from	no_login_URLs
where	URL$ like URL;

path$	constant varchar2(100) := substr (lower (owa_util.get_cgi_env ('PATH_INFO')), 2);

dummy		integer;
rec_found	boolean;

begin

   if gbl_pid is null then
      gbl_pid := get_cookie (cookie_name$);
   end if;

   if gbl_priv_pid is null then
      gbl_priv_pid := get_cookie (cookie_priv$);
   end if;

   open driver (path$);
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   if redirect then
      if NOT rec_found then
	 if gbl_pid is null AND gbl_priv_pid is null then -- user is not logged on
	    logged_in	:= false;
	    redirecting	:= true;
	    redirect_URL (server || vdir$ || 'profile.login?URL=' || path$);
	 end if;
      end if;
   end if;

end get_gbl_pid;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure public_header (this_title varchar2, body_open boolean default true,
			print boolean default false, js_src common.ident_arr,
			cache_timeout integer default null,
			css_src common.ident_arr) as

timeout	varchar2(50);

begin

   get_gbl_pid (false);
   dbms_application_info.set_client_info (get_user_name (nvl (gbl_priv_pid, gbl_pid)));
   dbms_application_info.set_module (replace (owa_util.get_cgi_env ('PATH_INFO'), '/', null),
					owa_util.get_cgi_env ('REMOTE_ADDR'));
-- htp.p ('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">');
   htp.p ('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/1998/REC-html40-19980424/loose.dtd">');
-- htp.p ('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">');

   htp.htmlOpen;
   htp.headOpen;

   htp.p ('<META HTTP-EQUIV="Content-Type" CONTENT="text/html;' || owa_util.get_cgi_env('REQUEST_IANA_CHARSET') || '">');
   htp.p ('<META NAME="Author" CONTENT="Matt Arena, Fermi National Accelerator Laboratory, Batavia, Illinois">');
   htp.p ('<META NAME="KEYWORDS" CONTENT="' || conf_title$ || '">');
   htp.p ('<META NAME="ROBOTS" CONTENT="ALL">');

   if cache_timeout is null then
      htp.p ('<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">');
   else
      timeout := to_char (get_UTC_time+(cache_timeout/1440), 'Dy, DD Mon YYYY HH:MI:SS');
      htp.p ('<META HTTP-EQUIV="EXPIRES" CONTENT="' || timeout || ' UTC">');
   end if;

   for i in 1..css_src.COUNT LOOP
      htp.linkRel ('stylesheet', css_src(i));
   end loop;

   for i in 1..js_src.COUNT LOOP
      if js_src(i) is not null then
         htp.p ('<SCRIPT TYPE="text/javascript" language="JavaScript" src="' || js_src(i) || '"></SCRIPT>');
      end if;
   end loop;


   htp.p ('<link rel=stylesheet type="text/css" href="' || server || vdir$ || 'common.css">');
   if CSS_URL$ is not null then
      htp.p ('<link rel=stylesheet type="text/css" href="' || CSS_URL$ || '">');
   end if;

   htp.title (conf_title$ || ' ' || this_title);
   if body_open then
      htp.headClose;
      header_body_open (this_title, print);
   end if;

end public_header;

-- ***********************************************************************************************

function header (this_title varchar2, body_open boolean default true,
		print boolean default false, js_src common.ident_arr,
		cache_timeout integer default null,
		css_src common.ident_arr,
		test_only boolean default false) return boolean as

timeout		varchar2(50);

begin

   get_gbl_pid;

   if has_privs_to_page then
      if not test_only then
	 public_header (this_title, body_open, print, js_src,
			cache_timeout, css_src);
      end if;
      return true;
   end if;

   return false;

end header;

-- ***********************************************************************************************

procedure public_header (this_title varchar2, body_open boolean default true,
			print boolean default false, js_src varchar2,
			cache_timeout integer default null, css_src varchar2) as

js_sources	common.ident_arr;
css_sources	common.ident_arr;

begin

   if js_src is not null then
      js_sources(1)	:= js_src;
   end if;

   if css_src is not null then
      css_sources(1)	:= css_src;
   end if;

   public_header (this_title, body_open, print, js_sources, cache_timeout, css_sources);

end public_header;

-- ***********************************************************************************************

function header (this_title varchar2, body_open boolean default true, print boolean default false,
		js_src varchar2 default null, cache_timeout integer default null,
		css_src varchar2 default null,
		test_only boolean default false) return boolean as

js_sources	common.ident_arr;
css_sources	common.ident_arr;

begin

   js_sources(1)	:= js_src;
   css_sources(1)	:= css_src;
   return header (this_title, body_open, print, js_sources,
			cache_timeout, css_sources, test_only);

end header;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure redirect_URL (URL varchar2) is

begin

   htp.htmlOpen;
   htp.headOpen;
   htp.meta ('Pragma', null, 'no-cache');
   htp.meta ('Refresh', null, '0; URL=' || URL);
   htp.meta('Author', null, 'Matt Arena');
   htp.meta('GENERATOR', null, 'Oracle Web Agent');
   htp.linkRev ('made',	'mailto:arenam@fnal.gov');
   htp.headClose;
   htp.bodyOpen(null,'BGCOLOR="#ffffff"');

   htp.anchor (URL, 'Click here');
   htp.p (' if your browser does not automatically forward.');
   footer;

end redirect_URL;

-- *********************************************************************************************************************

procedure onclick_script is

begin

   htp.p ('<SCRIPT TYPE="text/javascript1.1">');
   htp.p ('<!--');

   htp.p ('var already_clicked =  false');
   htp.p ('function checksubmit ()');
   htp.p ('{');
   htp.p ('    if (already_clicked == false)');
   htp.p ('    {');
   htp.p ('	   already_clicked = true');
   htp.p ('	   return true');
   htp.p ('    }');
   htp.p ('    alert ("Your file is being uploaded.")');
   htp.p ('    return false');
   htp.p ('}');

   htp.p ('-->');
   htp.p ('</SCRIPT>');

end onclick_script;

-- *********************************************************************************************************************

function format_time (this_time integer) return varchar2 is

chr_time	varchar2(4) := to_char(this_time, 'FM0000');

begin

   if this_time is null then
      return null;
   else
      return substr (chr_time, 1, 2) || ':' || substr (chr_time, 3);
   end if;

end format_time;

-- *******************************************************************************************************************************

function IFNOTNULL (str1 varchar2, str2 varchar2) return varchar2 is

begin

   if str1 is NULL then
      return (NULL);
   else
      return (str2);
   end if;

end;

-- *********************************************************************************************************

function radio_yes_no (var_name varchar2, var_value varchar2 default 'Y',
			include_not_sure boolean default true) return varchar2 is

yes	varchar2(8) := null;
no	varchar2(8) := null;
ns	varchar2(8) := null;

begin

   if var_value = 'Y' then
      yes := 'SELECTED';
   elsif var_value = 'N' then
      no  := 'SELECTED';
   else
      ns  := 'SELECTED';
   end if;

   if include_not_sure then
      return	htf.formRadio (var_name, 'Y', yes) || ' Yes '	|| space2$ ||
		htf.formRadio (var_name, 'N', no)  || ' No'	|| space2$ ||
		htf.formRadio (var_name, '?', ns)  || ' Not Sure';
   else
      return	htf.formRadio (var_name, 'Y', yes) || ' Yes '	|| space2$ ||
		htf.formRadio (var_name, 'N', no)  || ' No';
   end if;

end radio_yes_no;

-- *********************************************************************************************************

function popup_yes_no (var_name varchar2, var_value varchar2 default 'Y', allow_null boolean default true) return varchar2 is

yes	varchar2(8)	:= null;
no	varchar2(8)	:= null;
neither	varchar2(8)	:= null;
buffer	varchar2(100)	:= null;

begin

   if var_value = 'Y' then
      yes := 'SELECTED';
   elsif var_value = 'N' then
      no  := 'SELECTED';
   else
      neither := 'SELECTED';
   end if;

   if allow_null then
      buffer := htf.formSelectOption ('', neither);
   end if;

   return
	htf.formSelectOpen (var_name)	|| buffer				||
	htf.formSelectOption ('Yes',	yes,	cattributes=>'VALUE="Y"')	||
	htf.formSelectOption ('No', 	no, 	cattributes=>'VALUE="N"')	||
	htf.formSelectClose;

end popup_yes_no;

-- ********************************************************************************************

function get_paper_ID_list (abs_id integer) return common.ident_arr is

cursor	driver is
select	paper_id
from	sessions		s,
	abstract_sessions	sa
where	sa.abstract_id		= abs_id
and	s.session_id		= sa.session_id
order by
	decode (sa.primary_flag, 'Y', 0, 1),
	s.sort_order	nulls last,
	s.session_date, s.beg_time, s.end_time, s.session_id;

IDs	common.ident_arr;

begin

   for rec in driver LOOP
      IDs(IDs.COUNT+1) := rec.paper_id;
   end loop;

   return IDs;

end get_paper_ID_list;

-- *********************************************************************************************************************

function get_paper_ID (	abs_id		integer,
			primary_only	varchar2 default 'Y',
			fmt_out		varchar2 default 'N') return varchar2 is

cursor	driver is
select	paper_id, primary_flag
from	sessions		s,
	abstract_sessions	sa
where	sa.abstract_id		= abs_id
and	s.session_id		= sa.session_id
order by
	decode (sa.primary_flag, 'Y',0, 1),
	s.sort_order	nulls last,
	s.session_date, s.beg_time, s.end_time, s.session_id;

buffer	varchar2(4000)	:= null;
sepstr	varchar2(2)	:= null;

begin

   for rec in driver LOOP
      buffer := buffer || sepstr;

      if fmt_out = 'Y' and rec.primary_flag = 'N' then
         buffer := buffer || htf.italic (rec.paper_id);
      else
         buffer := buffer || rec.paper_id;
      end if;

      sepstr := ', ';
      exit when primary_only = 'Y';
   end loop;

   return buffer;

end get_paper_ID;

-- *********************************************************************************************************************

function get_keywords (this_id integer) return varchar2 is

cursor	driver is
select	k.keyword_descr
from	keyword_codes		k,
	abstract_keywords	ak
where	ak.abstract_id		= this_id
and	k.keyword_code		= ak.keyword_code
order by
	k.keyword_descr;

kw_list	varchar2(2000);

begin

   for driver_rec in driver LOOP
      kw_list := kw_list || ', ' || driver_rec.keyword_descr;
   end loop;

   kw_list := substr (kw_list, 3);
   return (kw_list);

end get_keywords;

-- *******************************************************************************************************************************

function trans_chr (buffer varchar2) return varchar2 is

new_buff	varchar2(4000) := buffer;

begin

   for i in 128..255 LOOP
      new_buff := replace (new_buff, chr(i), '&#' || to_char(i) || ';');
   end loop;

   return new_buff;

end trans_chr;

-- *******************************************************************************************************************************

function get_user_name_part (pid integer, part varchar2, translate varchar2 default 'Y') return varchar2 is

cursor	driver is
select	decode (part, fname$, fname, lname$, lname)	name
from	persons
where	person_id = pid;

driver_rec	driver%ROWTYPE;
rec_found	boolean;

begin

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if translate = 'Y' then
      driver_rec.name := trans_chr (driver_rec.name);
   end if;

   return driver_rec.name;

end get_user_name_part;

-- *******************************************************************************************************************************

function get_user_name (pid integer, reverse boolean default false, translate varchar2 default 'Y', initials_only varchar2 default 'N') return varchar2 is

cursor	driver is
select	fname || decode (mname, null,null, ' '||mname)	fm_name,
	initials, lname
from	persons
where	person_id = pid;

driver_rec	driver%ROWTYPE;
rec_found	boolean;

begin

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if translate = 'Y' then
      driver_rec.lname		:= trans_chr (driver_rec.lname);
      driver_rec.fm_name	:= trans_chr (driver_rec.fm_name);
   end if;

   if initials_only = 'Y' then
      if reverse then
	 return driver_rec.lname || ', ' || driver_rec.initials;
      else
	 return driver_rec.initials || ' ' || driver_rec.lname;
      end if;
   end if;

   if reverse then
      return driver_rec.lname || ', ' || driver_rec.fm_name;
   end if;

   return trim (driver_rec.fm_name || ' ' || driver_rec.lname);

end get_user_name;

-- *******************************************************************************************************************************

function get_user_name (pid integer, reverse varchar2, translate varchar2 default 'Y', initials_only varchar2 default 'N') return varchar2 is

begin

   if reverse = 'Y' then
      return get_user_name (pid, true, translate, initials_only);
   end if;

   return get_user_name (pid, false, translate, initials_only);

end get_user_name;

-- *******************************************************************************************************************************

function get_user_index_name (pid integer) return varchar2 is

cursor	driver is
select	fname || decode (mname, null,null, ' '||mname)	fm_name,
	lname
from	persons
where	person_id = pid;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   return driver_rec.lname  || ', ' || driver_rec.fm_name;

end get_user_index_name;

-- *******************************************************************************************************************************

function get_address (aid integer, term_char varchar2,
			include_country varchar2 default 'Y') return varchar2 is

cursor	driver is
select	*
from	addresses
where	address_id = aid;

driver_rec	driver%ROWTYPE;
buffer		varchar2(1000)	:= null;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   if driver_rec.affiliation_id = private_address$ then  -- private address
      if NOT common.user_is_JACoW_admin then
	 return ('Private Address');
      end if;
   end if;

   if driver_rec.address1 is not null then
      buffer := buffer || term_char || driver_rec.address1;
   end if;

   if driver_rec.address2 is not null then
      buffer := buffer || term_char || driver_rec.address2;
   end if;

   if driver_rec.address3 is not null then
      buffer := buffer || term_char || driver_rec.address3;
   end if;

    if driver_rec.po_box is not null then
      buffer := buffer || term_char || driver_rec.po_box;
   end if;

   if driver_rec.country_code = 'USA' then
      buffer := buffer || term_char;

      if driver_rec.town is not null then
	 buffer := buffer || driver_rec.town || ', ';
      end if;

      if driver_rec.postal_code is not null then
	 buffer := buffer || driver_rec.postal_code || ' ';
      end if;

      if driver_rec.zip_code is not null then
	 buffer := buffer || driver_rec.zip_code || ' ';
      elsif driver_rec.postal_code is not null then
	 buffer := buffer || driver_rec.postal_code || ' ';
      end if;

      if include_country = 'Y' then
	 if driver_rec.country_code is not null then
	    buffer := buffer || driver_rec.country_code;
	 end if;
      end if;

      return substr (buffer, length(term_char)+1);
   end if;

-- **********

   if include_country = 'Y' then
      if driver_rec.country_code is not null then
	 buffer := buffer || term_char || driver_rec.country_code || ' - ';
      end if;
   end if;

   if driver_rec.postal_code is not null then
      buffer := buffer || driver_rec.postal_code || ' ';
   end if;

   if driver_rec.town is not null then
      buffer := buffer || driver_rec.town || ' ';
   end if;

   if driver_rec.zip_code is not null then
      buffer := buffer || driver_rec.zip_code;
   end if;

   return substr (buffer, length(term_char)+1);

end get_address;

-- ***********************************************************************************************

function form_option (this_id integer, procedure_name varchar2, prompt varchar2) return varchar2 is

begin

   return (
	htf.formOpen (procedure_name, 'POST')	||
	ifnotnull (this_id, htf.formHidden ('this_id', this_id))	||
	htf.formSubmit (null, prompt)		||
	htf.formClose);

end form_option;

-- ***********************************************************************************************

function get_dot_image (code varchar2, flag varchar2) return varchar2 is

cursor	driver is
select	status_descr, image_URL, px_width, px_height
from	status_codes
where	status_code	= code
and	flag		= editor_dot$
UNION
select	referee_descr, image_URL, px_width, px_height
from	referee_codes
where	referee_code	= code
and	flag		= referee_dot$
UNION
select	transparency_descr, image_url, px_width, px_height
from	transparency_codes
where	transparency_code	= code
and	flag			= transp_dot$;

driver_rec	driver%ROWTYPE;
buffer		varchar2(200) := null;

begin

   if code is null then
      return null;
   end if;

   open driver;
   fetch driver into driver_rec;
   close driver;

   if driver_rec.px_width is not null then
      buffer := 'width="' || driver_rec.px_width || '"';
   end if;

   if driver_rec.px_height is not null then
      buffer := buffer || ' height="' || driver_rec.px_height || '"';
   end if;

   return htf.img (driver_rec.image_URL, calt=>driver_rec.status_descr || ' Dot', cattributes=>buffer);

end get_dot_image;

-- ***********************************************************************************************

procedure show_log_errors (this_log_id integer) is

cursor	driver is
select	*
from	log_errors
where	log_id = this_log_id;

first	boolean	:= true;

begin

   for driver_rec in driver loop
      if first then
	 htp.ulistOpen;
	 first	:= false;
      end if;

      htp.listItem (decode_value ('error_descr', 'error_codes',
					'error_code', driver_rec.error_code) );
   end loop;

   if NOT first then
      htp.ulistClose;
   end if;

end show_log_errors;

-- ***********************************************************************************************

procedure show_abstract_log (this_id integer, show_notes boolean, toggle_view boolean default false) is

cursor	driver is
select	log_date, person_id, log_id, log_code, status_code, referee_code,
	comments, editor_notes, null mail_id, null subject, transparency_code
from	logs
where	abstract_id = this_id
UNION
select	create_date log_date, null, null, null, null, null,
	null, null, mail_id, subject, null
from	mail_sent_blats
where	abstract_id = this_id
order by
	log_date desc, log_id desc;

Q$		constant char(1) := chr(39);
class_ID	integer := -1;
class_ID2	integer;
buffer		long;
dummy		ident_arr;
show_name	boolean;
show_referee	constant boolean := has_privs_to_page (editor_page$, false);

begin

   email.init_variables;
   dummy(1) := 'dummy';

   htp.p ('<TD>');

   if toggle_view then
      class_ID := class_ID + 2;
      htp.anchor ('#', 'Show Log',
		cattributes=>'ID="'	|| (class_ID+1)	||
			'" onclick="toggle_visibility(' ||
				Q$ || class_ID		|| Q$ || ',' ||
				Q$ || (class_ID+1)	|| Q$ || ');"');

      htp.p ('<DIV ID="' || class_ID || '">');
   end if;
   htp.ulistOpen;

   for driver_rec in driver loop
      buffer := null;

      if driver_rec.log_id is not null then
	 buffer := buffer || htf.bold (decode_value ('log_descr', 'log_codes',
					'log_code', driver_rec.log_code)) || ' ';
	 buffer := buffer ||	nvl (get_dot_image (driver_rec.status_code, editor_dot$),
				nvl (get_dot_image (driver_rec.referee_code, referee_dot$),
				     get_dot_image (driver_rec.transparency_code, transp_dot$) ) );
	 buffer := buffer || ' [';

	 show_name := true;
	 if driver_rec.log_code = 'REF' then
	    if NOT show_referee then
	       show_name := false;
	    end if;

	 end if;

	 if show_name then
	    buffer := buffer || get_user_name (driver_rec.person_id) || ' ';
	 end if;
	 buffer := buffer ||	'<span class=font-1>'			||
				local_time (driver_rec.log_date)	||
				'</span>]';

	 if driver_rec.comments is not null then
	    buffer := buffer || ' ' || htf.escape_sc (driver_rec.comments);
	 end if;

	 if driver_rec.editor_notes is not null then
	    if show_notes then
	       buffer := buffer || ' [' || htf.italic (htf.escape_sc (driver_rec.editor_notes)) || ']';
	    end if;
	 end if;

	 htp.listItem (buffer, cattributes=>'CLASS="BULLET"');
	 show_log_errors (driver_rec.log_id);

      else
	 buffer := buffer || htf.bold ('Email: ');
	 buffer := buffer ||	'<span class=font-1>'			|| ' [' ||
				local_time (driver_rec.log_date)	||
				'</span>] ';
	 buffer := buffer || htf.anchor ('javascript:newWindow (''email.read?mid=' ||
				driver_rec.mail_id || ''')',
				email.replace_variables (driver_rec.subject, dummy) );
	 htp.listItem (buffer, cattributes=>'CLASS="BULLET"');
      end if;

   end loop;

   htp.ulistClose;

   if toggle_view then
      htp.p ('</DIV>');
      class_ID := class_ID / 2;
      htp.p ('<SCRIPT LANGUAGE="JavaScript1.1" type="text/javascript">');
      htp.p ('<!-- Begin to hide script contents from old browsers.');

      for i in 1..class_ID LOOP
	 class_ID2 := ((i-1) * 2) + 1;
	 htp.p ('toggle_visibility(' ||
			Q$ || class_ID2	    || Q$ || ',' ||
			Q$ || (class_ID2+1) || Q$ || ');' );
      end loop;

      htp.p ('// End the hiding here. -->');
      htp.p ('</SCRIPT>');
   end if;

   htp.p ('</TD>');

end show_abstract_log;

-- ***********************************************************************************************

function local_time_stamp (this_date date) return date is

-- Convert the input time to the user's time zone

cursor	driver is
select	*
from	persons
where	person_id = nvl (gbl_priv_pid, gbl_pid);

driver_rec	driver%ROWTYPE;
rec_found	boolean;

tz_date		TIMESTAMP WITH TIME ZONE;
new_dte		date;

begin

   if this_date is null then
      return null;
   end if;

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if driver_rec.tz_name is null then
      select	dbtimezone
      into	driver_rec.tz_name
      from	dual;
   end if;

   tz_date	:= from_tz (cast (this_date as timestamp), 'GMT');
   tz_date	:= tz_date at time zone driver_rec.tz_name;
   new_dte	:= cast(tz_date as date);

   return new_dte;

end local_time_stamp;

-- ***********************************************************************************************

function local_time (this_date date) return varchar2 is

-- Convert the input time to the user's time zone

cursor	driver is
select	date_format_code, nvl (tz_name, 'UTC') tz_name
from	persons
where	person_id = nvl (gbl_priv_pid, gbl_pid);

rec		driver%ROWTYPE;
rec_found	boolean;
new_time	date;

begin

   if this_date is null then
      return null;
   end if;

   open driver;
   fetch driver into rec;
   rec_found := driver%FOUND;
   close driver;

   if rec_found then
      new_time := FROM_TZ (CAST (this_date AS TIMESTAMP), 'UTC') AT TIME ZONE rec.tz_name;
      return to_char (new_time, nvl(rec.date_format_code, common.date_fmt_str$)) || ' (' || rec.tz_name || ')';
   else
      return to_char (this_date, nvl(rec.date_format_code, common.date_fmt_str$)) || ' (UTC)';
   end if;

end local_time;

-- ***********************************************************************************

function get_alternate_paper_IDs (abs_id integer) return varchar2 is

cursor	driver is
select	a.paper_id
from	sessions		s,
	abstract_sessions	a
where	a.abstract_id		= abs_id
and	a.paper_id		is not null
and	s.session_id		= a.session_id
order by s.sort_order nulls last,
	 s.session_date,
	 s.beg_time,
	 s.end_time;

buffer	varchar2(4000)	:= null;
sepstr	varchar2(2)	:= null;

begin

   for rec in driver LOOP
      buffer := buffer || sepstr || rec.paper_id;
      sepstr := ', ';
   end loop;

   if buffer is not null then
      buffer := ' (' || buffer || ')';
   end if;

   return buffer;

end get_alternate_paper_IDs;

-- ***********************************************************************************

procedure show_abstract_session (abs_id integer, pc_descr varchar2, paper_id varchar2 default null) is

cursor	driver is
select	abs.*, pc.presentation_descr
from	sessions		s,
	presentation_codes	pc,
	abstract_sessions	abs
where	abs.abstract_id		= abs_id
and	abs.paper_id		like nvl (show_abstract_session.paper_id, '%')
and	pc.presentation_code	= abs.presentation_code
and	s.session_id		= abs.session_id
order by
	s.sort_order nulls last,
	s.session_date, s.beg_time, s.end_time,
	s.session_id;

type	rec_type is table of driver%ROWTYPE index by pls_integer;
recs	rec_type;

begin

   open driver;
   fetch driver BULK COLLECT into recs;
   close driver;

   if recs.COUNT = 0 then
      htp.tableOpen;
   else
      htp.tableOpen('BORDER');
   end if;

   for i in 1..recs.COUNT loop
      if i = 1 AND recs.COUNT > 1 then
         htp.p('<TD CLASS="highlight">');
      else
         htp.p('<TD>');
      end if;

      htp.tableOpen;
      show_data_row ('Paper ID',		recs(i).paper_ID);
      show_data_row ('Presentation Type',	recs(i).presentation_descr);
      show_data_row ('Program Session',		show_session_summary (recs(i).session_id));
      htp.tableClose;
      htp.p('</TD>');
   end loop;

   if recs.COUNT = 0 then
      show_data_row ('Presentation Type', pc_descr);
   end if;

   htp.tableClose;

end show_abstract_session;

-- ***********************************************************************************

procedure show_abstract_title (abs_id integer, paper_id varchar2 default null) is

cursor	driver is
select	a.title, pc.presentation_descr
from	presentation_codes	pc,
	abstracts		a
where	a.abstract_id		= abs_id
and	pc.presentation_code	= a.presentation_code;

driver_rec	driver%ROWTYPE;
rec_found	boolean;

begin

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if rec_found then
      htp.tableOpen;
      show_data_row ('Abstract:',
		htf.bold (nvl (nvl (paper_id, common.get_paper_ID (abs_id, 'N', 'Y')), abs_id)) || ' ' ||
				convert_text (driver_rec.title, html_fmt$));
      htp.tableClose;
      htp.para;

      show_abstract_session (abs_id, driver_rec.presentation_descr, paper_id);
   end if;

end show_abstract_title;

-- ***********************************************************************************

function show_session_summary (this_id varchar2) return varchar2 is

cursor	driver is
select	s.title, lc.capacity, lc.location_descr,
	to_char(s.session_date, 'mm/dd/yyyy')		session_date,
	substr ('0'||to_char (s.beg_time),
		  length(to_char(s.beg_time))-2 )	beg_time,
	substr ('0'||to_char (s.end_time),
		  length(to_char(s.end_time))-2 )	end_time
from	location_codes		lc,
	sessions		s
where	s.session_id		= this_id
and	lc.location_code	= s.location_code;

driver_rec	driver%ROWTYPE;
buffer		varchar2(100) := null;

begin

   if this_id is null then
      return ('Not Assigned');
   else
      open driver;
      fetch driver into driver_rec;
      close driver;

      if common.has_privs_to_page (common.jacow_admin$, false) then
         buffer := htf.br || 'Capacity: ' || driver_rec.capacity;
      end if;

      return (this_id || space2$ || '--' || space2$ || driver_rec.title || htf.br ||
		driver_rec.session_date || space2$ ||
		driver_rec.beg_time || ' -- ' || driver_rec.end_time ||
		htf.br || driver_rec.location_descr || buffer);
   end if;

end show_session_summary;

-- ***********************************************************************************

procedure close_form (field_name varchar2, onclick_code boolean default false) is

begin

   htp.para;

   if onclick_code then
      htp.formSubmit (cattributes=>'onClick="return checksubmit()"');
   else
      htp.formSubmit;
   end if;
   htp.formClose;

end close_form;

-- *********************************************************************************************************

function in_list (prev_affiliations ident_arr, text varchar2) return boolean is

begin

   for i in 1..prev_affiliations.count LOOP
      if prev_affiliations(i) = text then
	 return true;
      end if;
   end loop;

   return false;

end in_list;

-- *********************************************************************************************************

function get_user_affil_abbrev_list (pid integer, include_location varchar2 default 'N') return varchar2 is

cursor	driver is
select	distinct pro.sort_order, pro.current_address,
	common.get_affil_name (affil.affiliation_id, null, 'Y', 'Y') affil_abbrev,
	decode (addr.town, null,null, ' ' || addr.town) town,
	addr.country_code
from	affiliations		affil,
	addresses		addr,
	profiles		pro
where	pro.person_id		= PID
and	pro.deleted		is null
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
and	affil.affiliation_id	<> private_address$
order by
	current_address nulls last, 1, 2;

sep		varchar2(2)	:= null;
affil_list	varchar2(4000)	:= null;
country_descr	country_codes.country_descr%TYPE;

begin

   for driver_rec in driver LOOP
--	get only one affiliation
      exit when affil_list is not null and driver_rec.current_address is null;

      affil_list := affil_list || sep || driver_rec.affil_abbrev;

      if include_location = 'Y' then
	 affil_list	:= affil_list || driver_rec.town;
	 country_descr	:= common.decode_value ('country_descr', 'country_codes',
				'country_code', driver_rec.country_code);
	 if country_descr is not null then
	    affil_list	:= affil_list || ' ' || driver_rec.town;
	 end if;
      end if;

      sep	 := ', ';
   end loop;

   return affil_list;

end get_user_affil_abbrev_list;

-- *********************************************************************************************************

function get_affil_abbrev_list (abs_id integer, pid integer) return varchar2 is

cursor	driver is
select	/*+ INDEX (affil) INDEX (addr) */
	distinct
	auth.sort_order,
	common.get_affil_name (affil.affiliation_id, null, 'Y', 'Y') affiliation,
	addr.town
from	affiliations		affil,
	addresses		addr,
	profiles		pro,
	authors			auth
where	auth.abstract_id	= abs_id
and	pro.profile_id		= auth.profile_id
and	pro.person_id		= pid
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
order by
	auth.sort_order nulls last, 2, addr.town;

buffer			varchar2(1000) := null;
prev_affiliations	ident_arr;

begin

   for driver_rec in driver LOOP
      if NOT in_list (prev_affiliations, driver_rec.affiliation || ';' || driver_rec.town) then
	 buffer := buffer || '; ' || driver_rec.affiliation;
	 buffer := buffer ||  ', ' || driver_rec.town;
      end if;

      prev_affiliations(prev_affiliations.count+1) := driver_rec.affiliation || ';' || driver_rec.town;
   end loop;

   return substr (buffer, 3);

end get_affil_abbrev_list;

-- *********************************************************************************************************

function get_affil_name_list (pid integer) return varchar2 is

cursor	driver is
select	DISTINCT
	common.get_affil_name (affiliation_id, null, 'N') name1
from	affiliations		affil
where	affiliation_id		in
(
	select	/*+ INDEX (addr) */
		affiliation_id
	from	addresses		addr,
		profiles		pro
	where	pro.person_id		= pid
	and	pro.deleted		is null
	and	addr.address_id		= pro.address_id
)
and	affiliation_id		<> private_address$
order by 1;

buffer			varchar2(1000) := null;
prev_affiliations	ident_arr;

begin

   for driver_rec in driver LOOP
      buffer := buffer || ', ' || driver_rec.name1;
   end loop;

   return substr (buffer, 3);

end get_affil_name_list;

-- *********************************************************************************************************

function get_author_list2 (abs_id integer, include_primary boolean default true,
			include_affils boolean default true, initials_only varchar2 default 'N')
			return varchar2 is

cursor	primary is
select	get_affil_by_abs_person (abs_id, person_id) affiliation, person_id,
	aa.iname || ' ' || aa.lname il_name, aa.full_name, aa.on_leave
from	abstract_authors aa
where	abstract_id	= abs_id
and	ctype_order	= 20;

cursor	coauthors (this_affiliation varchar2, this_person_id integer) is
select	get_affil_by_abs_person (abs_id, person_id) affiliation, person_id,
	aa.iname || ' ' || aa.lname il_name, aa.full_name, aa.on_leave
from	abstract_authors aa
where	abstract_id	= abs_id
and	ctype_order	= 30
and	person_id	<> this_person_id -- no need for the primary if also a co-author
order by
	decode (pc_mode$, 'Y', sort_order, 0),
	decode (get_affil_by_abs_person (abs_id, person_id), this_affiliation, 1, 9),
	1, sort_lname, sort_fname, sort_mname;

buffer		long default null;
prev_affil	long;
prev_name	abstract_authors.full_name%TYPE := '~';
driver_rec	primary%ROWTYPE;

type rec_type is table of coauthors%ROWTYPE index by binary_integer;
recs rec_type;

begin

-- Get the primary author
   open primary;
   fetch primary into driver_rec;
   close primary;

-- Needed the primary author's affiliation for the sorting
   open coauthors (driver_rec.affiliation, driver_rec.person_id);
   fetch coauthors BULK COLLECT into recs;
   close coauthors;

   if include_primary then
      prev_affil := driver_rec.affiliation;
      for i in reverse 1..recs.COUNT loop
	 recs(i+1) := recs(i);
      end loop;
      recs(1) := driver_rec;
   else
      if recs.COUNT = 0 then
	 return null;
      end if;
      prev_affil := recs(1).affiliation;
   end if;

   for i in 1..recs.COUNT loop
      if initials_only = 'Y' then
	 recs(i).full_name := recs(i).il_name;
      end if;

      if include_affils then
	 if prev_affil <> recs(i).affiliation then
	    buffer := buffer || ' (' || prev_affil || ')';
	 end if;
      end if;

      if prev_name <> recs(i).full_name then
	 buffer := buffer || ', ' || recs(i).full_name;
	 if recs(i).on_leave = 'Y' then
	    buffer := buffer || ' [on leave]';
	 end if;
      end if;

      prev_affil := recs(i).affiliation;
      prev_name := recs(i).full_name;
   end loop;

   if include_affils then
      buffer := buffer || ' (' || prev_affil || ') ';
   end if;

   return substr (buffer, 3);

end get_author_list2;


-- *********************************************************************************************************

function get_author_paper_ids (pid integer) return varchar2 is

cursor	driver is
select	distinct
	s.sort_order, a.paper_id
from	sessions		s,
	abstract_sessions	a,
	authors			auth,
	profiles		pro
where	pro.person_id		= pid
and	auth.profile_id		= pro.profile_id
and	a.abstract_id		= auth.abstract_id
and	s.session_id		= a.session_id;

buffer	long;

begin

   for driver_rec in driver LOOP
      buffer := buffer || ', ' || driver_rec.paper_id;
   end loop;

   return (substr (buffer, 3));

end get_author_paper_ids;

-- ***********************************************************************************************

function get_cookie (cookie_name varchar2) return varchar2 is

v_cookie	owa_cookie.cookie;

begin

   v_cookie := owa_cookie.get (cookie_name);

   if v_cookie.num_vals > 0 then
      return decrypt (v_cookie.vals(1));
   end if;

   return null;

end get_cookie;

-- ***********************************************************************************************

procedure write_cookie (cookie_name varchar2, cookie_string varchar2, expire_date date default null) is

begin

   owa_util.mime_header('text/html', FALSE);
   owa_cookie.remove (cookie_name, '');

   if cookie_string is not null then
      owa_cookie.send (cookie_name, encrypt (cookie_string), expire_date);
   end if;

   owa_util.http_header_close;

end write_cookie;

-- ***********************************************************************************************

procedure write_cookies (cookie_name ident_arr, cookie_string ident_arr, expire_date date default null) is

begin

   owa_util.mime_header('text/html', FALSE);

   for i in 1..cookie_name.COUNT LOOP
      owa_cookie.remove (cookie_name(i), '');
      owa_cookie.send (cookie_name(i), encrypt (cookie_string(i)), expire_date);
   end loop;

   owa_util.http_header_close;

end write_cookies;

-- ***********************************************************************************************

function copyright_url (this_id integer) return varchar2 is

begin

    return 	server || vdir$	||
		'JACoW.copyright?this_id='	||
		to_char (this_id);

end copyright_url;

-- ****************************************************************************************************

function dad$ return varchar2 is

begin

   return upper (owa_util.get_cgi_env ('DAD_NAME'));

end dad$;

-- ****************************************************************************************************

function get_presentation_type (code varchar2) return varchar2 is

begin

   return decode_value ('presentation_type_code', 'presentation_codes', 'presentation_code', code);

end get_presentation_type;

-- ****************************************************************************************************

function get_presentation_type2 (code varchar2) return varchar2 is

begin

   return decode_value ('presentation_type_code', 'presentation_option_codes', 'presentation_option_code', code);

end get_presentation_type2;

-- ****************************************************************************************************

function get_presentation_type (abs_id integer) return varchar2 is

code	presentation_codes.presentation_code%type;

begin

   code := decode_value ('presentation_code', 'abstracts', 'abstract_id', abs_id);
   return get_presentation_type (code);

end get_presentation_type;

-- ****************************************************************************************************

function get_presentation_option (abs_id integer) return varchar2 is

code	presentation_codes.presentation_code%type;

begin

   code := decode_value ('presentation_code', 'abstracts', 'abstract_id', abs_id);
   return code;

-- return decode_value ('presentation_option_code', 'presentation_codes', 'presentation_code', code);

end get_presentation_option;

-- ****************************************************************************************************

function get_profile_affil (prof_id integer, abbrev_only varchar2 default 'N', include_abbrev varchar2 default 'Y') return varchar2 is

cursor	driver is
select	get_affil_name (addr.affiliation_id, ' ', include_abbrev, abbrev_only) affiliation
from	addresses		addr,
	profiles		pro
where	pro.profile_id		= prof_id
and	addr.address_id		= pro.address_id;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   return driver_rec.affiliation;

end get_profile_affil;

-- ****************************************************************************************************

function convert_text (this_text varchar2, fmt varchar2 default 'H') return varchar2 is

-- cursor	driver is
-- select	*
-- from	byte_codes;

-- buffer	long;

begin

   return this_text;
/*
   buffer := this_text;
   for driver_rec in driver LOOP

      if fmt = html_fmt$ then

	 if driver_rec.gif_file is null then
	    buffer := replace (buffer, driver_rec.user_code, driver_rec.html_code);
	 else
	    buffer := replace (buffer, driver_rec.user_code,
				htf.img (graphics_folder$ || upper(driver_rec.gif_file)) );
	 end if;

      elsif fmt = byte_fmt$ then
	 buffer := replace (buffer, driver_rec.user_code, chr(driver_rec.byte_code));

      elsif fmt = decimal_fmt$ then
	 buffer := replace (buffer, driver_rec.user_code,
				'&#' || trim (to_char(driver_rec.byte_code)) || ';' );

      elsif fmt = spires_fmt$ then
	 buffer := replace (buffer, driver_rec.user_code, driver_rec.spires_code);

      end if;
   end loop;

   if fmt = decimal_fmt$ then
      buffer := replace (buffer, '<sub>', '&lt;sub&gt;');
      buffer := replace (buffer, '</sub>', '&lt;/sub&gt;');
      buffer := replace (buffer, '<sup>', '&lt;sup&gt;');
      buffer := replace (buffer, '</sup>', '&lt;/sup&gt;');

   elsif fmt = html_fmt$ then
      buffer := htf.escape_sc (buffer);

   end if;

   return buffer;

exception
   when others then return ('"'||buffer||'"');
*/
end convert_text;

-- ****************************************************************************************************

function get_UTC_time return date is

now	date;

begin

   select sys_extract_utc(systimestamp) into now from dual;
   return now;

end get_UTC_time;

-- ************************************************************************************

function exempt_path return boolean is

path	varchar2(100);

begin

   path := lower (owa_util.get_cgi_env ('PATH_INFO'));
   if path like '/affil_reqs.%' or path like '/repository.%' then
      return true;
   end if;

   return false;

exception
   when others then
      return false;

end exempt_path;

-- ************************************************************************************

function new_request_pending (affil_id integer) return boolean is

cursor	driver is
select	1
from	affil_requests
where	address_id in
(	select	address_id
	from	addresses
	where	affiliation_id = affil_id);

dummy		integer;
rec_found	boolean;

begin

   if exempt_path then
      return false;
   end if;

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end new_request_pending;

-- ************************************************************************************

function get_affil_name (affil_id integer, sep_str varchar2 default ' ',
			incl_abbrev varchar2 default 'Y',
			abbrev_only varchar2 default 'N') return varchar2 is

cursor	driver is
select	name1, name2, department, affil_abbrev
from	affiliations
where	affiliation_id = affil_id;

driver_rec	driver%ROWTYPE;
buffer		long := null;

begin

   if affil_id > 0 then
      if new_request_pending (affil_id) then
	 return get_affil_name (new_affil_pending$, sep_str, 'N', 'N');
      end if;
   end if;

   open driver;
   fetch driver into driver_rec;
   close driver;

   if abbrev_only = 'Y' then
      return nvl (driver_rec.affil_abbrev, driver_rec.name1);
   end if;

   buffer := driver_rec.name1;

   if incl_abbrev = 'Y' then
      if driver_rec.affil_abbrev is not null then
	 buffer := buffer || ' (' || driver_rec.affil_abbrev || ')';
      end if;
   end if;

   if driver_rec.name2 is not null then
      buffer := buffer || sep_str || driver_rec.name2;
   end if;

   if driver_rec.department is not null then
      buffer := buffer || sep_str || driver_rec.department;
   end if;

   return buffer;

end get_affil_name;

-- ****************************************************************************************************

function  get_log_date (abs_id integer, code varchar2) return varchar2 is

cursor	driver is
select	max (log_date)	log_date
from	logs
where	abstract_id	= abs_id
and	log_code	= code;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   return local_time (driver_rec.log_date);

end get_log_date;

-- ****************************************************************************************************

function get_user_name_affiliation (pro_id integer, abbrev_only varchar2 default 'N') return varchar2 is

cursor	driver is
select	get_user_name (p.person_id)		name,
	get_affil_name (addr.affiliation_id, ' ', null, abbrev_only)	affiliation
from	addresses		addr,
	persons			p,
	profiles		pro
where	pro.profile_id		= pro_id
and	p.person_id		= pro.person_id
and	addr.address_id		= pro.address_id;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   return driver_rec.name || ' - ' || driver_rec.affiliation;

end get_user_name_affiliation;

-- ***********************************************************************************************

function invitee return boolean is

invitee	constant persons.invitee%TYPE := decode_value ('invitee', 'persons', 'person_id', gbl_pid);

begin

   if invitee = 'Y' then
      return true;
   end if;

   return false;

end invitee;

-- ***********************************************************************************************

function accept_abstracts return boolean is

begin

   if user_is_JACoW_admin then
      return true;
   end if;

   if invitation_only$ = 'Y' then

      if invitee then
	 if accept_abstracts$ = 'Y' then
	    return true;
	 end if;
      end if;

   elsif accept_abstracts$ = 'Y' then
      return true;

   end if;

-- Check for PC mode and if user is a PC member

   if PC_mode$ = 'Y' then
      if common.has_privs_to_page (common.propose_invited$, false) then
	 return true;
      end if;
   end if;

   return false;

end accept_abstracts;

-- ****************************************************************************************************

function referee_declined (status varchar2) return boolean is

declined	referee_codes.declined%TYPE;

begin

   if status is null then
      return false;
   end if;

   if referee_conf$ = 'Y' then
      declined := decode_value ('declined', 'referee_codes', 'referee_code', status);
      if declined = 'Y' then
	 return true;
      end if;

   end if;

   return false;

end referee_declined;

-- ****************************************************************************************************

function referee_revisions (status varchar2) return boolean is

revisions	referee_codes.revisions%TYPE;

begin

   if status is null then
      return false;
   end if;

   if referee_conf$ = 'Y' then
      revisions := decode_value ('revisions', 'referee_codes', 'referee_code', status);
      if revisions = 'Y' then
	 return true;
      end if;

   end if;

   return false;

end referee_revisions;

-- ****************************************************************************************************

function referee_accepted (status varchar2) return boolean is

begin

   if status is null then
      return false;
   end if;

   if referee_conf$ = 'Y' then
      if referee_declined (status) then
	 return false;
      elsif referee_revisions (status) then
	 return false;
      end if;
   end if;

   return true;

end referee_accepted;

-- ****************************************************************************************************

function paper_id_assigned (abs_id integer) return boolean is

cursor	driver is
select	1
from	abstract_sessions
where	abstract_id = abs_id;

rec_found	boolean;
dummy		integer;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end paper_id_assigned;

-- ****************************************************************************************************

function OK_to_upload_files (abs_id integer) return boolean is

cursor	driver is
select	status_code, editor_id, referee_code
from	abstracts
where	abstract_id = abs_id;

cursor	C2 (eStatus varchar2, rStatus varchar2) is
select	uploadable
from	upload_status_codes
where	editor_status_code	= eStatus
and	referee_status_code	= rStatus;

driver_rec	driver%ROWTYPE;
C2_rec		C2%ROWTYPE;

editor_status	char(1);
referee_status	char(1);

begin

-- Is there an upload script?

   if author_upload_script$ is null then
      return false;
   end if;

   open driver;
   fetch driver into driver_rec;
   close driver;

-- Paper ID assigned?

   if NOT paper_id_assigned (abs_id) then
      return false;
   end if;

-- Is the user an editor (or administrator)?

   if has_privs_to_page (editor_page$, no_err_msg$) then
      return true;
   end if;

-- Does the user have a special override privilege?

   if invitation_only$ = 'N' AND invitee then
      return true;
   end if;

-- Are file uploads enabled?

   if accept_file_uploads$ = 'N' then
      return false;
   end if;

-- ********** End of system and special privileges

-- ********** Check the editor and referee status

   if driver_rec.editor_id is null then
      editor_status := unassigned$;
   elsif driver_rec.status_code is null then
      editor_status := assigned$;
   elsif uploadable_dot_status (driver_rec.status_code) then
      editor_status := uploadable$;
   else
      editor_status := not_uploadable$;
   end if;

   if referee_conf$ = 'N' then
      if editor_status in (not_uploadable$, assigned$) then
	 return false;
      end if;
      return true;
   end if;

--  This is a refereed conference.  We must now check the referee status
--  and cross check it with the editor status.

   if referee.assigned (abs_id) = 'N' then
      referee_status := unassigned$;
   elsif driver_rec.referee_code is null then
      referee_status := assigned$;
   elsif referee_declined (driver_rec.referee_code) then
      referee_status := declined$;
   elsif uploadable_dot_status (driver_rec.referee_code) then
      referee_status := uploadable$;
   else
      referee_status := not_uploadable$;
   end if;

   open C2 (editor_status, referee_status);
   fetch C2 into C2_rec;
   close C2;

   if C2_rec.uploadable = 'Y' then
      return true;
   end if;

   return false;

end OK_to_upload_files;

-- ****************************************************************************************************

function uploadable_file_type (code varchar2) return boolean is

cursor	driver is
select	1
from	pfile_type_codes
where	presentation_code	= code
and	always_available	= 'Y';

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end uploadable_file_type;

-- ****************************************************************************************************

function transp_uploadable (abs_id integer) return boolean is

cursor	driver is
select	status_code, editor_id, referee_code, presentation_code
from	abstracts
where	abstract_id = abs_id;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   if NOT paper_id_assigned (abs_id) then
      return false;
   end if;

   if referee_conf$ = 'Y' then
      if referee_declined (driver_rec.referee_code) then
	 return false;
      end if;
   end if;

   if common.poster_transparencies$ = 'Y' then
      return true;
   end if;

   if get_presentation_type (abs_id) = oral$ then
      if uploadable_file_type (driver_rec.presentation_code) then
	 return true;
      end if;
   end if;

   return false;

end transp_uploadable;

-- ****************************************************************************************************
-- ****************************************************************************************************

function OK_to_edit_abstract (abs_id integer, for_title_change boolean default false)
				return boolean is

cursor	driver is
select	status_code, editor_id
from	abstracts
where	abstract_id		= abs_id
and	person_id		= gbl_pid
UNION
select	status_code, editor_id
from	authors			auth,
	abstracts		abs
where	auth.abstract_id	= abs_id
and	auth.author_code	= common.primary_author$
and	auth.profile_id		in (select profile_id from profiles where person_id = gbl_pid)
and	abs.abstract_id		= auth.abstract_id;

cursor	c2 is
select	log_date
from	logs
where	abstract_id	= abs_id
and	log_code	= 'AC';

driver_rec		driver%ROWTYPE;
rec_found		boolean;
abstract_created	date;
edit_OK_flag		status_codes.OK_to_edit%TYPE;

begin

   if user_is_JACoW_admin OR has_privs_to_page (editor_page$, no_err_msg$) OR
	has_privs_to_page (sort_file_page$, no_err_msg$) then
      return true;
   end if;

   if abs_id is null then -- New Abstract
      if accept_abstracts then
	 return true;
      elsif invitation_only$ = 'N' AND invitee then
	 return true;
      elsif PC_mode$ = 'Y' then
	 if common.has_privs_to_page (common.propose_invited$, false) then
	    return true;
	 end if;
      else
	 return false;
      end if;
   end if;

-- **********

   if PC_mode$ = 'Y' AND PC_edit$ = 'Y' then
      if abs_id is null then
	 return false;
      end if;

      if prog_cmtte.is_coordinator (abs_id) then
	 return true;
      end if;
   end if;

-- **********

-- Abstract being edited

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if NOT rec_found then
      return false;
   end if;

   if invitation_only$ = 'N' AND invitee then
      return true;
   end if;

-- **********

   if freeze_abs_updates$ = 'Y' then
      open c2;
      fetch c2 into abstract_created;
      close c2;

      if sysdate - abstract_created <= 1/12 then
	 return true;
      end if;

      if for_title_change then
	 return true;
      end if;

      return false;
   end if;

-- **********

   if driver_rec.editor_id is null then -- not assigned to an editor yet
      return true;
   end if;

   edit_OK_flag := common.decode_value ('OK_to_edit', 'status_codes',
					'status_code', driver_rec.status_code);
   if edit_OK_flag = 'Y' then
      return true;
   end if;

   return false;

end OK_to_edit_abstract;

-- ****************************************************************************************************

function favorite_author (this_profile_id integer) return boolean is

-- Determine if the profile is already in the favorite author's list.

cursor	driver is
select	1
from	favorite_authors
where	profile_id	= this_profile_id
and	person_id	= nvl (gbl_priv_pid, gbl_pid);

rec_found	boolean;
dummy		integer;

begin

   if gbl_pid = decode_value ('person_id', 'profiles', 'profile_id', this_profile_id) then
      return true;
   end if;

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end favorite_author;

-- ****************************************************************************************************

function get_abs_platform (abs_id integer) return varchar2 is

-- Extract the platform on the paper.  Use the source file's platform before the postscript's.

cursor	driver is
select	/*+ INDEX(f) */ platform_code
from	files		f
where	abstract_id	= abs_id
and	file_type_code	in ('SRC', 'PS', 'PDF', 'PDFS')
order by
	file_type_code	desc;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   return driver_rec.platform_code;

end get_abs_platform;

-- ********************************************************************************************

function get_user_affil_list (pid integer, sep_char varchar2 default htf.br) return varchar2 is

cursor	driver is
select	affiliation_id,
	get_affil_name (affiliation_id) affil_name
from	addresses	addr,
	profiles	pro
where	pro.person_id	= pid
and	pro.deleted	is null
and	addr.address_id	= pro.address_id
order by
	pro.sort_order	nulls last, 2;

buffer	long := null;

begin

   for driver_rec in driver LOOP
      buffer := buffer || sep_char || driver_rec.affil_name;
   end loop;

   return substr (buffer, length(sep_char)+1);

end get_user_affil_list;

-- ********************************************************************************************

function get_user_email (pid integer, as_links boolean default false) return varchar2 is

cursor	driver is
select	distinct email_address
from	profiles
where	person_id	= pid
and	deleted		is null
and	email_address	is not null;

buffer	long := null;

begin

   for driver_rec in driver LOOP
      buffer := buffer || ',';
      if as_links then
	 buffer := buffer || htf.mailto (driver_rec.email_address, driver_rec.email_address);
      else
	 buffer := buffer || driver_rec.email_address;
      end if;
   end loop;

   return substr (buffer, 2);

end get_user_email ;

-- ********************************************************************************************

function user_is_JACoW_admin return boolean is

begin

   return has_privs_to_page (jacow_admin$, false);

end user_is_JACoW_admin;

-- ********************************************************************************************

function sort_text (buffer varchar2) return varchar2 is

begin

   if buffer is null then
      return null;
   end if;

   return nlssort (convert_text (upper(buffer), byte_fmt$), 'NLS_SORT = Latin');

end sort_text;

-- ***************************************************************************************************************

function pad_string (key_string varchar2) return varchar2 is

-- length of input string must be a multiple of 16

new_string	varchar  (32752) := key_string;
mod_len		constant integer := mod (length (key_string), 16);

begin

   if mod_len = 0 then
      return key_string;
   end if;

   return key_string || rpad (' ', 16-mod_len, ' ');

end pad_string;

-- ***************************************************************************************************************

function encrypt (input_string varchar2) return varchar2 is

raw_input	    RAW (32752);
raw_key 	    RAW (128);

begin

   if input_string is null then
      return null;
   end if;

   raw_input	:= UTL_RAW.CAST_TO_RAW (pad_string (input_string));
   raw_key	:= UTL_RAW.CAST_TO_RAW (crypto_string$);

   return rawtohex (dbms_obfuscation_toolkit.DESEncrypt (INPUT=>raw_input, KEY=>raw_key) );

end encrypt;

-- ***************************************************************************************************************

function decrypt (input_string varchar2) return varchar2 is

raw_input	    RAW (32752);
raw_key 	    RAW (128);

begin

   if input_string is null then
      return null;
   end if;

   raw_input	:= hextoraw (input_string);
   raw_key	:= UTL_RAW.CAST_TO_RAW (crypto_string$);

   return trim (UTL_RAW.CAST_TO_VARCHAR2 (
		dbms_obfuscation_toolkit.DESDecrypt (INPUT=>raw_input, KEY=>raw_key) ));

end decrypt;

-- ***************************************************************************************************************

procedure delete_cookies is

begin

   owa_util.mime_header('text/html', FALSE);
   owa_cookie.remove (cookie_name$, '');
   owa_cookie.remove (cookie_priv$, '');
   owa_util.http_header_close;

end delete_cookies;

-- ***************************************************************************************************************

procedure logout is

begin

   delete_cookies;
   gbl_pid	:= null;
   gbl_priv_pid	:= null;

   public_header ('');
   htp.header (3, 'You are now logged out of the ' || conf_title$);

   htp.formOpen ('profile.html');
   htp.formSubmit (null, 'Login');
   htp.formClose;

   htp.para;
   footer;

end logout;

-- ***********************************************************************************

procedure form_focus (form_name varchar2, field_name varchar2) is

-- Java script to place the browswer's cursor in a specified field.

begin

   htp.p ('<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript1.1">');
   htp.p ('<!-- Begin to hide script contents from old browsers.');
   htp.p ('document.' || form_name || '.' || field_name || '.focus()');
   htp.p ('// End the hiding here. -->');
   htp.p ('</SCRIPT>');

end form_focus;

-- ***************************************************************************************************************

function valid_pid (pid varchar2) return boolean is

cursor	driver is
select	1
from	persons
where	person_id = decrypt (pid);

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end valid_pid;

-- **********************************************************************************************

function get_user_PID (uid varchar2) return integer is

cursor	driver is
select	person_id
from	persons
where	user_id = upper (uid);

pid	integer;

begin

   open driver;
   fetch driver into pid;
   close driver;

   return pid;

end get_user_PID;

-- **********************************************************************************************

function valid_referer (URL varchar2) return boolean is

cursor	driver (node$ varchar2) is
select	1
from	valid_referers
where	URL_NODE_NAME = node$;

server	valid_referers.URL_node_name%TYPE := get_server_name;
node	valid_referers.URL_node_name%TYPE := lower (URL);

rec_found	boolean;
dummy		integer;

begin

   node := substr (node, instr (node, '://') + 3);
   node := substr (node, 1, instr (node, '/') - 1);
   if server = node then -- referering page is from the same site.
      return true;
   end if;

   open driver (node);
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   if rec_found then
      return true;
   end if;

   htp.header (3, 'Please send the next two lines of text to the confernece administrator.');
   htp.bold ('Referer=' || URL);
   htp.br;
   htp.bold ('Server=' || server);
   return false;

end valid_referer;

-- **********************************************************************************************

function repo_is_remote return boolean is

begin

   if standalone_DB$ = 'Y' then
      return false;
   end if;

   if repo_db$ is null then
      return true;
   end if;

   return false;

end repo_is_remote;

-- ******************************************************************************************

procedure load_bytes (bytes in out ident_arr,  begchr integer,	endchr integer) is

begin

   for i in begchr..endchr LOOP
      bytes(bytes.count+1) := chr (i);
   end loop;

end load_bytes;

-- ******************************************************************************************

function fmt_search_string (buffer varchar2, operator varchar2 default ' OR ') return varchar2 is

-- Make the user's search string "OR" multiple words rather than the default.

cursor	driver is
select	' ' || trim (upper (word)) || ' '	word
from	CTX_reserved_words;

new_buffer	varchar2(4000) := ' ' || trim (upper (buffer)) || ' ';
bytes		ident_arr;
words		common.ident_arr;

begin

   open driver;
   fetch driver BULK COLLECT into words;
   close driver;

   for i in 1..words.COUNT loop
      new_buffer := replace (new_buffer, words(i), ' ');
   end loop;

   load_bytes (bytes,  33,  47);
   load_bytes (bytes,  58,  64);
   load_bytes (bytes,  91,  96);
   load_bytes (bytes, 123, 137);

   for i in 1..bytes.count LOOP
      new_buffer := replace (new_buffer, bytes(i), ' ');
   end loop;

   loop
      exit when instr (new_buffer, '  ') = 0;
      new_buffer := replace (new_buffer, '  ', ' ');
   end loop;

   new_buffer := trim (new_buffer);
   new_buffer := replace (new_buffer, ' ', operator); -- place the operator (OR | NEAR) between every word

   return nvl (new_buffer, 'aaaaaa');  -- "contains" search fails on null strings

end fmt_search_string;

-- **********************************************************************************************

function get_paper_seq_len (code varchar2, via varchar2 default 'presentation_codes') return integer is

presentation_type_code	presentation_type_codes.presentation_type_code%TYPE;

begin

   if via = 'presentation_codes' then
      presentation_type_code := get_presentation_type (code);
   else
      presentation_type_code := get_presentation_type2 (code);
   end if;

   if presentation_type_code = oral$ then
      return paper_id_oral_len$;
   end if;

   return paper_id_poster_len$;

end get_paper_seq_len;

-- **********************************************************************************************

function fmt_session_seq (seq integer, code varchar2) return varchar2 is

iseq	constant integer := to_number (seq);
fmt_str	varchar2(10);

begin

   fmt_str := 'FM' || rpad ('0', get_paper_seq_len (code), '0');
   return to_char (iseq, fmt_str);

end fmt_session_seq;

-- **********************************************************************************************

function final_QA (abs_id integer) return varchar2 is

cursor	driver is
select	/*+ INDEX(l) */
	log_code
from	logs		l
where	abstract_id	= abs_id
and	log_code	in (final_QA_passed$, final_QA_failed$)
order by
	log_date desc;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   if driver_rec.log_code = final_QA_failed$ then
      return 'Failed';

   elsif driver_rec.log_code = final_QA_passed$ then
      return 'Passed';

   end if;

   if NOT publishable_status_code (common.decode_value ('status_code', 'abstracts', 'abstract_id', abs_id) ) then
      return 'Not Publishable';
   end if;

   if common.referee_conf$ = 'Y' then
      if NOT publishable_referee_code (common.decode_value ('referee_code', 'abstracts', 'abstract_id', abs_id) ) then
	 return 'Not Publishable';
      end if;
   end if;

   return 'Pending';

end final_QA;

-- **********************************************************************************************

function fmt_OK_to_publish (msg varchar2) return varchar2 is

begin

   if msg is null then
      return 'Yes';
   end if;

   return 'No' || msg;

end fmt_OK_to_publish;

-- **********************************************************************************************

function paper_OK_to_publish (abs_id integer) return varchar2 is

cursor	C1 is
select	*
from	abstracts
where	abstract_id	= abs_id;

cursor	C2 is
select	*
from	poster_logs
where	abstract_id	= abs_id;

cursor	C3 is
select	/*+ INDEX(a) */
	a.abstract_id, c.log_descr
from	logs			a,
	log_codes		c
where	c.publish		= 'Y'
and	a.log_code(+)		= c.log_code
and	a.abstract_id(+)	= abs_id;

cursor	C4 is
select	/*+ INDEX(l) */	1
from	logs			l
where	abstract_id		= abs_id
and	log_code		= copyright_received$;

c1_rec		C1%ROWTYPE;
c2_rec		C2%ROWTYPE;
rec_found	boolean;
dummy		integer;
final_QA_text	varchar2(20);
msg		varchar2(1000) := null;

begin

   open c1;
   fetch c1 into c1_rec;
   close c1;

-- **********

   if NOT paper_id_assigned (abs_id) then
      msg := msg || ', Missing Paper ID';
   end if;

-- **********

   if NOT publishable_status_code (c1_rec.status_code) then
      msg := msg || ', Editor Status Code is not Publishable';
   end if;

   if NOT publishable_referee_code (c1_rec.referee_code) then
      msg := msg || ', Referee Status Code is not Publishable';
   end if;

-- **********

   final_QA_text := final_QA (abs_id);
   if final_QA_text <> 'Passed' then
      msg := msg || ', Final QA ' || final_QA_text;
   end if;

-- ********** Check log codes required for publishing

   for C3_rec in C3 LOOP
      if C3_rec.abstract_id is null then
	 msg := msg || ', Missing ' || C3_rec.log_descr;
      end if;
   end loop;

-- **********

   if copyright_required$ = 'Y' then
      open C4;
      fetch C4 into dummy;
      rec_found := C4%FOUND;
      close C4;

      if NOT rec_found then
	 msg := msg || ', Missing Copyright Form';
      end if;
   end if;

-- ********** Poster Police

   if use_poster_police$ = 'N' then
      return fmt_OK_to_publish (msg);
   end if;

   if get_presentation_type (c1_rec.presentation_code) = oral$ then
      return fmt_OK_to_publish (msg);  -- Does not apply to orals
   end if;

   open c2;
   fetch c2 into c2_rec;
   rec_found := C2%FOUND;
   close c2;

   if NOT rec_found then
      msg := msg || ', Missing Poster Police';
   end if;

   if c2_rec.manned = 'N' or c2_rec.posted = 'N' or c2_rec.satisfactory = 'N' then
      msg := msg || ', Poster Police Failed';
   end if;

-- **********

   return fmt_OK_to_publish (msg);

end paper_OK_to_publish;

-- **********************************************************************************************

function file_type_uploaded (abs_id integer, file_type varchar2) return varchar2 is

cursor	driver is
select	1
from	files
where	abstract_id	= abs_id
and	file_type_code	= file_type;

rec_found	boolean;
dummy		integer;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   if rec_found then
      return 'Yes';
   end if;

   return 'No';

end file_type_uploaded;

-- **********************************************************************************************

function build_IN_list (list ident_arr, this_var varchar2) return varchar2 is

buffer		varchar2(4000)	:= null;
comma		varchar2(1)	:= null;
quote		varchar2(1)	:= quote$;
all_numbers	boolean		:= true;

begin

   for i in 1..list.count LOOP
      exit when NOT all_numbers;
      if NOT validate_number (list(i)) then
	 all_numbers := false;
      end if;
   end loop;

   if all_numbers then
      quote := null;
   end if;

   for i in 1..list.count LOOP
      if list(i) is not null then
	 buffer := buffer || comma || quote || list(i) || quote;
	 comma	:= ',';
      end if;
   end loop;

   if buffer is not null then
      return ' ' || this_var || ' in (' || buffer || ') ';
   end if;

   return null;

end build_IN_list;

-- ********************************************************************************************

function build_in_list (oper varchar2, list ident_arr, varname varchar2) return varchar2 is

buffer	varchar2(500) := build_in_list (list, varname);

begin

   if buffer is null then
      return null;
   end if;

   return oper || buffer;

end build_in_list;

-- ********************************************************************************************

function valid_time (itime integer) return boolean is

cdate	varchar2(30);
ddate	date;

begin

   cdate := to_char (sysdate, 'mmddyyyy') || ' ' || to_char (itime, 'FM0000');
   ddate := to_date (cdate, 'mmddyyyy hh24mi');

   return true;

   exception
      when value_error then return (false);
      when others      then return (false);

end valid_time;

-- ****************************************************************************************

function vdir$ return varchar2 is

begin

   if owa_util.get_cgi_env ('SCRIPT_NAME') || '/' like vdir_debug$ then
      return vdir_debug$;
   end if;

   return vdir_dflt$;

end vdir$;

-- ********************************************************************************************

function get_next_token (rec in out varchar2, byte varchar2) return varchar2 is

token	varchar2(100);
ipos	integer;

begin

   if rec is null then
      return null;
   end if;

   ipos := instr (rec, byte);
   if ipos > 0 then
      token	:= substr (rec, 1, ipos-1);
      rec	:= substr (rec, ipos+length(byte));
   else
      token	:= rec;
      rec	:= null;
   end if;

   return token;

end get_next_token;

-- *******************************************************************************************

function add_time (this_date date, this_time integer) return date is

minutes		integer;
hours		integer;

begin

   minutes	:= mod (this_time, 100);
   hours	:= (this_time - minutes) / 100;
   minutes	:= (hours * 60) + minutes;

   return this_date + minutes/1440;

end add_time;

-- *******************************************************************************************

function get_person_affil_country (pid integer, sep_char varchar2 default ', ') return varchar2 is

cursor	driver is
select	country_descr
from	country_codes	cc,
	addresses	addr,
	profiles	pro
where	pro.person_id	= pid
and	pro.deleted	is null
and	addr.address_id	= pro.address_id
and	cc.country_code	= addr.country_code
order by
	sort_text (country_descr);

buffer	varchar2(5000) := null;

begin

   for driver_rec in driver LOOP
      buffer := sep_char || driver_rec.country_descr;
   end loop;

   return substr (buffer, length (sep_char)+1);

end get_person_affil_country;

-- *******************************************************************************************

function publishable_status_code (code varchar2) return boolean is

cursor	driver is
select	1
from	status_codes
where	status_code	= code
and	publishable	= 'Y';

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end publishable_status_code;

-- *******************************************************************************************

function publishable_referee_code (code varchar2) return boolean is

cursor	driver is
select	1
from	referee_codes
where	referee_code	= code
and	publishable	= 'Y';

dummy		integer;
rec_found	boolean;

begin

   if referee_conf$ = 'N' then
      return true;
   end if;

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end publishable_referee_code;

-- *******************************************************************************************

function uploadable_dot_status (code varchar2) return boolean is

-- Editor status codes are forced to uppercase
-- Referee status codes are forced to lowercase

cursor	driver is
select	1
from	status_codes
where	status_code	= code
and	OK_to_upload	= 'Y'
UNION
select	1
from	referee_codes
where	referee_code	= code
and	OK_to_upload	= 'Y';

dummy		integer;
rec_found	boolean;

begin

   if code is null then
      return true;
   end if;

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end uploadable_dot_status;

-- *******************************************************************************************

function get_abstract_id (pid varchar2) return integer is

cursor	driver is
select	abstract_id
from	abstract_sessions
where	paper_id = pid;

abs_id	integer;

begin

   open driver;
   fetch driver into abs_id;
   close driver;

   return abs_id;

end get_abstract_id;

-- *********************************************************************************************************************

function wanted_file_URL (paper_id varchar2, filename varchar2 default null) return varchar2 is

cursor	driver is
select	paper_id
from	abstract_sessions
where	abstract_id =
	(	select	abstract_id
		from	abstract_sessions
		where	paper_id = wanted_file_URL.paper_id
	)
and	primary_flag = 'Y';

URL		varchar2(1000);
primary_pid	abstract_sessions.paper_id%TYPE;

begin

   if editor_download_script$ is null then
      return null;
   end if;

   open driver;
   fetch driver into primary_pid;
   close driver;
   primary_pid := nvl(primary_pid, paper_id);

   URL := editor_download_script$ || '?paper_id=' || primary_pid;

   if filename is not null then
      URL := URL || '&wanted_file=' || filename;
   end if;

   if pass_phrase$ is NOT null then
      URL := URL || '&hcheck=' ||
			upper(RAWTOHEX(UTL_RAW.cast_to_raw(
				dbms_obfuscation_toolkit.md5(
				input_string=>pass_phrase$|| upper(primary_pid)))));
   end if;

   return URL;

end wanted_file_URL;

-- *********************************************************************************************************************

function get_paper_PDF (abs_id integer) return varchar2 is

cursor	driver is
select	paper_id
from	abstract_sessions	a
where	abstract_id		= abs_id
and	primary_flag		= 'Y'
and	exists
(	select	1
	from	files	f
	where	f.abstract_id		= a.abstract_id
	and	upper(file_name)	=
	(	select	upper(paper_id) || '.' || 'PDF'
		from	abstract_sessions
		where	abstract_id	= abs_id
		and	primary_flag	= 'Y')
	and	deleted			is null
);

rec_found	boolean;
driver_rec	driver%ROWTYPE;

begin

   if editor_download_script$ is null then
      return null;
   end if;

   open driver;
   fetch driver into driver_Rec;
   rec_found := driver%FOUND;
   close driver;

   if NOT rec_found then
      return null;
   end if;

   return wanted_file_URL (driver_rec.paper_id, driver_rec.paper_id || '.PDF');

end get_paper_PDF;

-- *******************************************************************************************

function paper_URL (paper_id varchar2) return varchar2 is

--role	varchar2(10) := 'AUTHOR';

begin

   return get_paper_PDF (get_abstract_id (paper_id));

end paper_URL;

-- *******************************************************************************************

function paper_anchor_tag (paper_id varchar2, label varchar2 default 'Download') return varchar2 is

URL	varchar2(4000) := wanted_file_URL(paper_id);

begin

   if URL is null then
      return null;
   end if;

   return htf.anchor2 (URL, label, ctarget=>'_new');

end paper_anchor_tag;

-- *******************************************************************************************

procedure status_code_popup (code varchar2, editor_opt varchar2, referee_opt varchar2,
				trans_opt varchar2 default null, show_null_opt boolean default true) is

cursor	driver is
select	sort_order, status_code, status_descr
from	status_codes
where	editor_opt	= 'Y'
UNION
select	sort_order, referee_code, referee_descr
from	referee_codes
where	referee_opt	= 'Y'
UNION
select	sort_order, transparency_code, transparency_descr
from	transparency_codes
where	trans_opt	= 'Y';

selected	varchar2(10) := null;

begin

   htp.formSelectOpen ('code');
   if code is null then
      selected := 'SELECTED';
   end if;

   if show_null_opt then
      htp.formSelectOption ('?', selected, cattributes=>'VALUE=""');
   end if;

   for driver_rec in driver LOOP
      selected := null;
      if driver_rec.status_code = code then
	 selected := 'SELECTED';
      end if;

      htp.formSelectOption (driver_rec.status_descr, selected,
				cattributes=>'VALUE="' || driver_rec.status_code || '"');
   end loop;
   htp.formSelectClose;

end status_code_popup;

-- *********************************************************************************************************************

procedure show_popup_table (this_code varchar2, this_descr varchar2, this_tab varchar2,
				this_prompt varchar2 default null, this_value varchar2 default null,
				where_claws varchar2 default null, cattributes varchar2 default null,
				show_blank boolean default true, var_name varchar2 default null,
				search_nulls boolean default false, order_by varchar2 default 'order by 2') is

type	curtype	is REF CURSOR;
driver	curtype;

type	rec_type is record (
	code	varchar2(100),
	descr	varchar2(1000) );

driver_rec	rec_type;

checked		varchar2(7) := null;
sql_stmt	varchar2(2000);

begin

   htp.formSelectOpen (nvl (var_name, 'this_payment_code'), this_prompt, cattributes=>cattributes);
   if show_blank then
      if this_value is null then
	 checked := 'CHECKED';
      end if;
      htp.formSelectOption ('', checked, cattributes=>'VALUE=""');
   end if;

   sql_stmt := 'select ' || this_code || ', ' || this_descr ||
		' from ' || this_tab || ' ' || where_claws || ' ' || order_by;

   open driver for sql_stmt;
   LOOP
      fetch driver into driver_rec;
      exit when driver%NOTFOUND;

      checked := null;
      if this_value = driver_rec.code then
	 checked := 'CHECKED';
      end if;

      htp.formSelectOption (driver_rec.descr, checked, cattributes=>'VALUE="' || driver_rec.code || '"');
   end loop;
   close driver;

   if search_nulls then
      htp.formSelectOption (search_for_null$);
   end if;

   htp.formSelectClose;

end show_popup_table;

-- ***************************************************************************************************************

procedure show_popup_table_row (this_code varchar2, this_descr varchar2, this_tab varchar2,
				this_prompt varchar2 default null, this_value varchar2 default null,
				where_claws varchar2 default null, cattributes varchar2 default null,
				show_blank boolean default true, var_name varchar2 default null,
				search_nulls boolean default false, order_by varchar2 default 'order by 2') is

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader (this_prompt, 'RIGHT', cnowrap=>'NOWRAP');
   htp.p ('<TD>');
   show_popup_table (this_code, this_descr, this_tab, null, this_value, where_claws,
			cattributes, show_blank, var_name, search_nulls, order_by);
   htp.p ('</TD>');
   htp.tableRowClose;

end show_popup_table_row;

-- *********************************************************************************************************************

procedure show_popup_list (var varchar2, value varchar2 default null,
			where_claws varchar2 default null, onchange varchar2 default null,
			multiple boolean default false, show_null boolean default true,
			form_var_name varchar2 default null, search_nulls boolean default false) is

type	cursor_type	is REF CURSOR;
type	rec_type is record (
	code	varchar2(40),
	descr	varchar2(500) );

driver		cursor_type;
driver_rec	rec_type;
selected	varchar2(8);
sql_stmt	varchar2(500);
var_name	varchar2(100) := nvl (form_var_name, 'this_' || var);

begin

   sql_stmt := 'select ' || var || '_code, ' || var || '_descr from ' || var || '_codes ';
   sql_stmt := sql_stmt || where_claws || ' ';

   if nvl (instr (lower (where_claws), 'order by'), 0) <> 1 then
      sql_stmt := sql_stmt || 'order by common.sort_text (' || var || '_descr' || ')';
   end if;

   if multiple then
      htp.formSelectOpen (var_name, cattributes=>'MULTIPLE ' || onchange);
   else
      htp.formSelectOpen (var_name, cattributes=>onchange);
   end if;

   if show_null then
      if value is null then
	 htp.formSelectOption ('', 'selected');
      else
	 htp.formSelectOption ('');
      end if;
   end if;

   open driver for SQL_STMT;
   LOOP
      fetch driver into driver_rec;
      exit when driver%NOTFOUND;

      selected := null;
      if value = driver_rec.code then
	 selected := 'selected';
      end if;

      htp.formSelectOption (driver_rec.descr, selected,
				cattributes=>'VALUE="' || driver_rec.code || '"');
   end loop;
   close driver;

   if search_nulls then
      htp.formSelectOption (search_for_null$);
   end if;

   htp.formSelectClose;

end show_popup_list;

-- *********************************************************************************************************************

procedure show_lookup_table (var varchar2, prompt varchar2, value varchar2 default null,
				where_claws varchar2 default null, onchange varchar2 default null,
				multiple boolean default false, show_null boolean default true,
				colspan integer default null, search_nulls boolean default false) is

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader (prompt, 'RIGHT', cnowrap=>'NOWRAP', cattributes => 'class=boldtext');
   if colspan > 1 then
      htp.p ('<TD COLSPAN="' || colspan || '">');
   else
      htp.p ('<TD>');
   end if;

   show_popup_list (var, value, where_claws, onchange, multiple, show_null, null, search_nulls);
   htp.p ('</TD>');
   htp.tableRowClose;

end show_lookup_table;

-- *******************************************************************************************

function pdf_required_code (code varchar2) return boolean is

cursor	driver is
select	pdf_required
from	status_codes
where	status_code = code;

rec	driver%rowtype;

begin

   open driver;
   fetch driver into rec;
   close driver;

   if rec.pdf_required = 'Y' then
      return true;
   end if;

   return false;

end pdf_required_code;

-- *******************************************************************************************

function pdf_uploaded (abs_id integer) return boolean is

cursor	driver is
select	1
from	files
where	abstract_id		= abs_id
and	upper(file_name)	=
	(	select	upper(paper_id) || '.' || 'PDF'
		from	abstract_sessions
		where	abstract_id	= abs_id
		and	primary_flag	= 'Y'
	);

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end pdf_uploaded;

-- *******************************************************************************************

function cc_admin (new_cc varchar2, subject varchar2) return varchar2 is

begin

   if cc_all_email$ = 'N' then
      return new_cc;
   end if;

   if subject like registration.subject$ then
      return new_cc;
   end if;

   if new_cc is null or instr (new_cc, editor_email$) > 0 then
      return editor_email$;
   end if;

   return new_cc || ',' || editor_email$;

end cc_admin;

-- *******************************************************************************************

function hash (buffer varchar2) return number is

begin

   return dbms_utility.get_hash_value (buffer, power (10,9), power (2, 30) );

end hash;

-- *******************************************************************************************

procedure blank_header (rpt_title varchar2) is

begin

   htp.htmlOpen;
   htp.headOpen;
   htp.meta ('Content-Type', null,	'text/html;CHARSET=' || charset$);
   htp.meta ('Author',	null,		'Matt Arena, Fermi National Accelerator Laboratory, Batavia, Illinois');
   htp.meta ('Pragma', null, 'no-cache');
   htp.title (conf_title$ || ' ' || rpt_title);
   htp.headClose;
   htp.bodyOpen;

end blank_header;

-- *******************************************************************************************

procedure blank_footer is

begin

   htp.bodyClose;
   htp.htmlClose;

end blank_footer;

-- *******************************************************************************************

function get_conf_code return varchar2 is

cursor	driver is
select	conference_code
from	control;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   return driver_rec.conference_code;

end get_conf_code;

-- *******************************************************************************************

-- This routine replaces special charaters found in a URL variable.

function sc (buffer varchar2, i integer default 1) return varchar2 is

type	vrec is varray(4) of varchar2(1);
list	vrec := vrec ('=', '&', ' ', '%');
string	varchar2(3);

begin

   if i > list.COUNT then
      return replace (buffer, tab$, '%');
   end if;

   string := tab$ || to_char (ascii (list(i)), 'FMXX');
   return sc (replace (buffer, list(i), string), i+1 );

end sc;

-- *******************************************************************************************

procedure hidden_array (var_name varchar2, array ident_arr) is

begin

   for i in 1..array.count LOOP
      htp.formHidden (var_name, array(i) );
   end loop;

end hidden_array;

-- ********************************************************************************************

function editing_as_jacow_admin return boolean is

begin

   if gbl_priv_pid = admin_pid$ then
      public_header ('Unable To Continue');
      htp.header (2, 'The JACoW Administrator account can not be used to edit a user''s profile.');
      htp.header (3, 'Please log in as a registered user with the administrator privilege. '	||
			'You can use the the JACoW Administrator account to grant yourself '	||
			'the administrator privilege.');
      htp.para;

      htp.tableOpen;
      htp.tableRowOpen;

      htp.p ('<TD>');
      htp.formOpen ('profile.html');
      htp.formSubmit (null, 'Login');
      htp.formClose;
      htp.p ('</TD>');

      htp.tableRowClose;
      htp.tableClose;
      footer;

      return true;
   end if;

   return false;

end editing_as_jacow_admin;

-- *********************************************************************************************

function privileged_user (pid integer) return boolean is

cursor	driver is
select	1
from	function_privileges	fp,
	user_functions		uf
where	uf.person_id		= pid
and	fp.function_code	= uf.function_code;

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end privileged_user;

-- ********************************************************************************************

procedure rebuild_CTX (table_name varchar2) is

online		varchar2(7)	:= 'online ';
process_name	varchar2(90)	:= 'CTX Rebuild of ' || table_name;

begin

   if NOT process_is_running (process_name) then
      common.set_process_name (process_name);

      if CTX_rebuild_online$ = 'N' then
	 online := null;
      end if;

      execute immediate 'alter index ' || table_name || ' rebuild ' || online || 'parameters (''sync memory 10M'')';
   end if;

   common.set_process_name ('');

end rebuild_CTX;

-- ********************************************************************************************

function trim_crlf (buffer varchar2) return varchar2 is

begin

   return trim (replace (replace (buffer, cr$, null), eol$, null));

end trim_crlf;

-- ********************************************************************************************

function get_author_profile_id (abs_id integer, code varchar2) return integer is

cursor	driver is
select	profile_id
from	authors
where	abstract_id	= abs_id
and	author_code	= code;

pid	integer;

begin

   open driver;
   fetch driver into pid;
   close driver;

   return pid;

end get_author_profile_id;

-- ********************************************************************************************

function get_user_primary_profile_id (pid integer) return integer is

cursor	driver is
select	pro.profile_id
from	affiliations		affil,
	addresses		addr,
	profiles		pro
where	pro.person_id		= PID
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
and	affil.affiliation_id	<> private_address$
order by
	pro.deleted nulls first,
	pro.current_address nulls last,
	pro.update_date desc;

profile_id	integer;

begin

   open driver;
   fetch driver into profile_id;
   close driver;

   return profile_id;

end get_user_primary_profile_id;

-- ********************************************************************************************

function get_user_primary_affil_id (pid integer) return integer is

cursor	driver is
select	affil.affiliation_id
from	affiliations		affil,
	addresses		addr,
	profiles		pro
where	pro.person_id		= PID
and	pro.deleted		is null
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
and	affil.affiliation_id	<> private_address$
order by
	pro.current_address nulls last;

affil_id	integer;

begin

   open driver;
   fetch driver into affil_id;
   close driver;

   return affil_id;

end get_user_primary_affil_id;

-- ********************************************************************************************

function get_user_primary_addr_id (pid integer) return integer is

cursor	driver is
select	addr.address_id
from	affiliations		affil,
	addresses		addr,
	profiles		pro
where	pro.person_id		= PID
and	pro.deleted		is null
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
and	affil.affiliation_id	<> private_address$
order by
	pro.current_address nulls last;

addr_id	integer;

begin

   open driver;
   fetch driver into addr_id;
   close driver;

   return addr_id;

end get_user_primary_addr_id;

-- ********************************************************************************************

function get_affil_by_abs_person (abs_id integer, pid integer, abbrevs_only varchar2 default 'Y') return varchar2 is

cursor driver is
select /*+ INDEX (affil) INDEX (addr) */
	distinct
	auth.sort_order,
	common.get_affil_name (affil.affiliation_id, null, 'N', abbrevs_only) affiliation,
	addr.town
from	affiliations	affil,
	addresses	addr,
	profiles	pro,
	authors		auth
where	auth.abstract_id	= abs_id
and	pro.profile_id		= auth.profile_id
and	pro.person_id		= pid
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
order by
	auth.sort_order nulls first, 2, addr.town;

buffer			varchar2(1000) := null;
prev_affiliations	ident_arr;

begin

   for driver_rec in driver LOOP
      if NOT in_list (prev_affiliations, driver_rec.affiliation || ';' || driver_rec.town) then
	 buffer := buffer || '; ' || driver_rec.affiliation;
	 buffer := buffer || ', ' || driver_rec.town;
      end if;

      prev_affiliations(prev_affiliations.count+1) := driver_rec.affiliation || ';' || driver_rec.town;
   end loop;

   return substr (buffer, 3);

end get_affil_by_abs_person;

-- ********************************************************************************************

function get_speaker_profile_id (abs_id integer) return integer is

cursor	driver is
select	profile_id
from	authors
where	abstract_id	= abs_id
and	author_code	= common.speaker$;

prof_id	integer;

begin

   open driver;
   fetch driver into prof_id;
   close driver;

   return prof_id;

end get_speaker_profile_id;

-- ************************************************************************************

function process_is_running (process_name varchar2) return boolean is

cursor	driver is
select	1
from	sys.v_$session
where	client_info	like process_name
and	status		<> 'KILLED';

rec_found	boolean;
dummy		integer;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end process_is_running;

-- ********************************************************************************************

procedure set_process_name (process_name varchar2) is

begin

   dbms_application_info.set_client_info (process_name);

end set_process_name;

-- ********************************************************************************************

procedure load_param (this_id integer) is

cursor	driver is
select	value
from	parameters
where	id = this_id;

value	parameters.value%TYPE;

begin

   if NOT params.exists(this_id) then
      open driver;
      fetch driver into value;
      close driver;

      params(this_id) := value;
   end if;

end load_param;

-- ********************************************************************************************

function param_text (this_id integer) return varchar2 is

begin

   load_param (this_id);
   return params(this_id);

end param_text;

-- ********************************************************************************************

function param_date (this_id integer) return date is

begin

   load_param (this_id);
   return to_date (params(this_id), 'mm/dd/yyyy');

end param_date;

-- ********************************************************************************************

function param_numb (this_id integer) return number is

begin

   load_param (this_id);
   return to_number (params(this_id));

end param_numb;

-- ********************************************************************************************

procedure fmtOUT (buffer varchar2, output_type varchar2, tblHDR boolean default false,
			col_count varchar2 := null) is

begin

   if output_type = out_HTML$ then
      if tblHDR then
         htp.tableHeader (buffer, ccolSpan=>col_count);
      else
         htp.tableData (nvl(buffer,common.space$), ccolSpan=>col_count);
      end if;

   else
      htp.prn ('"');
      htp.prn (buffer);
      htp.prn ('",');
   end if;

end fmtOUT;

-- ********************************************************************************************

function get_presenter_person_id (abs_id integer) return integer is

cursor	driver is
select	person_id
from	profiles
where	profile_id =
	(	select	profile_id
		from	authors
		where	abstract_id	= abs_id
		and	author_type	= common.present$);

person_id	integer;

begin

   open driver;
   fetch driver into person_id;
   close driver;

   return person_id;

end get_presenter_person_id;

-- ********************************************************************************************

procedure add_abs_session (	aid	integer,
				sid	varchar2,
				pcode	varchar2,
				pflag	varchar2 default 'N',
				stime	integer,
				dur	integer,
				seq	integer default null,
				SV_URL	varchar2 default null) is

cursor	driver (next_seq$ integer) is
select	1
from	abstract_sessions
where	abstract_id	= aid
and	session_id	= sid
and	session_seq	= nvl(seq, next_seq$);

dummy		integer;
rec_found	boolean;
rec		abstract_sessions%ROWTYPE;
next_seq	integer;

begin

   next_seq := paper_ids.get_next_session_seq(sid);

   if pflag = 'Y' then -- primary program code
      update	abstract_sessions
      set	primary_flag	= 'N'
      where	abstract_id	= aid
      and	session_seq	<> nvl(seq, next_seq)
      and	primary_flag	= 'Y';
   end if;

   open driver(next_seq);
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   if NOT rec_found then
      rec.abstract_id		:= aid;
      rec.presentation_code	:= pcode;
      rec.session_id		:= sid;
      rec.session_seq		:= nvl(seq, next_seq);
      rec.primary_flag		:= pflag;
      rec.start_time		:= stime;
      rec.duration		:= dur;
      rec.streaming_video_URL	:= sv_URL;

      insert into abstract_sessions values rec;
   end if;

-- Safety check; must have one primary
   select count(1) into dummy from abstract_sessions where abstract_id = aid;
   if dummy = 1 then -- it must be the primary
      update abstract_sessions
      set    primary_flag = 'Y'
      where  abstract_id  = aid
      and    primary_flag <> 'Y';
   end if;

end add_abs_session;

-- ********************************************************************************************

function primary_paper_id (pid varchar2) return boolean is

cursor	driver is
select	1
from	abstract_sessions
where	paper_id	= pid
and	primary_flag	= 'Y';

rec_found	boolean;
dummy		integer;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end primary_paper_id;

-- ********************************************************************************************

procedure show_popup_array (var_name varchar2, recs popups_type, pre_selected varchar2 default null) is

selected	varchar2(10);

begin

   htp.formSelectOpen (var_name);
   htp.formSelectOption ('', selected);

   for i in 1..recs.COUNT loop
      selected := null;
      if recs(i).code = pre_selected then
	 selected := 'SELECTED';
      end if;

      htp.formSelectOption (recs(i).name, selected,
				cattributes=>'VALUE="' || recs(i).code || '"');
   end loop;
   htp.formSelectClose;

end show_popup_array;

-- ********************************************************************************************

procedure show_popup_array_row (prompt varchar2, var_name varchar2, recs popups_type, pre_selected varchar2 default null) is

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader (prompt, 'RIGHT');
   htp.p ('<TD ALIGN="LEFT">');
      show_popup_array (var_name, recs, pre_selected);
   htp.p ('</TD>');
   htp.tableRowClose;

end show_popup_array_row;

-- ********************************************************************************************

function files_uploaded return boolean is

cursor	driver is
select	1
from	files;

rec_found	boolean;
dummy		integer;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end files_uploaded;

-- ********************************************************************************************

function repo_db$			return varchar2 is begin return param_text (0);   end repo_db$;
function conf_title$			return varchar2 is begin return param_text (1);   end conf_title$;
function pubs_home_page$		return varchar2 is begin return param_text (2);   end pubs_home_page$;
function file_upload_instr_URL$		return varchar2 is begin return param_text (3);   end file_upload_instr_URL$;
function chairs_email$			return varchar2 is begin return param_text (4);   end chairs_email$;
function conf_start_monday$		return date	is begin return param_date (5);   end conf_start_monday$;
function logo_url$			return varchar2 is begin return param_text (6);   end logo_url$;
function require_sub_class$		return varchar2 is begin return param_text (7);   end require_sub_class$;
function freeze_abs_updates$		return varchar2 is begin return param_text (8);   end freeze_abs_updates$;
function repo_profile_URL$		return varchar2 is begin return param_text (9);   end repo_profile_URL$;
function acct_instr$			return varchar2 is begin return param_text (10);  end acct_instr$;
function invitation_only$		return varchar2 is begin return param_text (11);  end invitation_only$;
function proceedings_base_URL$		return varchar2 is begin return param_text (12);  end proceedings_base_URL$;
function abstract_instr_url$		return varchar2 is begin return param_text (15);  end abstract_instr_url$;
function help_url$			return varchar2 is begin return param_text (16);  end help_url$;
function accept_abstracts$		return varchar2 is begin return param_text (17);  end accept_abstracts$;
function accept_file_uploads$		return varchar2 is begin return param_text (18);  end accept_file_uploads$;
function editor_email$			return varchar2 is begin return param_text (19);  end editor_email$;
function email_new_accounts$		return varchar2 is begin return param_text (20);  end email_new_accounts$;
function date_fmt_str$			return varchar2 is begin return param_text (21);  end date_fmt_str$;
function login_info_text$		return varchar2 is begin return param_text (22);  end login_info_text$;
function login_info_URL$		return varchar2 is begin return param_text (23);  end login_info_URL$;
function PC_present_enabled$		return varchar2 is begin return param_text (24);  end PC_present_enabled$;
function referee_auto_assign$		return varchar2 is begin return param_text (25);  end referee_auto_assign$;
function referee_notify_decline$	return varchar2 is begin return param_text (26);  end referee_notify_decline$;
function standalone_DB$			return varchar2 is begin return param_text (27);  end standalone_DB$;
function LI_dot_URL$			return varchar2 is begin return param_text (28);  end LI_dot_URL$;
function referee_notify_revisions$	return varchar2 is begin return param_text (29);  end referee_notify_revisions$;
function CSS_URL$			return varchar2 is begin return param_text (30);  end CSS_URL$;
function referee_PC_notify_decline$	return varchar2 is begin return param_text (31);  end referee_PC_notify_decline$;
function smtp_host$			return varchar2 is begin return param_text (33);  end smtp_host$;
function vdir_dflt$			return varchar2 is begin return param_text (34);  end vdir_dflt$;
function version_string$		return varchar2 is begin return param_text (35);  end version_string$;
function author_upload_script$		return varchar2 is begin return param_text (36);  end author_upload_script$;
function editor_download_script$	return varchar2 is begin return param_text (37);  end editor_download_script$;
function use_SSL$			return varchar2 is begin return param_text (38);  end use_SSL$;
function SSL_port$			return varchar2 is begin return param_text (39);  end SSL_port$;
function legal_footer_text$		return varchar2 is begin return param_text (40);  end legal_footer_text$;
function legal_footer_URL$		return varchar2 is begin return param_text (41);  end legal_footer_URL$;
function credits_footer$		return varchar2 is begin return param_text (42);  end credits_footer$;
function conf_location$			return varchar2 is begin return param_text (43);  end conf_location$;
function email_new_abstract$		return varchar2 is begin return param_text (44);  end email_new_abstract$;
function conf_len_days$			return number	is begin return param_numb (45);  end conf_len_days$;
function program_download_URL$		return varchar2 is begin return param_text (46);  end program_download_URL$;
function cc_new_affil_reqs$		return varchar2 is begin return param_text (47);  end cc_new_affil_reqs$;
function auto_session_ids$		return varchar2 is begin return param_text (48);  end auto_session_ids$;
function paper_id_oral_len$		return number	is begin return param_numb (49);  end paper_id_oral_len$;
function paper_id_poster_len$		return number	is begin return param_numb (50);  end paper_id_poster_len$;
function HTML_path$			return varchar2 is begin return param_text (51);  end HTML_path$;
function TEXT_path$			return varchar2 is begin return param_text (52);  end TEXT_path$;
function spires_meeting_note$		return varchar2 is begin return param_text (53);  end spires_meeting_note$;
function spires_conf_number$		return varchar2 is begin return param_text (54);  end spires_conf_number$;
function post_log_file$			return varchar2 is begin return param_text (55);  end post_log_file$;
function JACoW_URL$			return varchar2 is begin return param_text (56);  end JACoW_URL$;
function max_keywords$			return number	is begin return param_numb (57);  end max_keywords$;
function poster_id_assign_enabled$	return varchar2 is begin return param_text (58);  end poster_id_assign_enabled$;
function email_upd_abstract$		return varchar2 is begin return param_text (59);  end email_upd_abstract$;
function email_LOC_new_abstract$	return varchar2 is begin return param_text (60);  end email_LOC_new_abstract$;
function email_LOC_upd_abstract$	return varchar2 is begin return param_text (61);  end email_LOC_upd_abstract$;
function LOC_email_address$		return varchar2 is begin return param_text (62);  end LOC_email_address$;
function email_admn_new_abstracts$	return varchar2 is begin return param_text (63);  end email_admn_new_abstracts$;
function date_input_fmt_str$		return varchar2 is begin return param_text (64);  end date_input_fmt_str$;
function PC_reclassify_enabled$		return varchar2 is begin return param_text (65);  end PC_reclassify_enabled$;
function dtree_URL$			return varchar2 is begin return param_text (66);  end dtree_URL$;
function max_abstract_len$		return number	is begin return param_numb (67);  end max_abstract_len$;
function max_footnote_len$		return number	is begin return param_numb (68);  end max_footnote_len$;
function max_funding_agency_len$	return number	is begin return param_numb (69);  end max_funding_agency_len$;
function copyright_required$		return varchar2 is begin return param_text (70);  end copyright_required$;
function grace_period$			return number	is begin return param_numb (71);  end grace_period$;
function currency_symbol$		return varchar2 is begin return param_text (72);  end currency_symbol$;
function http_port$			return number	is begin return param_numb (73);  end http_port$;
function use_poster_police$		return varchar2 is begin return param_text (74);  end use_poster_police$;
function freeze_abs_reclass$		return varchar2 is begin return param_text (75);  end freeze_abs_reclass$;
function vdir_debug$			return varchar2 is begin return param_text (76);  end vdir_debug$;
function cc_all_email$			return varchar2 is begin return param_text (77);  end cc_all_email$;
function no_payment_email_msg$		return varchar2 is begin return param_text (78);  end no_payment_email_msg$;
function reclass_instr_URL$		return varchar2 is begin return param_text (79);  end reclass_instr_URL$;
function referee_conf$			return varchar2 is begin return param_text (80);  end referee_conf$;
function referee_instr$			return varchar2 is begin return param_text (81);  end referee_instr$;
function referees_per_paper$		return number	is begin return param_numb (82);  end referees_per_paper$;
function show_invoices$			return varchar2 is begin return param_text (83);  end show_invoices$;
function referee_PC_notify_revision$	return varchar2 is begin return param_text (85);  end referee_PC_notify_revision$;
function no_admin_coauthor_email$	return varchar2 is begin return param_text (86);  end no_admin_coauthor_email$;
function repo_URL$			return varchar2 is begin return param_text (87);  end repo_URL$;
function repo_URL_text$			return varchar2 is begin return param_text (88);  end repo_URL_text$;
function program_interval$		return number	is begin return param_numb (89);  end program_interval$;
function referee_notice$		return varchar2 is begin return param_text (90);  end referee_notice$;
function referee_assigned$		return varchar2 is begin return param_text (91);  end referee_assigned$;
function minutes_between_sync$		return varchar2 is begin return param_text (92);  end minutes_between_sync$;
function pmt_prompt_notes$		return varchar2 is begin return param_text (93);  end pmt_prompt_notes$;
function toc_by_present$		return varchar2 is begin return param_text (94);  end toc_by_present$;
function file_weight_threshold$		return varchar2 is begin return param_text (95);  end file_weight_threshold$;
function IP_addr_list$			return varchar2 is begin return param_text (96);  end IP_addr_list$;
function IP_addr_var$			return varchar2 is begin return param_text (97);  end IP_addr_var$;
function freeze_abs_present$		return varchar2 is begin return param_text (98);  end freeze_abs_present$;
function PC_mode$			return varchar2 is begin return param_text (100); end PC_mode$;
function PC_edit$			return varchar2 is begin return param_text (103); end PC_edit$;
function tz_offset$			return number	is begin return param_numb (104); end tz_offset$;
function cc_vendor$			return varchar2 is begin return param_text (105); end cc_vendor$;
function invite_letter$			return varchar2 is begin return param_text (106); end invite_letter$;
function CTX_rebuild_online$		return varchar2 is begin return param_text (107); end CTX_rebuild_online$;
function server_override$		return varchar2 is begin return param_text (108); end server_override$;
function new_affil_email$		return varchar2 is begin return param_text (109); end new_affil_email$;
function edot_hdr_text_color$		return varchar2 is begin return param_text (110); end edot_hdr_text_color$;
function edot_hdr_back_color$		return varchar2 is begin return param_text (111); end edot_hdr_back_color$;
function edot_hdr_font_size$		return varchar2 is begin return param_text (112); end edot_hdr_font_size$;
function edot_instr_font_size$		return varchar2 is begin return param_text (115); end edot_instr_font_size$;
function edot_cell_font_size$		return varchar2 is begin return param_text (116); end edot_cell_font_size$;
function edot_row_count$		return varchar2 is begin return param_text (117); end edot_row_count$;
function edot_column_count$		return varchar2 is begin return param_text (118); end edot_column_count$;
function edot_refresh_rate$		return varchar2 is begin return param_text (119); end edot_refresh_rate$;
function poster_transparencies$		return varchar2 is begin return param_text (120); end poster_transparencies$;
function deleteImg$			return varchar2 is begin return param_text (121); end deleteImg$;
function editImg$			return varchar2 is begin return param_text (122); end editImg$;
function usedImg$			return varchar2 is begin return param_text (123); end usedImg$;
function newImg$			return varchar2 is begin return param_text (124); end newImg$;
function nextImg$			return varchar2 is begin return param_text (125); end nextImg$;
function prevImg$			return varchar2 is begin return param_text (126); end prevImg$;
function cancelImg$			return varchar2 is begin return param_text (127); end cancelImg$;
function ht_booking$			return varchar2 is begin return param_text (128); end ht_booking$;
function ht_manager$			return varchar2 is begin return param_text (129); end ht_manager$;
function abs_book_initials_only$	return varchar2 is begin return param_text (130); end abs_book_initials_only$;
function hh_mail_signature$		return varchar2 is begin return param_text (131); end hh_mail_signature$;
function same_editor_and_qa_allowed$	return varchar2 is begin return param_text (132); end same_editor_and_qa_allowed$;
function hardcopy_required$		return varchar2 is begin return param_text (133); end hardcopy_required$;
function string_header$			return varchar2 is begin return param_text (134); end string_header$;
function string_instruction$		return varchar2 is begin return param_text (135); end string_instruction$;
function string_contacts$		return varchar2 is begin return param_text (136); end string_contacts$;
function string_footer$			return varchar2 is begin return param_text (137); end string_footer$;
function hide_program_codes$		return varchar2 is begin return param_text (138); end hide_program_codes$;
function regist_list_public$		return varchar2 is begin return param_text (139); end regist_list_public$;
function agenda_public_access$		return varchar2 is begin return param_text (140); end agenda_public_access$;
function from_email$			return varchar2 is begin return param_text (141); end from_email$;
function abs_submission_end_date$	return varchar2 is begin return param_text (142); end abs_submission_end_date$;
function contributions_end_date$	return varchar2 is begin return param_text (143); end contributions_end_date$;
function delegates_reg_start$		return varchar2 is begin return param_text (144); end delegates_reg_start$;
function delegates_reg_early$		return varchar2 is begin return param_text (145); end delegates_reg_early$;
function xtract_chk$			return varchar2 is begin return param_text (146); end xtract_chk$;
function abs_submission_start_date$	return varchar2 is begin return param_text (147); end abs_submission_start_date$;
function quick_regist_passphrase$	return varchar2 is begin return param_text (148); end quick_regist_passphrase$;
function new_profile_email$		return varchar2 is begin return param_text (149); end new_profile_email$;
function pass_phrase_paper_upload$	return varchar2 is begin return param_text (150); end pass_phrase_paper_upload$;
function pass_phrase$			return varchar2 is begin return param_text (151); end pass_phrase$;
function template_guidelines$		return varchar2 is begin return param_text (152); end template_guidelines$;
function currency_fmt$			return varchar2 is begin return param_text (157); end currency_fmt$;

-- ********************************************************************************************

end common;

-- ********************************************************************************************

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
