create table all_conference_codes as
tablespace data01
select * from conference_codes;

create table all_conferences (
conference_code	varchar2(10),
location	varchar2(100),
start_date	date,
duration	number )
tablespace	data01;

alter table all_conferences
	add constraint all_conferences_conf_code_fk
	foreign key (conference_code)
	references all_conference_codes (conference_code);

insert into conference_codes values ('BIW', 'Beams Instrumentation Workshop');
insert into conference_codes values ('ASPEN', 'Aspen');
insert into conference_codes values ('FLS', 'FLS');
insert into conference_codes values ('HB', 'HB');
insert into conference_codes values ('RT', 'Real Time Computing');

alter session set nls_date_format = 'mm/dd/yyyy';

insert into all_conferences values ('PAC', 'Chicago, Illinois, USA', '6/18/2001', 5);
insert into all_conferences values ('PAC', 'Portland, Oregon, USA', '5/12/2003', 5);
insert into all_conferences values ('BIW', 'Knoxville, Tennessee, USA', '5/3/2004', 4);
insert into all_conferences values ('EPAC', 'Lucerne, Switzerland', '7/5/2004', 5);
insert into all_conferences values ('LINAC', 'Lbeck, Germany', '8/16/2004', 5);
insert into all_conferences values ('FEL', 'Trieste, Italy', '8/29/2004', 5);
insert into all_conferences values ('CYCLOTRONS', 'Tokyo, Japan', '10/18/2004', 5);
insert into all_conferences values ('ASPEN', 'Aspen, Colorado, USA', '2/14/2005', 5);
insert into all_conferences values ('PAC', 'Knoxville, Tennessee, USA', '5/16/2005', 5);
insert into all_conferences values ('DIPAC', 'Lyon, France', '6/6/2005', 3);
insert into all_conferences values ('FEL', 'Stanford, California, USA', '8/21/2005', 5);
insert into all_conferences values ('COOL', 'Galena, Illinois, USA', '9/18/2005', 6);
insert into all_conferences values ('BIW', 'Batavia, Illinois, USA', '5/1/2006', 4);
insert into all_conferences values ('FLS', 'Hamburg, Germany', '5/15/2006', 5);
insert into all_conferences values ('HB', 'Tsukuba, Japan', '5/29/2006', 5);
insert into all_conferences values ('EPAC', 'Edinburgh, Scotland', '6/26/2006', 5);
insert into all_conferences values ('LINAC', 'Knoxville, Tennessee, USA', '8/21/2006', 5);
insert into all_conferences values ('FEL', 'Berlin, Germany', '8/27/2006', 5);
insert into all_conferences values ('ICAP', 'Chamonix, France', '10/2/2006', 5);
insert into all_conferences values ('APAC', 'Indore, India', '1/29/2007', 5);
insert into all_conferences values ('RT', 'Batavia, IL, USA', '4/29/2007', 6);
insert into all_conferences values ('DIPAC', 'Venice, Italy', '5/20/2007', 4);
insert into all_conferences values ('PAC', 'Albuquerque, New Mexico, USA', '6/25/2007', 5);
insert into all_conferences values ('FEL', 'Budker INP, Novosibirsk, Russia', '8/26/2007', 6);
insert into all_conferences values ('COOL', 'Bad Kreuznach, Germany', '9/9/2007', 6);
insert into all_conferences values ('CYCLOTRONS', 'Giardini Naxos, Italy', '9/30/2007', 6);
insert into all_conferences values ('ICALEPCS', 'Knoxville, Tennessee, USA', '10/15/2007', 5);
insert into all_conferences values ('EPAC', 'Genoa, Italy', '6/23/2008', 5);
