--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

spool Create_DB_Link.log

prompt 
prompt The JACoW application needs to connect to the JACoW repository to download data.
prompt You need the username and password to the account granted to you by the repository
prompt administrator at CERN.  You also need a TNS entry that points to the CERN repository.
prompt 
prompt 

accept repo_user_name	prompt "JACoW Repository User Name "
accept repo_pwd		prompt "JACoW Repository Password  " hide
accept tns_alias	prompt "JACoW Repository TNS Alias "

create database link jacow_repository
	connect to &repo_user_name identified by &repo_pwd
	using '&tns_alias';

prompt If you can see this table on the repository then the database link was created successfully.

desc abstracts@jacow_repository

spool off
