--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package dependencies as

   procedure keys;
   procedure primary_keys;

   procedure html;
   procedure show_objects (this_type varchar2);
   procedure show_dependencies (this_name varchar2, this_type varchar2);
   procedure show_depend2 (this_name varchar2);
   procedure show_source (this_name varchar2);

   procedure show_tables;
   procedure show_table (obj_name varchar2, obj_type varchar2);
   procedure show_columns (obj_name varchar2, obj_type varchar2, comments_only boolean default false);
   procedure cons1 (cons_name varchar2);
   procedure cons2 (cons_name varchar2);

   function show_table_comment (obj_name varchar2) return varchar2;

end dependencies;
/
show errors
