--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

prompt 
prompt Warning!!!
prompt 

prompt This script will drop every procedure, constraint, database link,
prompt sequence, view, index and table in this schema.  Be certain that
prompt you are in the JACoW schema owner's account.
prompt 

prompt You are currently logged in as:
show user
prompt 
prompt 

accept continue prompt 'Press Any Key To Continue...'
prompt 

@@Drop_All_Procedures
@@Drop_All_Constraints
@@Drop_All_DB_Links
@@Drop_All_Sequences
@@Drop_All_Views
@@Drop_All_Tables
@@Drop_All_Synonyms
@@Drop_All_Types

exec ctx_ddl.drop_stoplist ('SPMS_STOP_LIST');
exec ctx_ddl.drop_preference ('ABSTRACT_STORAGE');
exec ctx_ddl.drop_preference ('AFFIL_STORAGE');
exec ctx_ddl.drop_preference ('ADDR_STORAGE');

purge recyclebin;

col object_type format a50
select	object_type, object_name from user_objects;
