--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package email as

   procedure html;
   procedure init_variables;
   procedure show_variables(show_warning boolean default true);

   procedure step2 (log_codes common.ident_arr, file_types common.ident_arr, this_classification common.ident_arr,
		this_status common.ident_arr, this_referee common.ident_arr,
		this_presentation common.ident_arr, this_presentation_type common.ident_arr,
		this_presentation_option common.ident_arr, no_files common.ident_arr, police
		common.ident_arr, qaNoPolice common.ident_arr, noregist common.ident_arr,
		affil varchar2, send_to common.ident_arr, subject varchar2,
		message varchar2, cid common.ident_arr, pid common.ident_arr,
		attrib common.ident_arr);

   procedure step3 (log_codes common.ident_arr, file_types common.ident_arr, this_classification common.ident_arr,
		this_status common.ident_arr, this_referee common.ident_arr, this_presentation common.ident_arr,
		this_presentation_type common.ident_arr,  this_presentation_option common.ident_arr,
		no_files common.ident_arr, police common.ident_arr, qaNoPolice common.ident_arr,
		noregist common.ident_arr, affil varchar2, cid common.ident_arr, pid common.ident_arr,
		send_to common.ident_arr, subject varchar2, message varchar2, submit varchar2,
		attrib common.ident_arr);

   procedure one_email (abs_id integer);
   procedure history;
   procedure one (ID integer);
   procedure hist (ID integer);
   procedure read (mid integer);

   procedure schairs;
   procedure schair2 (sid common.ident_arr, subject varchar2, message varchar2);
   procedure schair3 (sid common.ident_arr, subject varchar2, message varchar2);

   procedure roles;
   procedure roles2 (expert common.ident_arr, this_function common.ident_arr, invitees common.ident_arr, subject varchar2, message varchar2);
   procedure roles3 (expert common.ident_arr, this_function common.ident_arr, invitees common.ident_arr, subj varchar2, msg varchar2);

   function format_message (message varchar2, show_header boolean default true) return varchar2;
   function replace_variables (message long, send_to common.ident_arr) return long;
   function recipient_count (recipients varchar2) return integer;

   variables	common.ident_arr;

end email;
/
show error
