select	cs.*, lc.capacity
from	location_codes	lc,
	class_sessions	cs,
	sessions	s
where	s.presentation_option_code		in
	(	select	presentation_code
		from	presentation_codes
		where	presentation_type_code = 'P') --common.poster$)
and	cs.session_id		= s.session_id
and	lc.location_code	= s.location_code
order by
	s.sort_order nulls last,
	s.session_date,
	s.beg_time,
	cs.sort_order;
