--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package params as

   procedure html;
   procedure show_cats (cat varchar2 default null);
   procedure get_value (num integer);
   procedure set_value (num integer, new_value varchar2);
   procedure reseq (cat varchar2 default null);
   procedure initial;
   procedure initial (code varchar2);
   procedure initial_save_params (code varchar2, ID common.ident_arr, value common.ident_arr);
   procedure initial_save_status_codes (code varchar2, status_code common.ident_arr, URL common.ident_arr);
   procedure initial_save_referee_codes (code varchar2, referee_code common.ident_arr, URL common.ident_arr);

dtype_number$	constant parameters.dtype%TYPE	:= 'N';
dtype_date$	constant parameters.dtype%TYPE	:= 'D';
dtype_boolean$	constant parameters.dtype%TYPE	:= 'B';

end params;
/
show error
