set define off

create or Replace package body profile as

rpt_title$	constant varchar2(20)	:= 'User Profiles';
rpt_title2$	constant varchar2(20)	:= 'Invitee List';
rpt_title3$	constant varchar2(30)	:= 'Verify System Administrator';
new_affil$	constant varchar2(30)	:= 'Request a New Affiliation';

lost_email$	constant varchar2(5)	:= 'EMAIL';
lost_prompt$	constant varchar2(6)	:= 'PROMPT';
forgot_pwd$	constant varchar2(20)	:= 'Forgotten Password';

-- repo_save_URL$ is used to direct the browser to the proper place after a profile is saved.
-- If the user is on the repository site then the user stays on the conferece web site.
-- See the repo_save_profile routine for more information

user_home_URL$	constant varchar2(20)	:= 'jacow.html';
repo_save_URL$	constant varchar2(100)	:= 'profile.manage';
search_URL$	constant varchar2(100)	:= 'search.html';

post_conf_save_URL	varchar2(500)	:= repo_save_URL$;
attrs			varchar2(90);
MT_arr			common.ident_arr;

crlf$		constant varchar2(2)	:= chr(13) || chr(10);
tab$		constant varchar2(1)	:= chr(9);

ignore_admin$	boolean	default true;
validate_IP$	boolean	default true;

-- *********************************************************************************************
-- *********************************************************************************************

function js$ return varchar2 is

begin

   return '<SCRIPT TYPE="text/javascript" language="JavaScript" src="' || common.server ||
		common.vdir$ || 'profile.js"></SCRIPT>';

end js$;

-- *********************************************************************************************

procedure js is

cursor	driver is
select	*
from	affiliations
order by
affiliation_id;

cmd varchar2(7) := 'if ';

begin

   htp.prn (
'function validateAcctInfo (admin_user) {

   if (admin_user == "N") {

      if (typeof (document.edt_profile.this_user_id) != "undefined") {
	 if (document.edt_profile.this_user_id.value == "") {
	    alert ("You must enter a User Name");
	    return false;
      } }

      if (typeof (document.edt_profile.pwd1) != "undefined") {
	 if (document.edt_profile.pwd1.value == "") {
	    alert ("You must enter a Password");
	    return false;
      } }

      if (typeof (document.edt_profile.pwd2) != "undefined") {
	 if (document.edt_profile.pwd2.value == "") {
	    alert ("You must re-enter your Password");
	    return false;
      } }

      if (typeof (document.edt_profile.pwd1) != "undefined") {
	 if (document.edt_profile.pwd1.value != document.edt_profile.pwd2.value) {
	    alert ("The two passwords must be the same");
	    return false;
   } } }

   if (typeof (document.edt_profile.this_lname) != "undefined") {
      if (document.edt_profile.this_lname.value == "") {
	 alert ("You must enter a Last (Family) Name");
	 return false;
   } }

   if (typeof (document.edt_profile.this_fname) != "undefined") {
      if (document.edt_profile.this_fname.value == "") {
	 alert ("You must enter a First (Given) Name");
	 return false;
   } }

   if (typeof (document.edt_profile.this_addr_id) != "undefined") {
      if (document.edt_profile.this_addr_id.value == "") {
	 alert ("You must select an Affiliation");
	 return false;
   } }

   if (admin_user == "N") {

      if (typeof (document.edt_profile.this_initials) != "undefined") {

	 if (document.edt_profile.this_initials.value == "") {
	    alert ("You must enter your Initials");
	    return false;
	 }

	 var ilen = document.edt_profile.this_initials.value.length - 1;
	 if (document.edt_profile.this_initials.value.charAt(ilen) != ".") {
	    alert ("Your Initials must end with a \".\"");
	    return false;
      } }

      if (typeof (document.edt_profile.email) != "undefined") {
	 if (document.edt_profile.email.value == "") {
	    alert ("You must enter an Email address");
	    return false;
	 }
      else if ( ! checkEmail (document.edt_profile.email.value) )
      {
      return false;
   } } }


   return true;

} // end validateAcctInfo
');

-- **********

   htp.print ('');
   htp.prn (
'function validateAuthor () {

   if (document.edt_profile.this_lname.value == "") {
      alert ("You must enter a Last (Family) Name");
      return false;
   }

   if (document.edt_profile.this_fname.value == "") {
      alert ("You must enter a First (Given) Name");
      return false;
   }

   if (document.edt_profile.this_addr_id.value == "") {
      alert ("You must select an Affiliation");
      return false;
   }

   if (document.edt_profile.email.value == "") {
      alert ("You must enter an Email address");
      return false;
   }

   return true;

} // end validateAuthor
');

-- **********

   htp.print ('');
   htp.prn (
'function validateAffilAddr () {

   if (document.edt_profile.this_addr_id.value == "") {
      alert ("You must select an Affiliation");
      return false;
   }

   if (document.edt_profile.email.value == "") {
      alert ("You must enter an Email address");
      return false;
   }

   return true;

} // end validateAffilAddr
');

-- **********

   htp.print ('');
   htp.prn (
'function ImageConstruct (name, address) {

   this.name = name;
   this.address = address;

} // end ImaegConstruct
');

-- **********


   htp.print ('');
   htp.prn (
'function setValue (addr_id) {

   opener.document.edt_profile.this_addr_id.value=addr_id;
   opener.document.edt_profile.affil_info.value=
affils[addr_id].name.replace (/<BR>/, "\n") + "\n" +
affils[addr_id].address.replace (/<BR>/, "\n");
   opener.focus();
   window.close();

} // end setValue
');

-- **********


   htp.print ('');
   htp.prn (
'function setAccount (user_id) {

   if (opener.document.SPMS.uid.length==0)
      opener.document.SPMS.uid.value=user_id;
   else
      opener.document.SPMS.uid.value=opener.document.SPMS.uid.value+"\n"+user_id;

   opener.focus();
   window.close();

} // end setAccount
');

-- **********

   htp.print ('');
   htp.prn (
'function newWindow (URL) {

   w = parseInt(screen.width*.75);
   h = parseInt(screen.height*.75);
   newWin = window.open (URL, "newWin' || common.time$ || '", "menubar=0,height=" + h + ",width=" + w + ",scrollbars=1,location=1,toolbar=1,status=1,resizable=1")
   newWin.focus()

} // end newWindow
');

-- **********

   htp.print ('');
   htp.prn (
'function checkEmail (formText) {

   var re=/\s/g; //remove spaces;
   var email_address = formText.replace(re,"");

   if (formText.length > 2) {
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(email_address)) {
	 return (true);
   } }

   alert ("The email address " + email_address + " has the wrong syntax!");

   return (false);

};
');

end js;

-- *********************************************************************************************
-- *********************************************************************************************

function gen_password_hash (uid varchar2, pwd varchar2) return number is

begin

   if trim (uid) is null then
      return null;
   end if;

   return common.hash (trim(upper(uid)) || trim (pwd) );

end gen_password_hash;

-- *********************************************************************************************
-- *********************************************************************************************

procedure invite (invite varchar2) is

begin

   if common.header (rpt_title$) then
      common.get_gbl_pid;
      update persons
      set requires_invitation = invite
      where person_id = common.gbl_pid;

      htp.header (3, 'Your request for an invitation letter for requesting a VISA is recorded.');
      htp.formOpen ('profile.manage');
      htp.formSubmit (null, 'Go back to your profile');
      htp.formClose;
      common.footer;
   end if;

end invite;

-- *********************************************************************************************
-- *********************************************************************************************

procedure new_coauthor_email (abs_id integer, prof_id integer) is

cursor C1 is
select	p.person_id,
	common.get_user_name (p.person_id) name,
	common.get_profile_affil (prof_id) affiliation,
	prof.email_address
from	persons		p,
	profiles	prof
where	prof.profile_id	= prof_id
and	p.person_id	= prof.person_id
and	p.user_id	is null;

cursor C2 is
select	a.*,
	common.get_author_profile_id (a.abstract_id, common.primary_author$) primary_profile_id
from	abstracts	a
where	abstract_id	= abs_id;

C1_rec C1%ROWTYPE;
C2_rec C2%ROWTYPE;
rec_found boolean;

OK_to_send boolean := true;

begin

   if common.no_admin_coauthor_email$ = 'N' and common.user_is_JACoW_admin then
      OK_to_send := false;
   end if;

   if common.PC_mode$ = 'Y' then
      OK_to_send := false;
   end if;

   if OK_to_send then
      open C1;
      fetch C1 into C1_rec;
      rec_found := C1%FOUND;
      close C1;

      if rec_found then
         open C2;
         fetch C2 into C2_rec;
         close C2;

         send_mail (C1_rec.email_address, common.conf_title$ || ' Contribution',
			C1_rec.name || common.eol2$ ||
			'You are listed as a coauthor in a ' || common.conf_title$ ||
			' Contribution entitled "' || C2_rec.title || '" submitted by ' ||
			common.get_user_name_affiliation (C2_rec.primary_profile_id) || '. ' ||
			'This has resulted in the creation of a profile for you, which is automatically ' ||
			'synchronized with the JACoW repository, and which you may access via the URL for ' ||
			common.conf_title$ || ': ' || common.server || common.vdir_dflt$ || 'profile.new_account.' ||
			common.eol2$ ||
			common.conf_title$ || ' invites you to verify your information regarding ' ||
			'this contribution by accessing the URL ' ||
			common.server || common.vdir_dflt$ || 'profile.html. ' ||
			'You are kindly invited to verify the data contained in your profile and create an ' ||
			'associated account, which will give you "ownership" of this profile. Note that all ' ||
			'contributions to JACoW collaboration conferences are linked to the JACoW Repository.',
			pid=>C1_rec.person_id, abs_id=>abs_id);
      end if;

   end if;

end new_coauthor_email;

-- **********************************************************************************************
-- **********************************************************************************************

procedure invalid_referer is

begin

   common.public_header (rpt_title$);
   htp.header (3, 'Server Not Recognized by the JACoW Administrator.', cattributes=>common.red$);
   common.footer;

end invalid_referer;

-- **********************************************************************************************
-- **********************************************************************************************

procedure show_mlist_hdr is

cursor driver is
select	conference_code
from	conference_codes
order by
conference_code;

begin

   for driver_rec in driver LOOP
      htp.prn (tab$ || driver_rec.conference_code);
   end loop;

end show_mlist_hdr;

-- **********************************************************************************************

procedure get_mlist (pid integer) is

cursor	driver is
select	c.conference_code,
	decode (m.person_id, null, 'No', 'Yes') flag
from	mailing_lists		m,
	conference_codes	c
where	m.conference_code(+)	= c.conference_code
and	m.person_id(+)		= pid
order by
c.conference_code;

begin

   for driver_rec in driver LOOP
      htp.prn (tab$ || driver_rec.flag);
   end loop;

end get_mlist;

-- **********************************************************************************************

procedure xls (this_conference common.ident_arr) is

type cursor_type is REF CURSOR;
driver cursor_type;

type rec_type is record (
	person_id	persons.person_id%TYPE,
	lname		persons.lname%TYPE,
	fname		persons.fname%TYPE,
	mname		persons.mname%TYPE,
	initials	persons.initials%TYPE,
	citizenship	persons.country_code%TYPE,
	affil_abbrev	affiliations.affil_abbrev%TYPE,
	name1		affiliations.name1%TYPE,
	name2		affiliations.name2%TYPE,
	department	affiliations.department%TYPE,
	affil_type_code	affiliations.affil_type_code%TYPE,
	mail_stop	profiles.mail_stop%TYPE,
	user_po_box	profiles.po_box%TYPE,
	address1	addresses.address1%TYPE,
	address2	addresses.address2%TYPE,
	address3	addresses.address3%TYPE,
	affil_po_box	addresses.po_box%TYPE,
	town		addresses.town%TYPE,
	postal_code	addresses.postal_code%TYPE,
	zip_code	addresses.zip_code%TYPE,
	country_code	addresses.country_code%TYPE,
	email_address	profiles.email_address%TYPE);

driver_rec rec_type;

sql_stmt varchar2(5000);

affil_type_descr	affil_type_codes.affil_type_descr%TYPE;
country_descr		country_codes.country_descr%TYPE;
citizenship_descr	country_codes.country_descr%TYPE;
region_descr	region_codes.region_descr%TYPE;

begin

   common.get_gbl_pid;

   if common.has_privs_to_page then
      owa_util.mime_header('application/vnd.excel', TRUE);

      htp.prn ('Last Name' || tab$ || 'First Name' || tab$ || 'Middle Name' || tab$ ||
	'Initials' || tab$ || 'Citizenship Code' || tab$ || 'Citizenship Country' || tab$ ||
	'Affil. Abbrev' || tab$ || 'Affil Name1' || tab$ || 'Affil Name2' || tab$ ||
	'Department' || tab$ || 'Affil Type' || tab$ || 'Mail Stop' || tab$ ||
	'User PO Box' || tab$ || 'Address1' || tab$ || 'Address2' || tab$ ||
	'Address3' || tab$ || 'Affil PO Box' || tab$ || 'Town' || tab$ ||
	'Postal Code' || tab$ || 'Zip Code' || tab$ || 'Country Code' || tab$ ||
	'Country Name' || tab$ || 'Region');

      if NOT common.repo_is_remote then
         htp.prn (tab$ || 'Email Address');
      end if;

      if this_conference.count = 1 and this_conference(1) is null then
	 sql_stmt := 'where 1 = 1 ';
	 show_mlist_hdr;
      else
	 sql_stmt := ' where ' || common.build_in_list (this_conference, 'conference_code') || ') ';
	 sql_stmt := 'where p.person_id in (select person_id from mailing_lists ' || sql_stmt;
      end if;

      sql_stmt := 'select p.person_id, p.lname, p.fname, p.mname, p.initials, ' ||
			'p.country_code, affil.affil_abbrev, affil.name1, ' ||
			'affil.name2, affil.department, affil.affil_type_code, ' ||
			'pro.mail_stop, pro.po_box, addr.address1, addr.address2, ' ||
			'addr.address3, addr.po_box, addr.town, addr.postal_code, ' ||
			'addr.zip_code, addr.country_code, email_address ' ||
		'from affiliations affil, addresses addr, profiles pro, persons p ' ||
		sql_stmt ||
			'and pro.person_id = p.person_id ' ||
			'and pro.deleted is null ' ||
			'and pro.current_address = ''Y'' ' ||
			'and addr.address_id = pro.address_id ' ||
			'and affil.affiliation_id = addr.affiliation_id ' ||
			'and affil.affiliation_id = common.get_user_primary_affil_id (p.person_id)';
      open driver for sql_stmt;
      LOOP
	 fetch driver into driver_rec;
	 exit when driver%NOTFOUND;

	 affil_type_descr	:= common.decode_value ('affil_type_descr', 'affil_type_codes',
						'affil_type_code', driver_rec.affil_type_code);
	 country_descr		:= common.decode_value ('country_descr', 'country_codes',
						'country_code', driver_rec.country_code);
	 citizenship_descr	:= common.decode_value ('country_descr', 'country_codes',
						'country_code', driver_rec.citizenship);
	 region_descr		:= common.decode_value ('region_descr', 'region_codes', 'region_code',
						common.decode_value ('region_code', 'country_codes',
									'country_code', driver_rec.country_code) );

        htp.prn (crlf$);
	htp.prn (
		driver_rec.lname 	|| tab$	||
		driver_rec.fname	|| tab$	||
		driver_rec.mname	|| tab$	||
		driver_rec.initials	|| tab$	||
		driver_rec.citizenship	|| tab$	||
		citizenship_descr	|| tab$	||
		driver_rec.affil_abbrev	|| tab$	||
		driver_rec.name1	|| tab$	||
		driver_rec.name2	|| tab$	||
		driver_rec.department	|| tab$	||
		affil_type_descr	|| tab$	||
		driver_rec.mail_stop	|| tab$	||
		driver_rec.user_po_box	|| tab$	||
		driver_rec.address1	|| tab$	||
		driver_rec.address2	|| tab$	||
		driver_rec.address3	|| tab$	||
		driver_rec.affil_po_box	|| tab$	||
		driver_rec.town		|| tab$	||
		driver_rec.postal_code	|| tab$	||
		driver_rec.zip_code	|| tab$	||
		driver_rec.country_code	|| tab$	||
		country_descr		|| tab$	||
		region_descr);

         if NOT common.repo_is_remote then
            htp.prn (tab$ || driver_rec.email_address);
         end if;


	 if this_conference.count = 1 and this_conference(1) is null then
	    get_mlist (driver_rec.person_id);
	 end if;

      end loop;
      close driver;
   end if;

end xls;

-- **********************************************************************************************

procedure mailing_lists is

begin

   if common.header ('Mailing Lists') then
      htp.anchor ('repository.xls', 'Affiliations Mailing List (Excel File)');
      htp.para;

      htp.formOpen ('profile.xls', 'POST');
      htp.p ('You may select multiple conferences to combine the lists into one extract.');
      htp.p (common.space2$);
      htp.p ('Select no conference to extract all profile data..');
      htp.para;
      htp.bold ('Select mailing list(s): ');
      htp.br;
      common.show_popup_list ('conference', multiple=>true);
      htp.para;
      htp.formSubmit (null, 'Profile Mailing List (Excel File)');
      htp.formClose;
   end if;
   common.footer;

end mailing_lists;

-- **********************************************************************************************
-- **********************************************************************************************

procedure log_activity (this_activity varchar2) is

begin

   insert into activities (person_id, activity_code, activity_date, ip_address, updated_by)
   values (common.gbl_pid, this_activity, common.get_UTC_time,
	nvl (owa_util.get_cgi_env ('HTTP_X_FORWARDED_FOR'),
		owa_util.get_cgi_env ('REMOTE_ADDR') ),
	nvl (common.gbl_priv_pid, common.gbl_pid) );

end log_activity;

-- **********************************************************************************************

function JACoW_account_exists (uid varchar2, pid integer) return boolean is

cursor driver is
select	person_id
from	persons
where	user_id = upper (uid);

rec_found boolean;
person_id integer;

begin

   if upper (uid) = 'JACOW' then
      return true;
   end if;

   open driver;
   fetch driver into person_id;
   rec_found := driver%FOUND;
   close driver;

   if person_id = pid then -- OK editing existing account
      return false;
   end if;

   return rec_found;

end JACoW_account_exists;

-- *********************************************************************************************

function JACoW_account_exists (pid integer) return boolean is

cursor	driver is
select	1
from	all_users
where	username =
(	select user_id
	from persons
	where person_id = pid);

rec_found boolean;
dummy integer;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end JACoW_account_exists;

-- *********************************************************************************************
-- *********************************************************************************************

function OK_to_edit_person_rec return boolean is

cursor driver is
select	1
from	persons
where	person_id = common.gbl_pid;

dummy integer;
rec_found boolean;

begin

   if common.user_is_JACoW_admin then
      return true;
   end if;

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end OK_to_edit_person_rec;

-- *********************************************************************************************

function OK_to_edit_profile_rec (prof_id integer) return boolean is

cursor driver is
select	1
from	profiles
where	profile_id	= prof_id
and	person_id	= common.gbl_pid;

dummy integer;
rec_found boolean;

begin

   if prof_id is null then
      return true;
   end if;

   if common.user_is_JACoW_admin then
      return true;
   end if;

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end OK_to_edit_profile_rec;

-- *********************************************************************************************

function profile_count (pid integer) return integer is

cursor driver is
select	count(1)
from	profiles
where	person_id = pid
and	deleted is null;

icount integer;

begin

   open driver;
   fetch driver into icount;
   close driver;

   return nvl (icount, 0);

end profile_count;

-- *********************************************************************************************
-- *********************************************************************************************

procedure show_profile_header (show_select boolean, show_invitee boolean default false,
show_abstract boolean default false) is

begin

   htp.tableOpen ('BORDER', cattributes=>'CELLPADDING="5"');
   htp.tableRowOpen ('LEFT', 'BOTTOM');

   if show_invitee then
      htp.tableHeader ('Invite');

   elsif show_select then
      htp.tableHeader ('Select');

   end if;

   htp.tableHeader ('Full Name');
   htp.tableHeader ('Initials');
   htp.tableHeader ('Affiliation');
   htp.tableHeader ('Email Address');

   if show_abstract then
      htp.tableHeader ('Abstracts');
   end if;

end show_profile_header;

-- *********************************************************************************************

procedure show_abstract_list (pid integer) is

cursor driver is
select	abstract_id,
	common.get_paper_id (abstract_id) paper_id
from	abstracts
where	person_id = pid
UNION
select	abstract_id,
	common.get_paper_id (abstract_id) paper_id
from	abstracts
where	abstract_id in
(	select	abstract_id
	from	authors
	where	profile_id in
	(	select	profile_id
		from	profiles
		where	person_id = pid
)	);

buffer long := null;
sep_chr varchar2(2) := null;

begin

   for driver_rec in driver LOOP
      buffer := buffer || sep_chr ||
		htf.anchor ('JACoW.edit_abstract_editor?abs_id=' || driver_rec.abstract_id,
		nvl (driver_rec.paper_id, driver_rec.abstract_id) );
      sep_chr := ', ';
   end loop;

   htp.p (nvl (buffer, common.space$));

end show_abstract_list;

-- *********************************************************************************************

procedure show_acct_info (pid integer, show_select boolean, selected varchar2,
				show_invitee boolean default false,
				select_account boolean default false,
				show_abstract boolean default false) is

invitee persons.invitee%TYPE;
user_id persons.user_id%TYPE;

begin

   htp.tableRowOpen ('LEFT', 'TOP');

   if select_account then
      user_id := common.decode_value ('user_id', 'persons', 'person_id', pid);
      user_id := nvl (user_id, pid);
      htp.tableData (htf.anchor ('javascript:setAccount(''' || user_id || ''')', user_id));

   elsif show_invitee then
      invitee := nvl (common.decode_value ('invitee', 'persons', 'person_id', pid), 'N');
      htp.tableData (htf.formHidden ('pid', pid) || common.popup_yes_no ('invite', invitee) );

   elsif show_select then
      htp.tableData (htf.formRadio ('pid', pid, selected), 'CENTER');

   end if;

   htp.tableData (common.get_user_name (pid));
   htp.tableData (common.decode_value ('initials', 'persons', 'person_id', pid) );
   htp.tableData (common.get_user_affil_list (pid));
   htp.tableData (replace (common.get_user_email (pid), ',', ', '));

   if show_abstract then
      htp.p ('<TD>');
      show_abstract_list (pid);
      htp.p ('</TD>');
   end if;

   htp.tableRowClose;

end show_acct_info;

-- *********************************************************************************************

procedure show_profile (pid integer, show_select boolean) is

begin

   htp.tableRowOpen ('LEFT', 'TOP');

   if show_select then
      htp.tableData (htf.formRadio ('pid', pid), 'CENTER');
   end if;

   htp.tableData (common.get_user_name (pid));
   htp.tableData (common.get_user_affil_list (pid));
   htp.tableRowClose;

end show_profile;

-- *********************************************************************************************
-- *********************************************************************************************

procedure merge3 (old_pid integer, new_pid integer) is

cursor driver is
select	*
from	profiles
where	person_id = old_pid;

cursor c2 (aid integer) is
select	*
from	profiles
where	person_id	= new_pid
and	address_id	= aid;

new_rec c2%ROWTYPE;

begin

   update activities set person_id = new_pid where person_id = old_pid;
   update activities set updated_by = new_pid where updated_by = old_pid;
   update logs set person_id = new_pid where person_id = old_pid;
   update abstracts set person_id = new_pid where person_id = old_pid;
   update abstracts set editor_id = new_pid where editor_id = old_pid;
   update affil_requests set requestor_id = new_pid where requestor_id = old_pid;

   update JN_abstracts set person_id = new_pid where person_id = old_pid;
   update JN_abstracts set editor_id = new_pid where editor_id = old_pid;
   update JN_abstracts set withdrawn_by = new_pid where withdrawn_by = old_pid;

   update mail_blats set person_id = new_pid where person_id = old_pid;
   update mail_blats_errors set person_id = new_pid where person_id = old_pid;
   update mail_sent_blats set person_id = new_pid where person_id = old_pid;
   update registrations set person_id = new_pid where person_id = old_pid;
   update merge_logs set merged_by = new_pid where merged_by = old_pid;

   update registrations set person_id = new_pid where person_id = old_pid;
   update payments set person_id = new_pid where person_id = old_pid;
   update credit_cards set person_id = new_pid where person_id = old_pid;
   update checkbox_items set person_id = new_pid where person_id = old_pid;

   update conf_roles
   set	 person_id = new_pid
   where person_id = old_pid
   and NOT exists
	(select	1 from conf_roles
	 where person_id = old_pid);

   delete from conf_roles where person_id = old_pid;

-- **********

   update	registrants r1
   set		person_id = new_pid
   where	person_id = old_pid
   and		not exists
	(	select	1
		from	registrants r2
		where	r2.person_id	= new_pid
		and	r2.page_id	= r1.page_id);

   delete from registrants where person_id = old_pid;

-- **********

   update	email_logs
   set		person_id = new_pid
   where	person_id = old_pid
   and		email_id NOT in
	(	select	email_id
		from	email_logs
		where	person_id = new_pid);

   delete from email_logs where person_id = old_pid;

-- **********

   update	mailing_lists
   set		person_id = new_pid
   where	person_id = old_pid
   and		conference_code NOT in
	(	select	conference_code
		from	mailing_lists
		where	person_id = new_pid);

   delete from mailing_lists where person_id = old_pid;

-- **********

   update	person_memberships
   set		person_id = new_pid
   where	person_id = old_pid
   and		membership_code NOT in
	(	select	membership_code
		from	person_memberships
		where	person_id = new_pid);

   delete from person_memberships where person_id = old_pid;

-- **********

   update	user_functions
   set		person_id = new_pid
   where	person_id = old_pid
   and		function_code NOT in
	(	select	function_code
		from	user_functions
		where	person_id = new_pid);

   delete from user_functions where person_id = old_pid;

-- **********

   update	favorite_authors
   set		person_id = new_pid
   where	person_id = old_pid
   and		profile_id NOT in
	(	select	profile_id
		from	favorite_authors
		where	person_id = new_pid);

   delete from favorite_authors where person_id = old_pid;

   delete from favorite_authors where profile_id in
	(select profile_id from profiles where person_id = old_pid);

-- ********** Merge the old profiles where there is no matching affiliation on the existing profiles

   update	profiles
   set		person_id = new_pid
   where	person_id = old_pid
   and		address_id NOT in
	(	select	address_id
		from	profiles
		where	person_id = new_pid);

-- ********** Move the old profiles to the profile of the new person where the affiliation is a match

   for old_rec in driver LOOP
-- Find the matching profile on the new person record.

      open c2 (old_rec.address_id);
      fetch c2 into new_rec;
      close c2;

      update authors a1
      set	profile_id = new_rec.profile_id
      where	profile_id = old_rec.profile_id
      and	NOT exists
	(	select	1
		from	authors a2
		where	a2.abstract_id	= a1.abstract_id
		and	a2.profile_id	= new_rec.profile_id);

      delete from authors where profile_id = old_rec.profile_id;

      update	JN_authors a1
      set	profile_id = new_rec.profile_id
      where	profile_id = old_rec.profile_id
      and	NOT exists
	(	select	1
		from	JN_authors a2
		where	a2.abstract_id	= a1.abstract_id
		and	a2.profile_id	= new_rec.profile_id);

      delete from authors where profile_id = old_rec.profile_id;

      update	sessions
      set	chair_profile_id = new_rec.profile_id
      where	chair_profile_id = old_rec.profile_id;

      update	conf_roles
      set	profile_id = new_rec.profile_id
      where	profile_id = old_rec.profile_id;

      update	conf_roles
      set	profile_id = new_rec.profile_id
      where	profile_id = old_rec.profile_id;
   end loop;

   update jn_logs set person_id = new_pid where person_id = old_pid;
   update person_attributes set person_id = new_pid where person_id = old_pid;

   update conf_registrants set person_id = new_pid where person_id = old_pid;
   update conf_roles set person_id = new_pid where person_id = old_pid;

   delete from profiles where person_id	= old_pid; -- delete the duplicate profiles
   delete from persons where person_id	= old_pid; -- delete the old person id

/*
exception when others then
   dbms_output.put_line (new_pid);
   dbms_output.put_line (old_pid);
*/

end merge3;

-- *********************************************************************************************

procedure merge2 (alpha varchar2, pids common.ident_arr, pid integer) is

begin

   if common.header (rpt_title$) then
      for i in 1..pids.count LOOP
         if pids(i) <> pid then
            update	merge_logs
            set		merged_by	= common.gbl_priv_pid,
			merged_repo	= common.get_UTC_time
            where	old_person_id	= pids(i)
            and		new_person_id	= pid;

            if SQL%rowcount = 0 then
               insert into merge_logs (old_person_id, new_person_id, merged_by, merged_repo)
               values (pids(i), pid, common.gbl_priv_pid, common.get_UTC_time);

               insert into sync_merge_persons (old_person_id, new_person_id)
               values (pids(i), pid);
            end if;
         end if;
      end loop;

      for i in 1..pids.count LOOP
         if pid <> pids(i) then
            merge3 (pids(i), pid);
         end if;
      end loop;

      common.redirect_URL ('profile.maint2?alpha=' || alpha);

   end if;

end merge2;

-- *********************************************************************************************
-- *********************************************************************************************

function get_abs_ids (pid integer, edit_urls boolean default true) return varchar2 is

cursor driver is
select	a.abstract_id
from	abstracts	a,
	authors		auth,
	profiles	pro
where	pro.person_id	= pid
and	auth.profile_id	= pro.profile_id
and	a.abstract_id	= auth.abstract_id
UNION
select	abstract_id
from	abstracts
where	person_id = pid;

buffer long;

begin

   for driver_rec in driver LOOP
      buffer := buffer || ', ';

      if edit_urls then
         buffer := buffer || htf.anchor2 ('search.abs_id?aid=' || driver_rec.abstract_id,
			driver_rec.abstract_id, ctarget=>'_new');
      else
         buffer := buffer || driver_rec.abstract_id;
      end if;
   end loop;

   return (substr (buffer, 3));

end get_abs_ids;

-- *********************************************************************************************

procedure show_merge_list_header is

begin

   htp.tableHeader ('ID');
   htp.tableHeader ('Last (Family) Name');
   htp.tableHeader ('First (Given) Name');
   htp.tableHeader ('Middle Name');
   htp.tableHeader ('Initials');
   htp.tableHeader ('User ID');
   htp.tableHeader ('Email(s)');
   htp.tableHeader ('Affiliation(s)');

   if common.repo_is_remote then
      htp.tableHeader ('Abstracts');
   else
      htp.tableHeader ('Comments');
   end if;

end show_merge_list_header;

-- ***********************************************************************************************

procedure show_merge_list_data (driver_rec persons%ROWTYPE, show_checkBox boolean) is

begin

   if show_checkBox then
      htp.tableData (htf.anchor2 ('profile.maint3' ||
			'?pid=' || common.encrypt (driver_rec.person_id),
			driver_rec.person_id, ctarget=>'_new'));
   else
      htp.tableData (driver_rec.person_id);
   end if;

   htp.tableData (nvl (driver_rec.lname, common.space$));
   htp.tableData (nvl (driver_rec.fname, common.space$));
   htp.tableData (nvl (driver_rec.mname, common.space$));
   htp.tableData (nvl (driver_rec.initials, common.space$));
   htp.tableData (nvl (driver_rec.user_id, common.space$));
   htp.tableData (nvl (common.get_user_email (driver_rec.person_id, true), common.space$));
   htp.tableData (nvl (common.get_user_affil_list (driver_rec.person_id), common.space$));

   if common.repo_is_remote then
      htp.tableData (nvl (get_abs_ids (driver_rec.person_id), common.space$));
   else
      htp.tableData (driver_rec.admin_comments);
   end if;

end show_merge_list_data;

-- *********************************************************************************************

procedure merge (alpha varchar2, pids common.ident_arr) is

cursor driver (pid integer) is
select	*
from	persons
where	person_id = pid;

driver_rec	driver%ROWTYPE;
selected	varchar2(8) := 'SELECTED';

begin

   if common.header (rpt_title$) then
      if common.gbl_priv_pid = common.admin_pid$ then
         htp.header (3, 'Unable To Merge', cattributes=>common.red$);
         htp.bold ('The JACoW account may not merge, you must use your personal account.');

      elsif pids.count < 3 then
         htp.header (3, 'You must select two or more account to merge.', cattributes=>common.red$);

      else
         htp.header (3, 'Merge the following accounts into the selected acccount.');
         htp.formOpen ('profile.merge2', 'POST');
         htp.formHidden ('alpha', alpha);

         for i in 2..pids.count LOOP
            htp.formHidden ('pids', pids(i));
         end loop;

         htp.tableOpen ('BORDER');
         htp.tableRowOpen ('LEFT', 'BOTTOM');
         htp.tableHeader ('Merge');
         show_merge_list_header;
         htp.tableRowClose;

         for i in 2..pids.count LOOP
            open driver (pids(i));
            fetch driver into driver_rec;
            close driver;

            htp.tableRowOpen ('LEFT', 'TOP');
            htp.tableData (htf.formRadio ('pid', driver_rec.person_id, selected));
            show_merge_list_data (driver_rec, false);
            htp.tableRowClose;

            selected := null;
         end loop;

         htp.tableClose;
         htp.para;
         htp.formSubmit (null, 'Merge');
         htp.para;
         htp.formClose;
      end if;

      common.footer;
   end if;

end merge;

-- *********************************************************************************************
-- *********************************************************************************************

procedure maint3 (pid varchar2) is

begin

   common.gbl_pid := common.decrypt (pid);
   common.write_cookie (common.cookie_name$, common.gbl_pid);
   common.redirect_URL (repo_save_URL$);

end maint3;

-- *********************************************************************************************
-- *********************************************************************************************

procedure maint2 (alpha varchar2) is

cursor C1 is
select	*
from	persons
where	soundex_lname like alpha || '%'
order by nlssort (lname, 'NLS_SORT = Latin'),
nlssort (fname, 'NLS_SORT = Latin');

cursor C2 is
select	DISTINCT p1.*
from	persons p1,
	persons p2
where	p2.sort_lname	= p1.sort_lname
and	p2.sort_fname	= p1.sort_fname
and	p2.rowid	<> p1.rowid
order by nlssort (p1.lname, 'NLS_SORT = Latin'),
nlssort (p1.fname, 'NLS_SORT = Latin');

type person_type is table of persons%ROWTYPE index by binary_integer;
recs person_type;
prev_name varchar2(200) := '~';

begin

   if common.header (rpt_title$) then
      htp.header (3, 'Click on a User ID to Edit the Profile');
      htp.bold ('Note: Editing occurs in a new window; ' ||
		'close the window when editing is complete. ' ||
		'Click refresh/reload to see your changes.',
		cattributes=>common.red$);
      htp.para;

      if NOT common.repo_is_remote then
         htp.formOpen ('profile.merge', 'POST');
         htp.formHidden ('alpha', alpha);
         htp.formHidden ('pids', 'dummy');
      end if;

      htp.tableOpen ('BORDER');
      htp.tableRowOpen ('LEFT', 'BOTTOM');

      if NOT common.repo_is_remote then
         htp.tableHeader ('Merge');
      end if;

      show_merge_list_header;
      htp.tableRowClose;

      if alpha = '%' then
         open C2;
         fetch C2 BULK COLLECT into recs;
         close C2;
      else
         open C1;
         fetch C1 BULK COLLECT into recs;
         close C1;
      end if;

      for i in 1..recs.COUNT LOOP
         if prev_name = upper (recs(i).lname || recs(i).fname) then
            htp.tableRowOpen ('LEFT', 'TOP', cattributes=>common.highlight$);
         else
            htp.tableRowOpen ('LEFT', 'TOP');
         end if;

         if NOT common.repo_is_remote then
            htp.tableData (htf.formCheckBox ('pids', recs(i).person_id), 'CENTER');
         end if;

         show_merge_list_data (recs(i), true);
         htp.tableRowClose;

         prev_name := upper (recs(i).lname || recs(i).fname);
      end loop;


      htp.tableClose;
      if NOT common.repo_is_remote then
         htp.para;
         htp.formSubmit (null, 'Merge');
         htp.formClose;
      end if;
      common.footer;
   end if;

end maint2;

-- *********************************************************************************************

procedure maint is

cursor	driver is
select	distinct substr (soundex_lname, 1, 1) alpha
from	persons
order by 1;

begin

   if common.header (rpt_title$) then
      htp.header (3, 'Select a Letter for a List of Persons');
      for driver_rec in driver LOOP
         htp.anchor ('profile.maint2?alpha=' || driver_rec.alpha, driver_rec.alpha);
         htp.p (common.space2$);
      end loop;

      htp.para;
      common.footer;
   end if;

end maint;

-- *********************************************************************************************
-- *********************************************************************************************

procedure save_membership_codes (this_membership_code common.ident_arr,
				this_membership_number common.ident_arr) is

-- Only checked items are returned in this_membership_code,
-- all values are returned in this_membership_number

j	integer := 1;
buffer	person_memberships.membership_number%TYPE;

begin

   delete from person_memberships where person_id = common.gbl_pid;

   buffer := null;
   for i in 2..this_membership_code.count LOOP
      LOOP
         j := j + 1;
         exit when j > this_membership_number.count;
         buffer := this_membership_number(j);
         exit when this_membership_number(j) is not null;
      end loop;

      insert into person_memberships (person_id, membership_code, membership_number)
      values (common.gbl_pid, this_membership_code(i), buffer);
   end loop;

   log_activity (mbrs_updated$);

end save_membership_codes;

-- *********************************************************************************************
-- *********************************************************************************************

procedure save_addit_attr (attr common.ident_arr) is

begin

   common.get_gbl_pid;
   delete from person_attributes where person_id = common.gbl_pid;

   for i in 2..attr.count LOOP
      insert into person_attributes (person_id, attribute_code)
      values (common.gbl_pid, attr(i) );
   end loop;

   log_activity (attrib_updated$);
   common.redirect_URL (repo_save_URL$);

end save_addit_attr;

-- *********************************************************************************************
-- *********************************************************************************************

procedure save_mailing_lists_codes (this_conference_code common.ident_arr) is

begin

   delete from mailing_lists where person_id = common.gbl_pid;

   for i in 2..this_conference_code.count LOOP
      insert into mailing_lists (person_id, conference_code)
      values (common.gbl_pid, this_conference_code(i));
   end loop;

   log_activity (mail_updated$);

end save_mailing_lists_codes;

-- *********************************************************************************************
-- *********************************************************************************************

function valid_account_info (this_fname varchar2, this_lname varchar2, this_initials varchar2) return varchar2 is

err_msg varchar2(4000) := null;

begin

   if this_fname is null then
      err_msg := htf.header (3, 'You must supply a First (Given) Name.');
   end if;

   if this_lname is null then
      err_msg := err_msg || htf.header (3, 'You must supply a Last (Family) Name.');
   end if;

   if this_initials is null then
      err_msg := err_msg || htf.header (3, 'You must supply your Initials');

   elsif substr (this_initials, length (this_initials)) <> '.' then
      err_msg := err_msg || htf.header (3, 'Your Initials must end with a "."');

   end if;

   return err_msg;

end valid_account_info;

-- *********************************************************************************************

procedure email_to_db_admin (pid integer, this_addr_id integer, email varchar2, ms varchar2,
				po varchar2, phone varchar2, URL varchar2, activity varchar2) is

cursor	driver is
select	*
from	persons
where	person_id = pid;

driver_rec	driver%ROWTYPE;

buffer		long;
subject		mail_blats.subject%TYPE;
this_affil_id	constant integer := common.decode_value ('affiliation_id', 'addresses',
							'address_id', this_addr_id);
BCC		mail_blats.BCC%TYPE := null;

begin

--   if common.email_new_accounts$ = 'Y' then
--      BCC := common.editor_email$;
--   end if;

   open driver;
   fetch driver into driver_rec;
   close driver;

   if activity = prof_created$ then
      buffer := ' - New Profile';
   elsif activity = acct_created$ then
      buffer := ' - New Account';
   elsif activity = acct_updated$ then
      buffer := ' - Updated profile or account';
   elsif activity = 'COC' then
      buffer := ' - New co-author profile';
   end if;

   subject	:= common.get_user_name (driver_rec.person_id, true) || ': ' || common.conf_title$ || buffer;
   buffer	:= common.get_user_name (driver_rec.person_id, true)|| common.eol2$	||
			'Username: '	|| driver_rec.user_id	|| common.eol$	||
			'Email: '	|| trim (email)		|| common.eol2$	||
			'Affilation: '	|| common.get_affil_name (this_affil_id)|| common.eol$ ||
			'Address: '	|| common.get_address(this_addr_id, common.eol$)|| common.eol2$ ||
			'Mail Stop: '	|| trim (ms)		|| common.eol$	||
			'P.O. Box: '	|| trim (po)		|| common.eol$	||
			'Phone: '	|| trim (phone)		|| common.eol2$	||
			'Originating URL is: '			|| nvl (URL, 'Main Repository');
   send_mail (common.new_profile_email$, subject, buffer, common.editor_email$,
		null, BCC, pid=>driver_rec.person_id);

end email_to_db_admin;

-- *********************************************************************************************

function valid_uid_pwd (uid varchar2, pwd1 varchar2, pwd2 varchar2) return varchar2 is

err_msg varchar2(4000) := null;

begin

   if common.user_is_JACoW_admin then
      if uid || pwd1 || pwd2 is null then
         return null;
      end if;
   end if;

   if instr (uid, ' ') > 0 then
      err_msg := htf.header (3, 'Username can not contain spaces.');
   end if;

   if uid is null then
      err_msg := err_msg || htf.header (3, 'You must supply a username.');
   end if;

   if instr (pwd1, ' ') > 0 then
      err_msg := htf.header (3, 'Password can not contain spaces.');
   end if;

   if pwd1 is null then
      err_msg := err_msg || htf.header (3, 'You must supply a password.');
   end if;

   if pwd1 <> pwd2 then
      err_msg := err_msg || htf.header (3, 'The two passwords supplied must be the same.');
   end if;

   return err_msg;

end valid_uid_pwd;

-- *********************************************************************************************

function get_next_person_id return integer is

cursor driver is
select person_id_seq.nextval
from dual;

next_id integer;

begin

   open driver;
   fetch driver into next_id;
   close driver;

   return next_id;

end get_next_person_id;

-- *********************************************************************************************

function get_next_profile_id return integer is

cursor driver is
select profile_id_seq.nextval
from dual;

next_id integer;

begin

   open driver;
   fetch driver into next_id;
   close driver;

   return next_id;

end get_next_profile_id;

-- *********************************************************************************************
-- *********************************************************************************************

procedure show_search_results (this_lname varchar2, this_email varchar2,
				person_ids in out common.int_arr,
				show_invitee boolean default false,
				select_account boolean default false,
				show_abstract boolean default false) is

colspan$	constant varchar2(1) := '6';
selected	varchar2(8) := 'SELECTED';
arr_names	lnames;
singleName	long;
counter$	number;
size$		number;


begin

-- Exact matches

   if(instr(this_lname,'%') != 0) then
      arr_names := get_lnames(this_lname);
      size$ :=arr_names.count;
   else
      arr_names(0) := this_lname;
      size$ := 1;
   end if;

   for i in 1..person_ids.count LOOP
      counter$ :=0;
      while counter$<size$ loop
         singleName := arr_names(counter$);
         if upper(singleName) = upper (common.decode_value ('lname', 'persons', 'person_id', person_ids(i))) OR
		instr (common.get_user_email (person_ids(i)), lower(this_email)) > 0 then
            show_acct_info (person_ids(i), true, selected, show_invitee, select_account, show_abstract);
            selected := null;

            if size$ = 1 then
               person_ids.delete(i);
            end if;
         end if;

         counter$ := counter$ +1;
      end loop;

     /* show_acct_info (person_ids(i), true, selected, show_invitee, select_account, show_abstract);
      selected := null;
      person_ids.delete(i);
      end if;*/
   end loop;

   if selected is NOT null AND (this_lname is not null OR this_email is not null) then -- no exact matches found
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableHeader ('No Exact Matches Found', ccolspan=>colspan$, cattributes=>common.red$);
      htp.tableRowClose;
   end if;

-- Fuzzy matches

   if person_ids.count > 0 then
      if this_lname is not null OR this_email is not null then
         htp.tableRowOpen ('LEFT', 'TOP');
         htp.tableHeader ('The following are close matches to your search.',
				ccolspan=>colspan$, cattributes=>common.red$);
         htp.tableRowClose;
      end if;

      for i in 1..person_ids.last LOOP
         if person_ids.exists(i) then
            show_acct_info (person_ids(i), true, selected, show_invitee, select_account, show_abstract);
            selected := null;
         end if;
      end loop;
   end if;

end show_search_results;

-- *********************************************************************************************
-- *********************************************************************************************

procedure save_new_account (URL varchar2, pid integer, prof_id integer, this_user_id varchar2,
			pwd1 varchar2, pwd2 varchar2, this_lname varchar2, this_fname varchar2,
			this_mname varchar2, this_initials varchar2, this_pname varchar2,
			orig_addr_id integer, this_addr_id integer, email varchar2, ms varchar2, po varchar2,
			phone varchar2, fax varchar2, this_sort varchar2, curr common.ident_arr,
			this_country varchar2, this_time_zone varchar2, this_date_fmt varchar2,
			this_membership_code common.ident_arr, this_membership_number common.ident_arr,
			this_conference_code common.ident_arr, vendor boolean default false, this_gender varchar2) is

next_pid	integer := pid;
err_msg		varchar2(1000) := null;
activity	activity_codes.activity_code%TYPE;

begin

   if NOT vendor then
      err_msg := err_msg || valid_uid_pwd (trim (this_user_id), trim (pwd1), trim (pwd2) );
      err_msg := err_msg || valid_account_info (trim (this_fname), trim (this_lname), trim (this_initials) );

      if this_addr_id is null then
	 err_msg := err_msg || htf.header (3, 'You must select an Affiliation.');
      elsif trim (email) is null and NOT common.user_is_JACoW_admin then
	 err_msg := err_msg || htf.header (3, 'You must specifiy an email address.');
      end if;

      if JACoW_account_exists (this_user_id, null) then
	 err_msg := err_msg || htf.header (3, 'A profile with that username already exists. Please select another.');
      end if;
   end if;

   if err_msg is null then

-- If a user was a co-author but never created an account then
-- a person & profile record exists.

      common.gbl_pid := pid;
      update persons
      set user_id = trim (this_user_id),
	password = decode (this_user_id, null, null,
	gen_password_hash (this_user_id, pwd1) ),
	fname = trim (this_fname),
	mname = trim (this_mname),
	pname = trim (this_pname),
	lname = trim (this_lname),
	initials = trim (this_initials),
	country_code = this_country,
	tz_name = this_time_zone,
	date_format_code= this_date_fmt
      where person_id = pid;

      if SQL%rowcount = 0 then
	 next_pid := get_next_person_id;
	 common.gbl_pid := next_pid;

	 insert into persons (person_id, user_id, password, fname, mname, pname,
		lname, initials, country_code, tz_name, date_format_code, gender)
		values (next_pid, trim (this_user_id), gen_password_hash (this_user_id, pwd1),
		trim (this_fname), trim (this_mname), trim (this_pname), trim (this_lname),
		trim (this_initials), this_country, this_time_zone, this_date_fmt, this_gender);

-- If a new affiliation request was made while creating an account
-- then attach it to this new account.
	 update affil_requests
	 set requestor_id = next_pid
	 where ip_address = owa_util.get_cgi_env ('REMOTE_ADDR');

	 if this_user_id is null then
            activity := prof_created$;
	 else
            activity := acct_created$;
	 end if;

      else
         activity := acct_updated$;
      end if;

      log_activity (activity);
      common.write_cookie (common.cookie_name$, common.gbl_pid);

      email_to_db_admin (next_pid, this_addr_id, email, ms, po, phone, URL, activity);
      save_membership_codes (this_membership_code, this_membership_number);
      save_mailing_lists_codes (this_conference_code);

      if URL is null then -- update is from the repository web site
	 save_profile (prof_id, orig_addr_id, this_addr_id, email, ms, po, phone, fax, this_sort, curr);

	 common.public_header (rpt_title$);
	 htp.header (3, 'Your profile was created successfully.');
	 htp.formOpen (common.server || common.vdir$ || repo_save_URL$);
	 htp.formSubmit (null, 'Continue');
	 htp.formClose;
	 common.footer;

      else -- update is from a conference web site
	 repo_save_profile (common.encrypt (common.gbl_pid), common.encrypt (common.gbl_priv_pid),
		common.encrypt (URL), prof_id, orig_addr_id, this_addr_id, email, ms, po,
		phone, fax, this_sort, curr);
      end if;

   else -- there was an error message

      common.public_header (rpt_title$);
      htp.p (err_msg);
      htp.para;
      htp.p (common.click_back$);
      htp.para;
      htp.div (cattributes=>'STYLE="COLOR:RED"');
      htp.bold ('Note:');
      htp.p ('The password fields will be cleared by your browswer when you click the back button.');
      htp.p ('</DIV>');
      common.footer;

   end if;

end save_new_account;

-- *********************************************************************************************

function possible_dup_acct (pids in out common.int_arr, this_lname varchar2,
				this_fname varchar2, email varchar2) return boolean is

cursor driver is
select	person_id
from	persons
where	sort_lname	= common.sort_text (this_lname)
and	soundex (fname)	= soundex (this_fname)
UNION
select	person_id
from	profiles
where	email_address	= lower (trim (email));

rec_found boolean := false;

begin

   for driver_rec in driver LOOP
      pids(pids.count+1) := driver_rec.person_id;
      rec_found := true;
   end loop;

   return rec_found;

end possible_dup_acct;

-- *********************************************************************************************

function fmt_param (buffer varchar2) return varchar2 is

type byte_type is varray (3) of varchar2(1);
bytes byte_type := byte_type ('%', '&', '?');

string varchar2(4000) := buffer;
byte integer;

begin

   for i in 1..bytes.count LOOP
      byte := ascii (bytes(i));
      string := replace (string, bytes(i), '%' || to_char (byte, 'FM0X'));
   end loop;

   return string;

end fmt_param;

-- *********************************************************************************************

procedure hide_array (var_name varchar2, array common.ident_arr) is

begin

   for i in 1..array.count LOOP
      htp.formHidden (var_name, fmt_param (array(i)));
   end loop;

end hide_array;

-- *********************************************************************************************

function get_profile_id (this_lname varchar2, this_fname varchar2, email varchar2) return integer is

cursor driver is
select	profile_id
from	profiles		pro,
	persons			p
where	p.lname			= this_lname
and	p.fname			= this_fname
and	pro.person_id		= p.person_id
and	pro.email_address	= email
and	pro.deleted		is null;

dummy integer;

begin

   open driver;
   fetch driver into dummy;
   close driver;

   return dummy;

end get_profile_id;

-- *********************************************************************************************

procedure verify_new_account (form varchar2, URL varchar2, this_user_id varchar2,
			pwd1 varchar2, pwd2 varchar2, this_lname varchar2, this_fname varchar2,
			this_mname varchar2, this_initials varchar2, this_pname varchar2,
			orig_addr_id integer, this_addr_id integer, email varchar2, ms varchar2,
			po varchar2, phone varchar2, fax varchar2, this_sort varchar2,
			curr common.ident_arr, this_country varchar2, this_time_zone varchar2,
			this_date_fmt varchar2, this_membership_code common.ident_arr,
			this_membership_number common.ident_arr, this_conference_code common.ident_arr,
			this_gender varchar2) is

profile_id constant integer := get_profile_id (this_lname, this_fname, email);
buffer varchar2(10) := 'If your ';

begin

   if profile_id is not null then
      buffer := 'Your ';
   end if;

   htp.header (3, 'Your profile is very similiar to the profile(s) below.', cattributes=>common.red$);
   htp.p (buffer);
   htp.p ('profile is listed below please select it rather than creating a new one.');
   htp.p (common.space2$);
   htp.p ('If your affiliation and/or email address is incorrect');
   htp.p ('you will have an opportunity to correct it later.');
   htp.p (common.space2$);
   htp.p ('Our goal is to have one and only one record of each person');
   htp.p ('in our database. Your cooperation is greatly appreciated.');
   htp.para;

   if profile_id is null then
      htp.formOpen (form, 'POST');

      if URL is not null then
         htp.formHidden ('URL', common.encrypt (URL));
      end if;

      htp.formHidden ('verified', 'Y');
      htp.formHidden ('pid', '');

      if form like '%repo_%' then
         htp.formHidden ('priv_pid', common.gbl_priv_pid);
      end if;

      htp.formHidden ('prof_id', '');
      htp.formHidden ('this_user_id', fmt_param (this_user_id));
      htp.formHidden ('pwd1', fmt_param (pwd1));
      htp.formHidden ('pwd2', fmt_param (pwd2));
      htp.formHidden ('this_lname', fmt_param (this_lname));
      htp.formHidden ('this_fname', fmt_param (this_fname));
      htp.formHidden ('this_mname', fmt_param (this_mname));
      htp.formHidden ('this_initials', fmt_param (this_initials));
      htp.formHidden ('this_pname', fmt_param (this_pname));
      htp.formHidden ('orig_addr_id', orig_addr_id);
      htp.formHidden ('this_addr_id', this_addr_id);
      htp.formHidden ('email', fmt_param (email));
      htp.formHidden ('ms', fmt_param (ms));
      htp.formHidden ('po', fmt_param (po));
      htp.formHidden ('phone', fmt_param (phone));
      htp.formHidden ('fax', fmt_param (fax));
      htp.formHidden ('this_sort', fmt_param (this_sort));
      htp.formHidden ('this_gender', this_gender);

      hide_array ('curr', curr);

      htp.formHidden ('this_country', this_country);
      htp.formHidden ('this_time_zone', fmt_param (this_time_zone));
      htp.formHidden ('this_date_fmt', this_date_fmt);

      hide_array ('this_membership_code', this_membership_code);
      hide_array ('this_membership_number', this_membership_number);
      hide_array ('this_conference_code', this_conference_code);

      htp.para;
      htp.p ('My profile is not below, I wish to create my profile using the data I just entered');
      htp.formSubmit (null, 'Create My Profile');
      htp.formClose;
   end if;

end verify_new_account;

-- *********************************************************************************************

procedure new_account (verified varchar2, pid integer, prof_id integer, this_user_id varchar2,
			pwd1 varchar2, pwd2 varchar2, this_lname varchar2, this_fname varchar2,
			this_mname varchar2, this_initials varchar2, this_pname varchar2,
			orig_addr_id integer, this_addr_id integer, email varchar2, ms varchar2,
			po varchar2, phone varchar2, fax varchar2, this_sort varchar2,
			curr common.ident_arr, this_country varchar2, this_time_zone varchar2,
			this_date_fmt varchar2, this_membership_code common.ident_arr,
			this_membership_number common.ident_arr, this_conference_code common.ident_arr,
			this_gender varchar2) is

pids common.int_arr;

begin

   if common.header (rpt_title$, test_only=>true) then
      if verified = 'N' AND possible_dup_acct (pids, this_lname, this_fname, email) then
         common.public_header (rpt_title$);
         verify_new_account ('profile.new_account', null, this_user_id, pwd1, pwd2, this_lname,
				this_fname, this_mname, this_initials, this_pname, orig_addr_id,
				this_addr_id, email, ms, po, phone, fax, this_sort, curr,
				this_country, this_time_zone, this_date_fmt, this_membership_code,
				this_membership_number, this_conference_code, this_gender);

         htp.formOpen ('profile.find_user3');
         htp.tableOpen ('BORDER');
         show_search_results (this_lname, email, pids);
         htp.tableClose;
         htp.para;
         htp.formSubmit (null, 'Select Profile Above');
         htp.formClose;
         common.footer;
      else
         common.get_gbl_pid;
         post_conf_save_URL := null; -- prevent the browser from redirecting itself
         save_new_account (null, pid, prof_id, this_user_id, pwd1, pwd2, this_lname, this_fname,
				this_mname, this_initials, this_pname, orig_addr_id, this_addr_id,
				email, ms, po, phone, fax, this_sort, curr, this_country,
				this_time_zone, this_date_fmt, this_membership_code,
				this_membership_number, this_conference_code, false, this_gender);
      end if;
   end if;

end new_account;

-- *********************************************************************************************

procedure repo_new_account (verified varchar2, URL varchar2, pid integer, priv_pid varchar2,
			prof_id integer, this_user_id varchar2, pwd1 varchar2, pwd2 varchar2,
			this_lname varchar2, this_fname varchar2, this_mname varchar2,
			this_initials varchar2, this_pname varchar2, orig_addr_id integer,
			this_addr_id integer, email varchar2, ms varchar2, po varchar2, phone varchar2,
			fax varchar2, this_sort varchar2, curr common.ident_arr, this_country varchar2,
			this_time_zone varchar2, this_date_fmt varchar2,
			this_membership_code common.ident_arr, this_membership_number common.ident_arr,
			this_conference_code common.ident_arr, this_gender varchar2) is

pids	common.int_arr;
new_URL	varchar2(500) := common.decrypt (URL);

begin

   if common.valid_referer (new_URL) then
      if verified = 'N' AND possible_dup_acct (pids, this_lname, this_fname, email) then
         if common.header (rpt_title$) then
            verify_new_account ('profile.repo_new_account', new_URL, this_user_id, pwd1, pwd2,
			this_lname, this_fname, this_mname, this_initials, this_pname,
			orig_addr_id, this_addr_id, email, ms, po, phone, fax, this_sort,
			curr, this_country, this_time_zone, this_date_fmt, this_membership_code,
			this_membership_number, this_conference_code, this_gender);

            htp.tableOpen ('BORDER');
            htp.formOpen (new_URL || 'profile.find_user3');
            htp.tableOpen ('BORDER');
            show_search_results (this_lname, email, pids);
            htp.tableClose;
            htp.para;
            htp.formSubmit (null, 'Select Profile Above');
            htp.formClose;
            common.footer;
         end if;

      else
         common.gbl_priv_pid := common.decrypt(priv_pid);
         save_new_account (new_URL, pid, prof_id, this_user_id, pwd1, pwd2, this_lname, this_fname,
			this_mname, this_initials, this_pname, orig_addr_id, this_addr_id, email, ms,
			po, phone, fax, this_sort, curr, this_country, this_time_zone, this_date_fmt,
			this_membership_code, this_membership_number, this_conference_code, false, this_gender);
      end if;
   else
      invalid_referer;
   end if;

end repo_new_account;

-- *********************************************************************************************
-- *********************************************************************************************

function validate_profile_data (this_addr_id integer, email varchar2) return varchar2 is

err_msg long := null;

begin

   if this_addr_id is null then
      err_msg := err_msg || htf.header (3, 'You must select an Affiliation & Address Combination.');
   end if;

   return err_msg;

end validate_profile_data;

-- *********************************************************************************************

procedure set_current_addr_flag (prof_id integer, curr common.ident_arr) is

cursor	driver is
select	count(1)
from	profiles
where	person_id	= common.gbl_pid
and	deleted		is null;

icount integer;

begin

   open driver;
   fetch driver into icount;
   close driver;

   if curr.COUNT = 1 then -- user un-checked the curr box
      update	profiles
      set	current_address	= null
      where	profile_id	= prof_id;
   end if;

   if icount = 1 or curr.count = 2 then
      update	profiles
      set	current_address	= null
      where	person_id	= common.gbl_pid
      and	current_address	is not null;

      update	profiles
      set	current_address	= 'Y'
      where	profile_id	= prof_id;
   end if;

end set_current_addr_flag;

-- *********************************************************************************************

/* While editing a profile record the user can change their affiliation. The foreign key
address_id is on the profile record not the affiliation_id. Therefore all changes of the
address_id looks like a change in the affiliation. Howerver, if the old and new address_id
both point to the same affiliatiion then it is simply a change in address at the same
affiliation, in which case we do not create another profile record. If the change in
address_id is to a different affiliation then we create a new profile record.
*/

procedure save_profile2 (prof_id in out integer, orig_addr_id integer, this_addr_id integer,
			email varchar2, ms varchar2, po varchar2, phone varchar2, fax varchar2,
			this_sort varchar2, curr common.ident_arr) is

cursor	driver is
select	profile_id
from	profiles
where	person_id	= common.gbl_pid
and	address_id	= this_addr_id;

dup_affiliation	exception;
pragma		exception_init (dup_affiliation, -1);

orig_affil_id constant integer := common.decode_value ('affiliation_id', 'addresses', 'address_id', orig_addr_id);
this_affil_id constant integer := common.decode_value ('affiliation_id', 'addresses', 'address_id', this_addr_id);

sort_val	integer := 0;
new_profile	boolean := false;
the_prof_id	integer	:= prof_id;
driver_rec	driver%ROWTYPE;

begin

   if common.validate_number (this_sort) then
      sort_val := to_number (this_sort);
   end if;

-- When editing a profile address changes are treated as new profiles. Except when the original
-- address ID is zero. Zero represents a request for a new affiliation. Allowing updates to a profile
-- with a new request pending allows the user to continue in abstract creation and change the affiliation
-- later, without re-attaching the profile to the abstract.

   if the_prof_id is null then
      new_profile := true;
   elsif orig_affil_id = 0 then
      new_profile := false;
   elsif nvl (orig_affil_id, -1) <> this_affil_id then
      new_profile := true;
   end if;

   if new_profile then -- see if adding back a deleted profile
      open driver;
      fetch driver into driver_rec;
      close driver;

      if driver_rec.profile_id is not null then
	 the_prof_id := driver_rec.profile_id;
	 new_profile := false;
      end if;
   end if;

   if new_profile then
      select profile_id_seq.nextval into the_prof_id from dual;
      prof_id := the_prof_id;  -- must send back to the conference DB via calling routine

      insert into profiles (profile_id, person_id, address_id, email_address,
		mail_stop, po_box, phone_number, fax_number, sort_order)
      values (the_prof_id, common.gbl_pid, this_addr_id, email,
		ms, po, phone, fax, sort_val);
      log_activity (prof_created$);
   else

      update	profiles
      set	address_id	= this_addr_id,
		email_address	= email,
		mail_stop	= ms,
		po_box		= po,
		phone_number	= phone,
		fax_number	= fax,
		sort_order	= sort_val,
		deleted		= null
      where	profile_id	= the_prof_id;

      log_activity (prof_updated$);
   end if;

   set_current_addr_flag (the_prof_id, curr);

exception when dup_affiliation then null; -- user changed to an existing affiliation.

end save_profile2;

-- *********************************************************************************************
-- *********************************************************************************************

-- This routine will never execute on the conference side; only in the JACoW repository.

procedure find_save_author (pid varchar2, URL varchar2, abs_id integer, this_lname varchar2,
				this_fname varchar2, this_mname varchar2, this_initials varchar2,
				this_pname varchar2, orig_addr_id integer, this_addr_id integer,
				email varchar2, this_gender varchar2) is

err_msg	long := null;
prof_id	integer := null;
new_pid	integer;
new_URL	varchar2(500) := common.decrypt (URL);

curr common.ident_arr;

begin

   if common.valid_referer (new_URL) then
      if common.valid_pid (pid) then -- the person_id that is adding a new coauthor
	 curr(1) := 'dummy';
	 err_msg := validate_profile_data (this_addr_id, email);
	 err_msg := err_msg || valid_account_info (trim (this_fname),
	 trim (this_lname), trim (this_initials) );

	 if err_msg is NOT null then
	    common.public_header (rpt_title$);
	    htp.p (err_msg);
	    htp.para;
	    htp.p (common.click_back$);
	    htp.para;
	    common.footer;

	 else
	    prof_id := get_profile_id (this_lname, this_fname, email);

	    if prof_id is null then -- no matching profile in DB; create new one
	       new_pid := get_next_person_id;

	       insert into persons (person_id, lname, fname, mname, initials, pname, tz_name, gender)
	       values (new_pid, trim(this_lname), trim(this_fname), trim(this_mname),
			trim(this_initials), trim(this_pname), 'GMT', this_gender);

	       common.gbl_pid := new_pid; -- set the ID to the new author just created
	       common.gbl_priv_pid := common.decrypt (pid); -- set "created by" for log_activitiy routine

	       save_profile2 (prof_id, orig_addr_id, this_addr_id, email, null, null, null, null, null, curr);
	       email_to_db_admin (new_pid, this_addr_id, email, null, null, null, null, 'COC');

	       common.redirect_URL (new_URL || 'JACoW.repo_add_author' ||
				'?pid=' || pid ||
				'&prof_id=' || prof_id ||
				'&abs_id=' || abs_id);
	    else
	       common.redirect_URL (new_URL || 'JACoW.add_author' ||
				'?abs_id=' || abs_id ||
				'&pid=' || common.decrypt (new_pid));
	    end if;
	 end if;
      end if;

   else
      invalid_referer;
   end if;

end find_save_author;

-- *********************************************************************************************

procedure get_account_info (vendor boolean) is

cursor driver is
select *
from persons
where person_id = common.gbl_pid;

driver_rec driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   common.show_data_sep (2);
   common.show_data_row (common.red('Last (Family) Name*'), htf.formText ('this_lname', 40, 40, driver_rec.lname));
   common.show_data_row (common.red('First (Given) Name*'), htf.formText ('this_fname', 40, 40, driver_rec.fname));

   if NOT vendor then
      common.show_data_row ('Middle Name', htf.formText ('this_mname', 40, 40, driver_rec.mname));
      common.show_popup_table_row ('gender_code', 'gender_descr', 'gender_codes',
				'Your Gender', driver_rec.gender, var_name=>'this_gender');

      common.show_data_row (common.red('Initials of First and Middle Names*'),
	      htf.formText ('this_initials', 40, 40, driver_rec.initials) ||
			'The initials of the first and middle names are used in the author index. ' ||
			'Initials must be separated by full stops. In the example George Bernard ' ||
			'Shaw, the initials should be entered: G.B. The author index will reflect ' ||
			'this with: Shaw, G.B.' || htf.formHidden ('this_pname', driver_rec.pname));
   end if;

/* PNAME is no longer displayed for data entry. It remains as a
   hidden field and value in the event it is resurrected. */

end get_account_info;

-- *********************************************************************************************

procedure get_date_format (this_format varchar2) is

cursor driver is
select	date_format_code, to_char (sysdate, date_format_code) example
from	date_format_codes
order by 2;

selected varchar2(8) null;

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader ('Preferred Date/Time Format', 'RIGHT');

   htp.p ('<TD>');
   htp.formSelectOpen ('this_date_fmt');

   if this_format is null then
      selected := 'SELECTED';
   end if;

   htp.formSelectOption ('** Use Conference Standard **', selected, cattributes=>'VALUE=""');

   for driver_rec in driver LOOP

      selected := null;
      if driver_rec.date_format_code = this_format then
         selected := 'SELECTED';
      end if;

      htp.formSelectOption (driver_rec.example, selected,
			cattributes=>'VALUE="' || driver_rec.date_format_code || '"');
   end loop;

   htp.formSelectClose;
   htp.p ('</TD>');
   htp.tableRowClose;

end get_date_format;

-- *********************************************************************************************

procedure get_country_tz_info is

cursor driver is
select	*
from	persons
where	person_id = common.gbl_pid;

driver_rec driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   common.show_lookup_table ('COUNTRY', 'Citizenship', driver_rec.country_code);
   common.show_lookup_table ('time_zone', 'Your Time Zone', nvl (driver_rec.tz_name, 'GMT'));
   get_date_format (driver_rec.date_format_code);

end get_country_tz_info;

-- *********************************************************************************************

procedure get_membership_info is

cursor driver is
select	m.membership_code, m.membership_descr, p.person_id, p.membership_number
from	person_memberships	p,
	membership_codes	m
where	p.membership_code(+)	= m.membership_code
and	p.person_id(+)		= common.gbl_pid
order by membership_descr;

checked varchar2(7);

begin

   common.show_data_sep (2);

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader ('Select those professional organizations of which you are a member and ' ||
			'enter your membership number.', ccolspan=>'2');
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData (common.space$);
   htp.p ('<TD NOWRAP>');
   htp.formHidden ('this_membership_code', 'dummy');
   htp.formHidden ('this_membership_number', 'dummy');

   htp.tableOpen;
   htp.tableRowOpen ('LEFT', 'BOTTOM');
   htp.tableData (common.space$);
   htp.tableHeader ('Organization');
   htp.tableHeader ('Membership Number');
   htp.tableRowClose;

   for driver_rec in driver LOOP
      htp.tableRowOpen ('LEFT', 'TOP');

      checked := null;
      if driver_rec.person_id is NOT null then
         checked := 'CHECKED';
      end if;

      htp.tableData (htf.formCheckbox ('this_membership_code', driver_rec.membership_code, checked) );
      htp.tableData (driver_rec.membership_descr);
      htp.tableData (htf.formText ('this_membership_number', 20, 80, driver_rec.membership_number));
      htp.tableRowClose;
   end loop;

   htp.tableClose;

   htp.p ('</TD>');
   htp.tableRowClose;

end get_membership_info;

-- *********************************************************************************************

procedure get_mailing_lists_info is

cursor driver is
select	c.conference_code, c.conference_descr, m.person_id
from	mailing_lists		m,
	conference_codes	c
where	c.discontinued		is null
and	m.conference_code(+)	= c.conference_code
and	m.person_id(+)		= common.gbl_pid
order by c.conference_descr;

checked varchar2(7);

begin

   common.show_data_sep (2);

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader ('Select the conference series for which you wish to receive announcements.', ccolspan=>'2');
   htp.tableRowClose;

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableData (common.space$);
   htp.p ('<TD NOWRAP>');

   htp.formHidden ('this_conference_code', 'dummy');

   htp.tableOpen;
   htp.tableRowOpen ('LEFT', 'BOTTOM');
   htp.tableData (common.space$);
   htp.tableHeader ('Conference');
   htp.tableRowClose;

   for driver_rec in driver LOOP
      htp.tableRowOpen ('LEFT', 'TOP');

      checked := null;
      if driver_rec.person_id is NOT null then
         checked := 'CHECKED';
      end if;

      htp.tableData (htf.formCheckbox ('this_conference_code', driver_rec.conference_code, checked) );
      htp.tableData (driver_rec.conference_descr);
      htp.tableRowClose;
   end loop;

   htp.tableClose;

   htp.p ('</TD>');
   htp.tableRowClose;

end get_mailing_lists_info;

-- *********************************************************************************************

procedure get_user_pwd (this_username varchar2, vendor boolean, pwd_only boolean default false) is

prompt varchar2(50);

begin

   if NOT pwd_only then
      common.show_data_sep (2);

      if vendor then
         prompt := common.red('Email Address*');
      else
         prompt := common.red('User Name*');
      end if;

      common.show_data_row (prompt, htf.formText ('this_user_id', 30, 30, this_username));
   end if;

   common.show_data_row (common.red('Password*'), htf.formPassword ('pwd1', 30, 30));
   common.show_data_row (common.red('Reenter Password*'), htf.formPassword ('pwd2', 30, 30));

end get_user_pwd;

-- *********************************************************************************************

procedure get_profile_addr (email_address varchar2, mail_stop varchar2, po_box varchar2,
				phone_number varchar2, fax_number varchar2, sort_order varchar2,
				current_address varchar2, private_addr boolean default false) is

checked varchar2(7) := null;

begin

   common.show_data_row (common.red('Email*'), htf.formText ('email',30, 100, email_address) );

   if NOT private_addr then
      common.show_data_row ('Mail Stop', htf.formText ('ms', 30, 30, mail_stop) );
      common.show_data_row ('PO Box', htf.formText ('po', 10, 10, po_box) );
      common.show_data_row ('Display Order', htf.formText ('this_sort', 5, 3, sort_order) ||
	' Display order controls the order in which multiple affiliations display in author lists.');
   end if;

   common.show_data_row ('Phone', htf.formText ('phone',20, 20, phone_number) );
   common.show_data_row ('Fax', htf.formText ('fax', 20, 20, fax_number) );

   if current_address is not null then
      checked := 'CHECKED';
   end if;

   common.show_data_row ('Current Address',
   htf.formHidden ('curr', 'dummy') || htf.formCheckBox ('curr', 'Y', checked) ||
	'Check box to indicate your current mailing address.');

end get_profile_addr;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure lost_pwd3 (p integer, h number, pwd1 varchar2, pwd2 varchar2, URL varchar2) is

msg long := null;
new_URL parameters.value%TYPE := common.decrypt (URL);

begin

   msg := valid_uid_pwd ('a', pwd1, pwd2);
   if msg is null then
      common.blank_header (rpt_title$);
      update persons
      set password = gen_password_hash (user_id, pwd1)
      where person_id = p
      and password = h;

      if URL is null then
         htp.header (3, 'Password changed.');
         htp.tableOpen;
         common.show_data_row ('Name', common.get_user_name (p) );
         common.show_data_row ('Affiliation', common.get_user_affil_list (p, ', '));
         htp.tableClose;

         htp.para;
         htp.anchor ('javascript:window.close()', 'Close Window');
         htp.para;
         common.blank_footer;
      else
         common.redirect_URL (new_URL || 'profile.psync' ||
				'?pid=' || common.encrypt(p) ||
				'&code='|| prof_updated$);
      end if;
   else
      common.blank_header (rpt_title$);
      htp.p (msg);
      htp.header (3, common.click_back$);
      htp.para;
      common.blank_footer;
   end if;

end lost_pwd3;

-- ***********************************************************************************************

procedure lost_pwd2 (p integer, h number) is

cursor driver is
select	user_id
from	persons
where	person_id		= p
and	nvl (password,0)	= nvl (h, 0);

user_id persons.user_id%TYPE;
rec_found boolean;
URL parameters.value%TYPE;

begin

   if common.secure_login then
      common.public_header (rpt_title$);

      open driver;
      fetch driver into user_id;
      rec_found := driver%FOUND;
      close driver;

      if user_id is null then
         htp.header (3, 'This profile does not contain account information (i.e. no user name or password).', cattributes=>common.red$);

      elsif rec_found then
         URL := replace (common.repo_profile_URL$, 'http:', 'https:');
         htp.formOpen (URL || 'profile.lost_pwd3', 'POST', cattributes=>'NAME="SPMS"');
         htp.formHidden ('p', p);
         htp.formHidden ('h', h);
         htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));

         htp.tableOpen;
         common.show_data_row ('User ID', user_id);
         common.show_data_row ('Name', common.get_user_name (p) );
         common.show_data_row ('Affiliation', common.get_user_affil_list (p, ', '));
         get_user_pwd ('a', false, true);
         htp.tableClose;

         htp.br;
         htp.formSubmit;
         htp.formClose;
         common.form_focus ('SPMS', 'pwd1');

      else
         htp.header (3, 'Invalid Entry', cattributes=>common.red$);
      end if;

      common.footer;

   else
      common.redirect_URL (common.sserver || common.vdir$ || 'profile.lost_pwd2' || '?p=' || p || '&h=' || h);
   end if;

end lost_pwd2;

-- ***********************************************************************************************

procedure lost_pwd (pid integer) is

cursor driver is
select password
from persons
where person_id = pid;

driver_rec driver%ROWTYPE;
recipient constant mail_blats.recipient%TYPE := common.get_user_email (pid);

begin

   common.public_header (rpt_title$);

   open driver;
   fetch driver into driver_rec;
   close driver;

   if recipient is null then
      htp.header (3, 'ERROR - No Email Address');
      htp.p ('You do not have an email address on file.');

   else
      htp.header (3, 'Email Address Found');
      htp.p ('According to our records your email address is:');
      htp.bold (recipient);
      htp.p ('. You will receive an email with instructions to reset your password.');
      htp.para;

      htp.formOpen ('profile.html');
      htp.formSubmit (null, 'Login');
      htp.formClose;
      htp.para;

      send_mail (recipient, common.conf_title$ || ' Account',
		common.get_user_name (pid) || common.eol2$ ||
		'Use the following URL to reset your password. ' || common.sserver || common.vdir$ ||
		'profile.lost_pwd2?p=' || pid || '&h=' || driver_rec.password);
   end if;

   common.footer;

end lost_pwd;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure find_new_user (pid integer) is

cursor c1 is select * from persons where person_id = pid;
cursor c2 is select * from profiles where person_id = pid and deleted is null;
cursor c3 (AID integer) is select affiliation_id from addresses where address_id = AID;

c1_rec C1%ROWTYPE;
c2_rec C2%ROWTYPE;
affil_id integer;

begin

   open c1;
   fetch c1 into c1_rec;
   close c1;

   open c2;
   fetch c2 into c2_rec;
   close c2;

   open c3 (c2_rec.address_id);
   fetch c3 into affil_id;
   close c3;

   common.public_header (rpt_title$, body_open=>false);
   common.header_body_open (rpt_title$);
   common.gbl_pid := pid;
   htp.p (js$);

   htp.anchor2 (common.acct_instr$, common.font2 ('Instructions'), null, '_new');

   attrs := 'NAME="edt_profile" onSubmit="return validateAcctInfo(''N'')"';
   if common.user_is_JACoW_admin then
      attrs := 'NAME="edt_profile" onSubmit="return validateAcctInfo(''Y'')"';
   end if;

   if common.repo_is_remote then -- Conference DB; updates to profile in repo only
      htp.formOpen (common.repo_profile_URL$ || 'profile.repo_new_account', 'POST', cattributes=>attrs);
      htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
      htp.formHidden ('priv_pid', common.encrypt (common.gbl_priv_pid));
   else
      htp.formOpen ('profile.new_account', 'POST', cattributes=>attrs);
   end if;

   if nvl (pid, 0) = 0 then
      htp.formHidden ('verified', 'N');
   else
      htp.formHidden ('verified', 'Y');
   end if;

   htp.formHidden ('pid', pid);
   htp.formHidden ('prof_id', c2_rec.profile_id);
   htp.tableOpen;

   get_user_pwd (c1_rec.user_id, false);
   get_account_info (false);
   show_affil_addr_popup (c2_rec.address_id, false);
   common.show_data_sep (2);
   get_profile_addr (c2_rec.email_address, c2_rec.mail_stop, c2_rec.po_box,
			c2_rec.phone_number, c2_rec.fax_number, c2_rec.sort_order,
			c2_rec.current_address);

   get_country_tz_info;
   get_membership_info;
   get_mailing_lists_info;

   common.show_data_row (common.red ('* Required Fields'), htf.formSubmit);

   htp.tableClose;
   htp.formClose;
   htp.para;
   common.footer;

end find_new_user;

-- *********************************************************************************************

procedure find_new_author (abs_id integer) is

begin

   common.public_header (rpt_title$);
   htp.p (js$);

   htp.formOpen (common.repo_profile_URL$ || 'profile.find_save_author', 'POST',
		cattributes=>'NAME="edt_profile" onSubmit="return validateAuthor()"');
   htp.formHidden ('pid', common.encrypt (nvl (common.gbl_priv_pid, common.gbl_pid)));
   htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));

   htp.formHidden ('abs_id', abs_id);
   htp.tableOpen;

   common.gbl_pid := null; -- clear for next 2 routines.
   get_account_info (false);
   show_affil_addr_popup (null, false);
   common.show_data_row (common.red('Email*'), htf.formText ('email',30, 100) );
   common.show_data_row ('* Fields in RED are required.', htf.formSubmit);

   htp.tableClose;
   htp.formClose;
   common.footer;

end find_new_author;

-- *********************************************************************************************
-- *********************************************************************************************

procedure find_user3 (pid integer) is

cursor driver is
select	*
from	persons
where	person_id = pid;

driver_rec driver%ROWTYPE;
rec_found boolean;

begin

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if rec_found AND driver_rec.user_id is null then -- profile exists but no JACoW account

      common.redirect_URL ('profile.find_new_user?pid=' || pid);

   elsif common.has_privs_to_page (common.jacow_admin$, false) then
      manage;

   else
      common.public_header (rpt_title$);

      show_profile_header (false);
      show_acct_info (pid, false, 'SELECTED');
      htp.tableClose;

      htp.para;
      htp.p ('Your username is: ');
      htp.bold (driver_rec.user_id);

      htp.p (common.space2$);
      htp.anchor ('profile.lost_pwd?pid=' || pid, 'I Forgot my password.');
      htp.para;

      htp.formOpen (common.server || common.vdir$ || 'profile.html');
      htp.formSubmit (null, 'Logon To Your Account');
      htp.formClose;
      common.footer;

   end if;

end find_user3;

-- *********************************************************************************************
-- *********************************************************************************************

function find_search_db (this_lname varchar2, this_email varchar2,
string varchar2 default null, attr common.ident_arr) return common.int_arr is

type	cursor_type is REF CURSOR;
driver	cursor_type;
l_data	long := null;
start$	number default 0;
size$	number default 1;
index$	number default 1;
word	long := null;

Q$	constant varchar2(1) := chr(39);
Q2$	constant varchar2(2) := Q$||Q$;

person_ids	common.int_arr;
lname		long := Q$ || replace (trim (this_lname), Q$, Q2$) || Q$;
email		long := Q$ || trim (this_email) || Q$;
str		long := Q$ || trim (string) || Q$;

sql_stmt	long := null;
union_txt	varchar2(10) := null;
select_count	integer := 0;
dummy		common.ident_arr;
dummyQuery	long := null;

begin

   if trim (this_lname) is not null then

     start$ :=1;
     sql_stmt := 'select sort_lname, sort_fname, sort_mname, person_id from persons where ';
     loop
        word := common.stringTokenizer(this_lname, start$ , '%') ;
        lname := Q$ || replace (trim (word), Q$, Q2$) || Q$;
        exit when word is null;

        sql_stmt := sql_stmt || ' sort_lname = common.sort_text (' || lname || ') ' ||
			'or soundex_lname = soundex (' || lname || ') or';
        start$ := start$ +1;
     end loop;

     if(instr(sql_stmt,'or',-1,1) != 0) then
        size$ := length(sql_stmt);
        index$ := instr(sql_stmt,'or',-1,1);
        sql_stmt := substr(sql_stmt,1,index$-1);
      end if;

      union_txt := ' UNION ';
      select_count := select_count + 1;
   end if;

   if trim (this_email) is not null then
      sql_stmt := sql_stmt || union_txt ||
		'select sort_lname, sort_fname, sort_mname, p.person_id ' ||
		'from persons p, ' ||
		' profiles pro ' ||
		'where pro.email_address = lower (' || email || ') ' ||
		'and pro.deleted is null ' ||
		'and p.person_id = pro.person_id';
      union_txt := ' UNION ';
      select_count := select_count + 1;
   end if;

   if trim (string) is not null then
      sql_stmt := sql_stmt || union_txt ||
		'select sort_lname, sort_fname, sort_mname, p.person_id ' ||
		'from persons p, ' ||
		' profiles pro, ' ||
		' addresses addr, ' ||
		' affiliations affil ' ||
		'where affil.affiliation_id >= 0 ' ||
		'and p.person_id = pro.person_id ' ||
		'and pro.address_id = addr.address_id ' ||
		'and pro.deleted is null ' ||
		'and addr.affiliation_id = affil.affiliation_id ' ||
		'and ( contains (affil.search_text, ' || str || ', 1) > 0 OR ' ||
		' contains (addr.search_text, ' || str || ', 2) > 0 ) ';
      union_txt := ' UNION ';
      select_count := select_count + 1;
   end if;

   if attr.COUNT > 1 then
      sql_stmt := sql_stmt || union_txt ||
		'select sort_lname, sort_fname, sort_mname, p.person_id ' ||
		'from persons p, ' ||
		' person_attributes a ' ||
		'where p.person_id = a.person_id ' ||
		'and ' || common.build_in_list (attr, 'a.attribute_code');
   end if;

   if select_count = 1 then
      sql_stmt := replace (sql_stmt, 'select', 'select distinct');
   end if;

   if(sql_stmt is not null) then
      sql_stmt := sql_stmt || ' order by sort_lname, sort_fname, sort_mname';

      open driver for SQL_STMT;
         fetch driver BULK COLLECT into dummy, dummy, dummy, person_ids;
      close driver;
   end if;
   return person_ids;

end find_search_db;

-- *********************************************************************************************

procedure find_user2 (this_lname varchar2, this_email varchar2) is

person_ids common.int_arr;

begin

   common.public_header (rpt_title$);
   person_ids := find_search_db (this_lname, this_email, null, MT_arr);

   if person_ids.count > 0 then
      htp.header (3, 'The following profiles match your search criteria.');
      htp.formOpen ('profile.find_user3', 'POST');
      show_profile_header (true);
      show_search_results (this_lname, this_email, person_ids);
      htp.tableClose;
      htp.para;

      htp.bold ('Attention:', cattributes=>common.red$);
      htp.p ('If your profile');
      htp.bold ('is in the list above');
      htp.p ('but the affiliation is wrong, please');
      htp.bold ('do not create a new profile.', cattributes=>common.red$);
      htp.p (common.space$);
      htp.p ('Instead, select your profile above, you will have an opportunity to enter');
      htp.p ('the correct affiliation on the next screen.');
      htp.para;

      htp.formSubmit (null, 'Select Above');
      htp.formClose;
   else
      htp.header (3, 'No profiles matched your search criteria.');
   end if;

   htp.anchor ('profile.find_new_user?pid=', 'Create a New Profile');
   htp.p (common.space2$ || common.space2$ || common.space2$ || common.space2$);
   htp.anchor (common.server || common.vdir$ || 'profile.html', 'Search Again');
   htp.para;

   common.footer;

end find_user2;

-- *********************************************************************************************
-- *********************************************************************************************

procedure find_invite3 (pid common.ident_arr, invite common.ident_arr) is

begin

   common.get_gbl_pid;

   if NOT common.editing_as_jacow_admin then
      for i in 1..pid.count LOOP
         update persons
         set invitee = invite(i)
         where person_id = pid(i)
         and nvl(invitee,'N') <> invite(i);
      end loop;

      common.public_header (rpt_title2$);
      htp.header (3, 'Update Complete');

      htp.anchor ('profile.find_invite', 'Add New Invitees');
      htp.p (common.space2$);
      htp.anchor ('reports.show_invitees', 'Show All Invitees');
      htp.para;
      common.footer;

   end if;

end find_invite3;

-- *********************************************************************************************
-- *********************************************************************************************

procedure find_repo3 (pid integer) is

begin

   common.get_gbl_pid;

   if NOT common.editing_as_jacow_admin then

-- Normally, this cookie's value is the session id, however the user logged in is an
-- administrator. In this case the cookie's value is the person_id of the account
-- being editid by the administrator.

      common.write_cookie (common.cookie_name$, pid);
      common.redirect_URL (repo_save_URL$);
   end if;

end find_repo3;

-- *********************************************************************************************
-- *********************************************************************************************

procedure find_invite2 (this_lname varchar2, this_email varchar2, string varchar2) is

selected varchar2(8) := 'SELECTED';
person_ids common.int_arr;

begin

   common.public_header (rpt_title2$);
   person_ids := find_search_db (this_lname, this_email, string, MT_arr);

   if person_ids.count > 0 then
      htp.header (3, 'The following profiles match your search criteria.');
      htp.formOpen ('profile.find_invite3', 'POST');
      show_profile_header (true);
      show_search_results (this_lname, this_email, person_ids, show_invitee=>true);
      htp.tableClose;
      htp.para;
      htp.formSubmit (null, 'Select Profile Above');
      htp.formClose;

   else
      htp.header (3, 'No profiles matched your search criteria.');
   end if;

   htp.anchor (common.server || common.vdir$ || 'profile.find_invite', 'Search Again');
   htp.para;

   common.footer;

end find_invite2;

-- *********************************************************************************************

procedure find_repo2 (this_lname varchar2, this_email varchar2, string varchar2, attr common.ident_arr) is

selected varchar2(8) := 'SELECTED';
person_ids common.int_arr;

begin

   if common.header (rpt_title$) then
      person_ids := find_search_db (this_lname, this_email, string, attr);

      if person_ids.count > 0 then
         htp.header (3, 'The following profiles match your search criteria.');
         htp.formOpen ('profile.find_repo3', 'POST');
         show_profile_header (true, show_abstract=>true);
         show_search_results (this_lname, this_email, person_ids, show_abstract=>true);
         htp.tableClose;
         htp.para;
         htp.formSubmit (null, 'Select Profile Above');
         htp.formClose;
      else
         htp.header (3, 'No profiles matched your search criteria.');
      end if;

      htp.anchor ('profile.find_new_user?pid=', 'Create a New Profile');
      htp.p (common.space2$ || common.space2$ || common.space2$ || common.space2$);
      htp.anchor (common.server || common.vdir$ || 'profile.find_repo', 'Search Again');
      htp.para;
      common.footer;
   end if;

end find_repo2;

-- *********************************************************************************************

procedure find_author2 (abs_id integer, this_lname varchar2, this_email varchar2) is

person_ids common.int_arr;

begin

   common.public_header (rpt_title$);
   person_ids := find_search_db (this_lname, this_email, null, MT_arr);

   if person_ids.count > 0 then

      htp.formOpen ('jacow.add_author', 'POST');
      htp.formHidden ('abs_id', abs_id);
      htp.header (3, 'The following ' || jacow.set_label ('speakers', 'authors') ||
			' match your search criteria.');
      show_profile_header (true);
      show_search_results (this_lname, this_email, person_ids);
      htp.tableClose;
      htp.para;

      htp.formSubmit (null, 'Use Selected ' || jacow.set_label ('Speaker', 'Author') );
      htp.formClose;

      htp.bold ('Attention:', cattributes=>common.red$);
      htp.p ('If the ' || jacow.set_label ('speaker', 'co-author') || ' you seek');
      htp.bold ('is in the list above');
      htp.p ('but the affiliation is wrong, please');
      htp.bold ('do not create a new ' || jacow.set_label ('speaker', 'author.'), cattributes=>common.red$);
      htp.p (common.space$);
      htp.p ('Instead, select the individual above, you will have an opportunity to enter the correct');
      htp.p ('affiliation on the next screen.');

   else
      htp.header (3, 'No ' || jacow.set_label ('speakers', 'authors') || ' matched your search criteria.');
   end if;

   htp.tableOpen;
   htp.tableRowOpen;

   htp.p ('<TD>');

   htp.formOpen ('profile.find_new_author', 'POST');
   htp.formHidden ('abs_id', abs_id);
   htp.formSubmit (null, 'Create a new ' || jacow.set_label ('speaker', 'author') );
   htp.formClose;
   htp.para;
   htp.p ('</TD>');

   htp.p ('<TD>');
   htp.formOpen (common.server || common.vdir$ || 'profile.find_author');
   htp.formHidden ('abs_id', abs_id);
   htp.formSubmit (null, 'Search Again');
   htp.formClose;
   htp.p ('</TD>');

   htp.tableRowClose;
   htp.tableClose;

   common.footer;

end find_author2;

-- *********************************************************************************************
-- *********************************************************************************************

procedure show_attrib_fields (pid integer default common.gbl_pid) is

cursor driver is
select	pa.person_id, a.attribute_code, a.attribute_descr
from	person_attributes	pa,
	attribute_codes		a
where	pa.attribute_code(+)	= a.attribute_code
and	pa.person_id(+)		= pid
order by
a.attribute_descr;

checked varchar2(7);

begin

   for driver_rec in driver LOOP
      checked := null;
      if driver_rec.person_id is not null then
         checked := 'CHECKED';
      end if;
      common.show_data_row (htf.formCheckbox ('attr', driver_rec.attribute_code, checked),
				driver_rec.attribute_descr);
   end loop;

end show_attrib_fields;

-- *********************************************************************************************

procedure show_find_form (admin_fields boolean default false, attrib_fields boolean default false) is

begin

   htp.tableOpen;
   common.show_data_row ('Last (Family) Name', htf.formText ('this_lname', 40, 40) );
   common.show_data_row ('Email Address', htf.formText ('this_email', 40, 100) );

   if admin_fields then
      common.show_data_row ('Affiliation Search String',
      htf.formText ('string', 50, 200) );
   end if;

   if attrib_fields then
      htp.formHidden ('attr', 'dummy');
      show_attrib_fields (0);
   end if;

   common.show_data_row (null, htf.formSubmit (null, 'Search') );

   htp.tableClose;
   htp.formClose;
   common.form_focus ('FIND', 'this_lname');
   htp.para;

end show_find_form;

-- *********************************************************************************************

procedure find_invite is

begin

   if common.header (rpt_title2$) then
      htp.anchor ('reports.show_invitees', 'List All Invitiees');
      htp.para;
      htp.tableOpen;
      htp.tableRowOpen ('LEFT', 'TOP');

      htp.p ('<TD>');
         htp.header (3, 'Option 1 - Search the JACoW Database for existing persons.');
         htp.formOpen ('profile.find_invite2', 'POST', cattributes=>'NAME="FIND"');
         show_find_form (true);
      htp.p ('</TD>');

      htp.p ('<TD>');
         htp.header (3, 'Option 2 - Bulk Load Invitees via Email Addresses');
         htp.p ('Enter each invitees'' email address; one per line.');
         htp.br;
         htp.formOpen ('profile.invitee_load', 'POST');
         htp.formTextArea ('emails', 10, 30);
         htp.br;
         htp.formSubmit;
         htp.formClose;
      htp.p ('</TD>');

      htp.tableRowClose;
      htp.tableClose;
      common.footer;
   end if;

end find_invite;

-- *********************************************************************************************
-- *********************************************************************************************

procedure invitee_load (emails varchar2) is

cursor driver (email varchar2) is
select	rowid, common.get_user_name (person_id) name,
	common.get_user_affil_list(person_id) affil
from	persons
where	person_id in
(	select	person_id
	from	profiles
	where	email_address = lower (email)
and	deleted is null
)
order by
sort_lname, sort_fname, sort_mname;

email_list long := trim (emails);
email_addr varchar2(200);
buffer long;
icount integer;

begin


   if common.header (rpt_title2$) then
      htp.header (3, 'The following individuals are now set as invitees.');
      htp.tableOpen ('BORDER');

      LOOP
         exit when email_list is null;
         email_addr := common.get_next_token (email_list, common.crlf$);

         buffer := null;
         icount := 0;
         for driver_rec in driver (email_addr) LOOP
            update persons
            set invitee = 'Y'
            where rowid = driver_rec.rowid;

            if icount > 0 then
               buffer := buffer || htf.tableRowOpen ('LEFT', 'TOP');
            end if;

            buffer := buffer || htf.tableData (driver_rec.name, cnowrap=>'NOWRAP');
            buffer := buffer || htf.tableData (driver_rec.affil);
            buffer := buffer || htf.tableRowClose;
            icount := icount + 1;
         end loop;

         if icount = 0 then
            icount := 1;
         end if;

         htp.tableRowOpen ('LEFT', 'TOP');
         htp.tableData (email_addr, crowspan=>icount, cnowrap=>'NOWRAP');
         htp.p (nvl (buffer, htf.tableData (common.space$) ||
         htf.tableData (common.space$) ||
         htf.tableRowClose) );
      end loop;

      htp.tableClose;
      common.footer;
   end if;

end invitee_load;

-- *********************************************************************************************
-- *********************************************************************************************

procedure find_repo is

begin

   if common.header (rpt_title$) then
      htp.header (3, 'Step 1 - Search the JACoW Database for an existing profile.');
      htp.formOpen ('profile.find_repo2', 'POST', cattributes=>'NAME="FIND"');
      show_find_form (true, true);
      common.footer;
   end if;

end find_repo;

-- *********************************************************************************************

procedure find_author (abs_id integer) is

begin

   common.public_header (rpt_title$);
   htp.header (3, 'Step 1 - Search the JACoW Database for an existing ' ||
			jacow.set_label ('speaker.', 'author.') );
   htp.formOpen ('profile.find_author2', 'POST', cattributes=>'NAME="FIND"');
   htp.formHidden ('abs_id', abs_id);
   show_find_form;
   common.footer;

end find_author;

-- *********************************************************************************************

procedure find_user is

begin

   htp.formOpen ('profile.find_user2', 'POST', cattributes=>'NAME="FIND"');
   show_find_form;

end find_user;

-- *********************************************************************************************
-- *********************************************************************************************

procedure find_account2 (this_lname varchar2, this_email varchar2) is

person_ids common.int_arr;

begin

   common.public_header (rpt_title$);
   htp.p (profile.js$);
   person_ids := find_search_db (this_lname, this_email, null, MT_arr);

   if person_ids.count > 0 then
      htp.header (3, 'The following accounts match your search criteria.');
      show_profile_header (true);
      show_search_results (this_lname, this_email, person_ids, select_account=>true);
      htp.tableClose;
      htp.para;
   else
      htp.header (3, 'No ' || jacow.set_label ('speakers', 'authors') || ' matched your search criteria.');
   end if;

   htp.formOpen (common.server || common.vdir$ || 'profile.find_account');
   htp.formSubmit (null, 'Search Again');
   htp.formClose;
   common.footer;

end find_account2;

-- *********************************************************************************************

procedure find_account is

begin

   common.public_header (rpt_title$);
   htp.formOpen ('profile.find_account2', 'POST', cattributes=>'NAME="FIND"');
   show_find_form;
   common.footer;

end find_account;

-- *********************************************************************************************
-- *********************************************************************************************

procedure find_regist3 (pid integer) is
	last_name 	persons.LNAME%TYPE;
begin

   common.get_gbl_pid;
   if common.has_privs_to_page (common.reg_admin_page$) then
      last_name:=common.decode_value('lname','persons','person_id',pid);
      regist_maint.show_search_registrants(lname=>last_name,balancedue=>'yes');
   end if;

end find_regist3;

-- *********************************************************************************************

procedure find_regist2 (this_lname varchar2, this_email varchar2, string varchar2, attr common.ident_arr) is

selected varchar2(8) := 'SELECTED';
person_ids common.int_arr;
i number;


begin

   if common.header (rpt_title$) then
      person_ids := find_search_db (this_lname, this_email, string, attr);

      if person_ids.count > 0 then
         htp.header (3, 'The following profiles match your search criteria.');
         htp.formOpen ('registration.find_regist', 'POST');
         show_profile_header (true, show_abstract=>true);
         show_search_results (this_lname, this_email, person_ids, show_abstract=>true);
         htp.tableClose;
         htp.para;
         htp.formSubmit (null, 'Select Profile Above');
         htp.formClose;
      else
         htp.header (3, 'No profiles matched your search criteria.');
      end if;

      htp.anchor (common.server || common.vdir$ || 'profile.find_regist', 'Search Again');
      htp.para;
      common.footer;
   end if;

end find_regist2;

-- *********************************************************************************************

procedure find_regist is

begin

   if common.header (rpt_title$) then
      htp.header (3, 'Step 1 - Search the JACoW Database for an existing profile.');
      htp.formOpen ('profile.find_regist2', 'POST', cattributes=>'NAME="FIND"');
      show_find_form (true, true);
      common.footer;
   end if;

end find_regist;

-- *********************************************************************************************
-- *********************************************************************************************

procedure delete_profile2 (prof_id varchar2, URL varchar2) is

-- This procedure runs on the main repository then bounces back to the conference site.

pid integer;
err_msg long := null;

integrity_constraint exception;
pragma exception_init (integrity_constraint, -2292);
new_URL parameters.value%TYPE := common.decrypt (URL);
new_prof_id integer := common.decrypt (prof_id);

begin

   pid := common.decode_value ('person_id', 'profiles', 'profile_id', new_prof_id);
   common.gbl_pid := pid;

   if OK_to_edit_profile_rec (new_prof_id) then
      if profile_count (pid) > 1 then
         delete from favorite_authors where profile_id = new_prof_id;
         delete from profiles where profile_id = new_prof_id;

      end if;

      common.redirect_URL (new_URL || 'profile.psync' ||
				'?pid=' || common.encrypt(pid) ||
				'&code='|| prof_deleted$);
   end if;

exception when integrity_constraint then
   update profiles
   set deleted = common.get_UTC_time
   where profile_id = new_prof_id;

   common.redirect_URL (new_URL || 'profile.psync' ||
			'?pid=' || common.encrypt(pid) ||
			'&code='|| prof_deleted$);

end delete_profile2;

-- *********************************************************************************************

procedure delete_profile (prof_id integer) is

pid integer;
user_id persons.user_id%TYPE;

begin

   common.public_header (rpt_title$);
   htp.header (3, 'Are you sure you wish to delete this Affiliation from your profile?');
   htp.tableOpen;
   htp.tableRowOpen;

   htp.p ('<TD>');
      htp.formOpen (common.repo_profile_URL$ || 'profile.delete_profile2', 'POST');
      htp.formHidden ('prof_id', common.encrypt (prof_id));
      htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
      htp.formSubmit (null, 'Yes');
      htp.formClose;
   htp.p ('</TD>');

   htp.p ('<TD>');
      htp.formOpen (common.server || common.vdir$ || repo_save_URL$, 'POST');
      htp.formSubmit (null, 'No');
      htp.formClose;
   htp.p ('</TD>');

   htp.tableRowClose;
   htp.tableClose;
   common.footer;

end delete_profile;

-- *********************************************************************************************
-- *********************************************************************************************

procedure save_profile (prof_id integer, orig_addr_id integer, this_addr_id integer,
			email varchar2, ms varchar2, po varchar2, phone varchar2, fax varchar2,
			this_sort varchar2, curr common.ident_arr) is

err_msg long := null;
temp_prof_id integer := prof_id;

begin

   if common.gbl_pid is null then
      common.get_gbl_pid;
   end if;

   err_msg := validate_profile_data (this_addr_id, email);

   if err_msg is null then
      save_profile2 (temp_prof_id, orig_addr_id, this_addr_id, email, ms, po, phone, fax, this_sort, curr);

      if post_conf_save_URL is not null then
	 common.redirect_URL (post_conf_save_URL);
      end if;

   else
      common.public_header (rpt_title$);
      htp.p (err_msg);
      htp.bold (common.click_back$);
      common.footer;
   end if;

end save_profile;

-- *********************************************************************************************
-- *********************************************************************************************

procedure repo_save_profile (pid varchar2, ppid varchar2, URL varchar2, prof_id integer, orig_addr_id integer,
				this_addr_id integer, email varchar2, ms varchar2, po varchar2,
				phone varchar2, fax varchar2, this_sort varchar2, curr common.ident_arr) is

new_URL varchar2(500) := common.decrypt (URL);

begin

   if common.valid_referer (new_URL) then
      if common.valid_pid (pid) then
	 -- This routine is called (via a web form) from a conference database.
	 -- Once the information is saved in the repository the browser must go back to the conference web site
	 post_conf_save_URL := new_URL || 'profile.psync?pid=' || pid || '&code=' || prof_updated$;

	 common.gbl_pid := common.decrypt (pid);
	 common.gbl_priv_pid := common.decrypt (ppid);
	 save_profile (prof_id, orig_addr_id, this_addr_id, email, ms, po, phone, fax, this_sort, curr);

      else -- invalid entry

	 common.public_header ('System Error');
	 htp.header (3, 'Invalid Person ID.');
	 htp.p ('The profile record you are attempting to edit does not exist in the repository.');
	 htp.p ('pid=' || pid);
	 htp.br;
	 common.footer;
      end if;

   else
      invalid_referer;
   end if;

end repo_save_profile;

-- *********************************************************************************************
-- *********************************************************************************************

procedure psync (pid varchar2, code varchar2) is

/*	This routine runs on the local confernece after returning from the main repository.
	Its purpose is to syncronize one person so the user sees their updates immeditally.
*/

ipid integer := common.decrypt (pid);

begin

   common.write_cookie (common.cookie_name$, ipid);
   common.gbl_pid := ipid;

   sync.one_person (ipid);

   common.public_header (rpt_title$);
   htp.header (3, 'Your information was updated successfully on the main JACoW Repository.');
   htp.bold ('Note:');
   htp.p ('During periods of heavy conference activity, your updated information');
   htp.p ('may not be immediately visible.');

   htp.formOpen (repo_save_URL$, 'POST');
   htp.formSubmit (null, 'Continue');
   htp.formClose;
   common.footer;

   log_activity (code);

end psync;

-- *********************************************************************************************
-- *********************************************************************************************

procedure check_CTX_index is

cursor C1 is
select	count(1)
from	ctxsys.dr$pending
where	exists
(	select 1
	from affiliations
	where rowid = pnd_rowid);

cursor C2 is
select	count(1)
from	ctxsys.dr$pending
where	exists
(	select 1
	from addresses
	where rowid = pnd_rowid);

dummy integer;

begin

   open C1;
   fetch C1 into dummy;
   close C1;

   if dummy > 0 then
      common.rebuild_CTX ('AFFILIATION_CTX');
   end if;

-- **********

   open C2;
   fetch C2 into dummy;
   close C2;

   if dummy > 0 then
      common.rebuild_CTX ('ADDRESS_CTX');
   end if;

end check_CTX_index;

-- ******************************************************************************************

procedure affil_search2 (string varchar2) is

cursor driver (txt varchar2) is
select	addr.address_id,
	common.get_affil_name (affil.affiliation_id, htf.br) affil_name,
	common.get_address (addr.address_id, htf.br) address
from	addresses addr,
	affiliations affil
where	addr.affiliation_id = affil.affiliation_id
and	affil.affiliation_id >= 0
and	contains (affil.search_text, txt, 1) +
	contains (addr.search_text, txt, 2) > 0
order by
score(1) + score(2) desc, 2;

TYPE rec_type is table of driver%ROWTYPE index by binary_integer;
recs rec_type;

code mail_blats_errors.error_code%TYPE;
emessage mail_blats_errors.error_message%TYPE;

begin

   dbms_application_info.set_module (owa_util.get_cgi_env ('PATH_INFO') || ' ' || string,
					owa_util.get_cgi_env ('REMOTE_ADDR'));
   check_CTX_index;

   open driver (common.fmt_search_string (string, ' NEAR '));
   fetch driver BULK COLLECT into recs;
   close driver;

   if recs.count = 0 then
      open driver (common.fmt_search_string (string, ' OR ') );
      fetch driver BULK COLLECT into recs;
      close driver;
   end if;

   common.public_header (rpt_title$);
   htp.p (js$);
   htp.p ('<SCRIPT TYPE="text/javascript" language="Javascript" type="text/javascript">');
   htp.p ('<!--');
   htp.p ('var affils = new Array();');

   for i in 1..recs.count LOOP
      recs(i).affil_name := trim (recs(i).affil_name);
      recs(i).affil_name := replace (recs(i).affil_name, '"', null);

      recs(i).address := trim (recs(i).address);
      recs(i).address := replace (recs(i).address, '"', null);

      htp.prn ('affils[');
      htp.prn (recs(i).address_id);
      htp.prn ('] = new ImageConstruct ("');
      htp.prn (recs(i).affil_name);
      htp.prn ('", "');
      htp.prn (recs(i).address);
      htp.p ('");');
   end loop;

   htp.p ('-->');
   htp.p ('</SCRIPT>');

   htp.tableOpen ('BORDER');
   for i in 1..recs.count LOOP
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData (htf.anchor ('javascript:setValue(' || recs(i).address_id || ')', 'Select') );
      htp.tableData (recs(i).affil_name || htf.br || recs(i).address);
      htp.tableRowClose;
   end loop;
   htp.tableClose;

   if recs.count = 0 then
      htp.header (3, 'No Affiliations Matched Your Search String', cattributes=>common.red$);
      htp.bold ('You many use your browswer''s back button to try again.');
   end if;

   htp.para;
   htp.bold ('Can''t find your affiliation?');
   htp.anchor ('profile.affil_req', new_affil$);
   htp.para;

   common.footer;

exception
   when others then
      code := sqlcode;
      emessage := sqlerrm;

      htp.p ('-->');
      htp.p ('</SCRIPT>');
      htp.header (3, 'An error occured when searching the database.', cattributes=>common.red$);

      if trim (string) is null then
         htp.bold ('You must enter a search string.');
      else
         htp.bold ('Please try another search string.');
         send_mail ('arenam@fnal.gov', 'SPMS Search Error',
	' Original String = ' || string || common.eol$ ||
	'Formattted String = ' || common.fmt_search_string (string) || common.eol$ ||
	' Error Code = ' || code || common.eol$ ||
	' Error Message = ' || emessage, 'arenam@fnal.gov' ||
	' Email Address = ' || common.get_user_email(common.gbl_pid) );
      end if;

      htp.br;
      htp.p (common.click_back$);
      common.footer;

end affil_search2;

-- ******************************************************************************************
-- ******************************************************************************************

procedure affil_search is

begin

   common.public_header (rpt_title$);
   htp.formOpen ('profile.affil_search2', 'POST', cattributes=>'NAME="AFFIL_SEARCH"');
   htp.header (3, 'Search for an Affiliation');
   htp.para;
   htp.bold ('Enter any portion of an Affiliation''s name then click Search.');
   htp.para;
   htp.formText ('string', 40, 200);

   htp.para;
   htp.formSubmit (null, 'Search');
   htp.formClose;
   common.form_focus ('AFFIL_SEARCH', 'string');
   common.footer;

end affil_search;

-- *********************************************************************************************
-- *********************************************************************************************

procedure set_dim (buffer varchar2, rows in out integer, cols in out integer) is

icount integer := 1;
ipos integer := 1;
prev_pos integer := 0;

begin

   if buffer is not null then
      LOOP
         ipos := instr (buffer, chr(10), 1, icount);
         exit when ipos = 0;

         icount := icount + 1;
         rows := rows + 1;
         cols := greatest (cols, ipos-prev_pos);
         prev_pos := ipos;
      end loop;

      cols := greatest (cols, length(buffer)-prev_pos);
   end if;

end set_dim;

-- *********************************************************************************************

procedure show_affil_addr_popup (this_addr_id integer, vendor boolean default false) is

cursor driver is
select	common.get_affil_name (affiliation_id, chr(10)) affil_name,
	common.get_address (address_id, chr(10)) address
from	addresses
where	address_id = this_addr_id;

driver_rec	driver%ROWTYPE;
rows		integer := 2;
cols		integer := 1;
button_name	varchar2(50);
label		varchar2(50) := 'Affiliation';
path$		constant varchar2(200) := lower (owa_util.get_cgi_env ('PATH_INFO'));

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   button_name := 'Search for Affiliation';
   if this_addr_id is null then
      rows := 5;
      cols := 50;
   else
      set_dim (driver_rec.affil_name, rows, cols);
      set_dim (driver_rec.address, rows, cols);
   end if;

   if path$ NOT in ('/profile.find_user3', '/profile.find_new_user', '/' || search_URL$) and not vendor then
      common.show_data_row (null, 'Note: Changing your affiliation on this page creates a new ' ||
		'affiliation in your profile.' || htf.br || 'To remove the ' ||
		'old affiliation click "Delete Affiliation" on the next page.');
      label := common.red('Affiliation*');
   end if;

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader (label || htf.br ||
		'<INPUT TYPE="button" VALUE="' || button_name ||
		'" onClick=''return newWindow ("profile.affil_search")''>', 'RIGHT');

   htp.p ('<TD>');
      htp.formHidden ('orig_addr_id', this_addr_id);
      htp.formHidden ('this_addr_id', this_addr_id);
      htp.formTextAreaOpen ('affil_info', rows, cols, cattributes=>'DISABLED');
      htp.p (driver_rec.affil_name);
      htp.p (driver_rec.address);
      htp.formTextAreaClose;
   htp.p ('</TD>');

   htp.tableRowClose;

end show_affil_addr_popup;

-- *********************************************************************************************

procedure edit_profile (prof_id integer) is

cursor driver is
select *
from profiles
where profile_id = prof_id;

driver_rec driver%ROWTYPE;
continue boolean := true;
buffer varchar(200) := 'Edit Your Profile';

begin

   common.get_gbl_pid;

   open driver;
   fetch driver into driver_rec;
   close driver;

   if OK_to_edit_profile_rec (prof_id) then

      if common.user_is_JACoW_admin then
         buffer := 'Edit ' || common.get_user_name (driver_rec.person_id) || '''s Profile';
      end if;

      common.public_header (rpt_title$);
      htp.p (js$);
      htp.header (3, buffer);

      attrs := 'NAME="edt_profile" onSubmit="return validateAcctInfo(''N'')"';
      if common.user_is_JACoW_admin then
         attrs := 'NAME="edt_profile" onSubmit="return validateAcctInfo(''Y'')"';
      end if;

      if common.repo_is_remote then -- Conference DB; updates to profile in repo only
         htp.formOpen (common.repo_profile_URL$ || 'profile.repo_save_profile', 'POST', cattributes=>attrs);
         htp.formHidden ('pid', common.encrypt (common.gbl_pid));
         htp.formHidden ('ppid', common.encrypt (common.gbl_priv_pid));
         htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
      else
         htp.formOpen ('profile.save_profile', 'POST', cattributes=>attrs);
      end if;

      htp.formHidden ('prof_id', prof_id);
      htp.tableOpen;

      show_affil_addr_popup (driver_rec.address_id, false);
      common.show_data_sep (2);
      get_profile_addr (driver_rec.email_address, driver_rec.mail_stop, driver_rec.po_box,
			driver_rec.phone_number, driver_rec.fax_number, driver_rec.sort_order,
			driver_rec.current_address);

      common.show_data_row (null, htf.formSubmit);

      htp.tableClose;
      htp.formClose;

      common.footer;
   else

      html; -- Don't allow editing of a profile that does not belong to the user
   end if;

end edit_profile;

-- *********************************************************************************************
-- *********************************************************************************************

procedure continue_message (buffer varchar2) is

begin

   if post_conf_save_URL = repo_save_URL$ then -- user is logged into the repository DB
      common.public_header (rpt_title$);
      htp.header (3, 'Your ' || buffer || ' Information was updated successfully.');
      htp.formOpen (post_conf_save_URL, 'POST');
      htp.formSubmit (null, 'Continue');
      htp.formClose;
      common.footer;
   else
      common.redirect_URL (post_conf_save_URL);
   end if;

end continue_message;

-- *********************************************************************************************

procedure save_account_info (	this_lname	varchar2,
				this_fname	varchar2,
				this_mname	varchar2,
				this_initials	varchar2,
				this_gender	varchar2,
				this_pname	varchar2) is

err_msg varchar2(4000) := null;

begin

   common.get_gbl_pid;
   err_msg := valid_account_info (this_fname, this_lname, trim (this_initials) );

   if err_msg is null then

      if OK_to_edit_person_rec then
         update	persons
         set	fname		= trim (this_fname),
		mname		= trim (this_mname),
		lname		= trim (this_lname),
		pname		= trim (this_pname),
		gender		= this_gender,
		initials	= trim (this_initials)
         where	person_id	= common.gbl_pid;

         log_activity (acct_updated$);
      end if;

      continue_message ('User');
   else
      common.public_header (rpt_title$);
      htp.p (err_msg);
      common.footer;
   end if;

end save_account_info;

-- *********************************************************************************************

procedure repo_save_account_info (pid varchar2, ppid varchar2, URL varchar2, this_lname varchar2,
					this_fname varchar2, this_mname varchar2,
					this_initials varchar2, this_pname varchar2,
					this_gender varchar2) is

new_URL varchar2(500) := common.decrypt (URL);

begin

   if common.valid_referer (new_URL) then
      if common.valid_pid (pid) then
         post_conf_save_URL := new_URL || 'profile.psync?pid=' || pid || '&code=' || acct_updated$;
				common.gbl_pid := common.decrypt (pid);
				common.gbl_priv_pid := common.decrypt (ppid);

         save_account_info (this_lname, this_fname, this_mname, this_initials, this_gender, this_pname);
      else -- invalid entry
         common.redirect_URL (new_URL || repo_save_URL$);
      end if;
   else
      invalid_referer;
   end if;

end repo_save_account_info;

-- *********************************************************************************************

procedure save_uidpwd (this_user_id varchar2, pwd1 varchar2, pwd2 varchar2) is

err_msg varchar2(4000) := null;

begin

   common.get_gbl_pid;

   err_msg := valid_uid_pwd (this_user_id, pwd1, pwd2);
   if JACoW_account_exists (this_user_id, common.gbl_pid) then
      err_msg := err_msg || htf.header (3, 'The username is in use on another profile.');
   end if;

   if err_msg is null then

      if OK_to_edit_person_rec then
         update persons
         set	user_id = this_user_id,
		password = gen_password_hash (this_user_id, pwd1)
         where	person_id = common.gbl_pid;

         log_activity (acct_updated$);
      end if;

      continue_message ('User');
   else
      common.public_header (rpt_title$);
      htp.p (err_msg);
      htp.p (common.click_back$);
      common.footer;
   end if;

end save_uidpwd;

-- *********************************************************************************************

procedure repo_save_uidpwd (pid varchar2, ppid varchar2, URL varchar2,
this_user_id varchar2, pwd1 varchar2, pwd2 varchar2) is

new_URL varchar2(500) := common.decrypt (URL);

begin

   if common.valid_referer (new_URL) then
      if common.valid_pid (pid) then
         post_conf_save_URL := new_URL || 'profile.psync?pid=' || pid || '&code=' || acct_updated$;
				common.gbl_pid := common.decrypt (pid);
				common.gbl_priv_pid := common.decrypt (ppid);
         save_uidpwd (this_user_id, pwd1, pwd2);
      else -- invalid entry
         common.redirect_URL (new_URL || repo_save_URL$);
      end if;
   else
      invalid_referer;
   end if;

end repo_save_uidpwd;

-- *********************************************************************************************

procedure save_country_tz_info (this_country varchar2, this_time_zone varchar2, this_date_fmt varchar2) is

begin

   common.get_gbl_pid;
   if OK_to_edit_person_rec then
      update	persons
      set	country_code		= this_country,
		tz_name			= this_time_zone,
		date_format_code	= this_date_fmt
      where	person_id		= common.gbl_pid;

      log_activity (acct_updated$);
   end if;

   continue_message ('Citizenship');

end save_country_tz_info;

-- *********************************************************************************************

procedure repo_save_country_tz_info (pid varchar2, ppid varchar2, URL varchar2, this_country varchar2,
					this_time_zone varchar2, this_date_fmt varchar2) is

new_URL varchar2(500) := common.decrypt (URL);

begin

   if common.valid_referer (new_URL) then
      if common.valid_pid (pid) then

         if this_country is null then
            common.public_header(rpt_title$);
            htp.header(3, 'You must supply your Citizenship', cattributes=>common.red$);
            htp.p(common.click_back$);
            common.footer;
         else
            post_conf_save_URL	:= new_URL || 'profile.psync?pid=' || pid || '&code=' || acct_updated$;
            common.gbl_pid	:= common.decrypt (pid);
            common.gbl_priv_pid	:= common.decrypt (ppid);
            save_country_tz_info (this_country, this_time_zone, this_date_fmt);
         end if;

      else -- invalid entry
         common.redirect_URL (new_URL || repo_save_URL$);
      end if;
   else
      invalid_referer;
   end if;

end repo_save_country_tz_info;

-- *********************************************************************************************

procedure save_membership_info (this_membership_code common.ident_arr,
this_membership_number common.ident_arr) is

begin

   common.get_gbl_pid;
   if OK_to_edit_person_rec then
      save_membership_codes (this_membership_code, this_membership_number);
   end if;

   continue_message ('Membership');

end save_membership_info;

-- *********************************************************************************************

procedure repo_save_membership_info (pid varchar2, ppid varchar2, URL varchar2,
					this_membership_code common.ident_arr,
					this_membership_number common.ident_arr) is

new_URL varchar2(500) := common.decrypt (URL);

begin

   if common.valid_referer (new_URL) then
      if common.valid_pid (pid) then
         post_conf_save_URL := new_URL || 'profile.psync?pid=' || pid || '&code=' || mbrs_updated$;
         common.gbl_pid := common.decrypt (pid);
         common.gbl_priv_pid := common.decrypt (ppid);
         save_membership_info (this_membership_code, this_membership_number);
      else -- invalid entry
         common.redirect_URL (new_URL || repo_save_URL$);
      end if;
   else
      invalid_referer;
   end if;

end repo_save_membership_info;

-- *********************************************************************************************

procedure save_mailing_lists_info (this_conference_code common.ident_arr) is

begin

   common.get_gbl_pid;
   if OK_to_edit_person_rec then
      save_mailing_lists_codes (this_conference_code);
   end if;

   continue_message ('Mailing Lists');

end save_mailing_lists_info;

-- *********************************************************************************************

procedure repo_save_mailing_lists_info (pid varchar2, ppid varchar2, URL varchar2,
this_conference_code common.ident_arr) is

new_URL varchar2(500) := common.decrypt (URL);

begin

   if common.valid_referer (new_URL) then
      if common.valid_pid (pid) then
         post_conf_save_URL := new_URL || 'profile.psync?pid=' || pid || '&code=' || mail_updated$;
         common.gbl_pid := common.decrypt (pid);
         common.gbl_priv_pid := common.decrypt (ppid);
         save_mailing_lists_info (this_conference_code);
      else -- invalid entry
         common.redirect_URL (new_URL || repo_save_URL$);
      end if;
   else
      invalid_referer;
   end if;

end repo_save_mailing_lists_info;

-- *********************************************************************************************
-- *********************************************************************************************

procedure edit_account_info is

begin

   common.public_header (rpt_title$);
   htp.p (js$);
   htp.p (common.font2 ('User Information for ' || common.get_user_name (common.gbl_pid) ) );

   attrs := 'NAME="edt_profile" onSubmit="return validateAcctInfo(''N'')"';
   if common.user_is_JACoW_admin then
      attrs := 'NAME="edt_profile" onSubmit="return validateAcctInfo(''Y'')"';
   end if;

   if common.repo_is_remote then -- Conference DB; updates to profile in repo only
      htp.formOpen (common.repo_profile_URL$ || 'profile.repo_save_account_info', 'POST', cattributes=>attrs);
      htp.formHidden ('pid', common.encrypt (common.gbl_pid));
      htp.formHidden ('ppid', common.encrypt (common.gbl_priv_pid));
      htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
   else
      htp.formOpen ('profile.save_account_info', 'POST', cattributes=>attrs);
   end if;

   htp.tableOpen;
   get_account_info (false);
   common.show_data_row (null, htf.formSubmit (null, 'Save'));
   htp.formClose;
   htp.tableClose;
   common.footer;

end edit_account_info;

-- *********************************************************************************************

procedure edit_country_tz_info is

begin

   common.public_header (rpt_title$);
   htp.p (common.font2 ('Citizenship Information for ' || common.get_user_name (common.gbl_pid) ) );

   if common.repo_is_remote then -- Conference DB; updates to profile in repo only
      htp.formOpen (common.repo_profile_URL$ || 'profile.repo_save_country_tz_info', 'POST');
      htp.formHidden ('pid', common.encrypt (common.gbl_pid));
      htp.formHidden ('ppid', common.encrypt (common.gbl_priv_pid));
      htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
   else
      htp.formOpen ('profile.save_country_tz_info', 'POST');
   end if;

   htp.tableOpen;
   get_country_tz_info;
   common.show_data_row (null, htf.formSubmit (null, 'Save'));
   htp.tableClose;
   common.footer;

end edit_country_tz_info;

-- *********************************************************************************************

procedure edit_membership_info is

begin

   common.public_header (rpt_title$);
   htp.p (common.font2 ('Membership Information for ' || common.get_user_name (common.gbl_pid) ) );

   if common.repo_is_remote then -- Conference DB; updates to profile in repo only
      htp.formOpen (common.repo_profile_URL$ || 'profile.repo_save_membership_info', 'POST');
      htp.formHidden ('pid', common.encrypt (common.gbl_pid));
      htp.formHidden ('ppid', common.encrypt (common.gbl_priv_pid));
      htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
   else
      htp.formOpen ('profile.save_membership_info', 'POST');
   end if;

   htp.tableOpen;
   get_membership_info;
   common.show_data_row (null, htf.formSubmit (null, 'Save'));
   htp.tableClose;
   common.footer;

end edit_membership_info;

-- *********************************************************************************************

procedure edit_addit_attr is

begin

   common.public_header (rpt_title$);
   htp.p (common.font2 ('Additional Attributes for ' || common.get_user_name (common.gbl_pid) ) );
   htp.formOpen ('profile.save_addit_attr', 'POST');
   htp.formHidden ('attr', 'dummy');
   htp.tableOpen;
   show_attrib_fields;
   common.show_data_row (null, htf.formSubmit (null, 'Save'));
   htp.tableClose;
   common.footer;

end edit_addit_attr;

-- *********************************************************************************************

procedure edit_mailing_lists is

begin

   common.public_header (rpt_title$);
   htp.p (common.font2 ('Mailing List Information for ' || common.get_user_name (common.gbl_pid) ) );

   if common.repo_is_remote then -- Conference DB; updates to profile in repo only
      htp.formOpen (common.repo_profile_URL$ || 'profile.repo_save_mailing_lists_info', 'POST');
      htp.formHidden ('pid', common.encrypt (common.gbl_pid));
      htp.formHidden ('ppid', common.encrypt (common.gbl_priv_pid));
      htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
   else
      htp.formOpen ('profile.save_mailing_lists_info', 'POST');
   end if;

   htp.tableOpen;
   get_mailing_lists_info;
   common.show_data_row (null, htf.formSubmit (null, 'Save'));
   htp.tableClose;
   common.footer;

end edit_mailing_lists;

-- *********************************************************************************************
-- *********************************************************************************************

procedure admin (comments varchar2) is

begin

   common.get_gbl_pid;
   common.public_header (rpt_title$);
   if NOT common.repo_is_remote then  -- repository
      if common.has_privs_to_page (common.repository_URL$, false) then
         update persons set admin_comments = comments where person_id = common.gbl_pid;
         common.redirect_URL ('profile.manage');
      end if;
   end if;
   common.footer;

end admin;

-- *********************************************************************************************
-- *********************************************************************************************

procedure edit_uidpwd is

user_id persons.user_id%TYPE;

begin

   common.public_header (rpt_title$);
   htp.p (common.font2 ('Change Username and/or Password for ' || common.get_user_name (common.gbl_pid) ) );

   if common.repo_is_remote then -- Conference DB; updates to profile in repo only
      htp.formOpen (common.repo_profile_URL$ || 'profile.repo_save_uidpwd', 'POST', cattributes=>'NAME="SPMS"');
      htp.formHidden ('pid', common.encrypt (common.gbl_pid));
      htp.formHidden ('ppid', common.encrypt (common.gbl_priv_pid));
      htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
   else
      htp.formOpen ('profile.save_uidpwd', 'POST');
   end if;

   user_id := common.decode_value ('user_id', 'persons', 'person_id', common.gbl_pid);

   htp.tableOpen;
   get_user_pwd (user_id, false);
   common.show_data_row (null, htf.formSubmit (null, 'Save'));
   htp.formClose;
   common.form_focus ('SPMS', 'this_user_id');
   htp.tableClose;
   common.footer;

end edit_uidpwd;

-- *********************************************************************************************
-- *********************************************************************************************

procedure show_membership_fields is

cursor driver is
select	membership_descr, person_id, membership_number
from	person_memberships	pm,
	membership_codes	mc
where	mc.membership_code	= pm.membership_code(+)
and	pm.person_id(+)		= common.gbl_pid
order by membership_descr;

member varchar2(3);

begin

   htp.tableOpen (cattributes=>'class="profile"');
   common.show_title_sep (2, htf.anchor
		('profile.edit_membership_info', 'Membership Information'));
   common.show_data_row ('Member', htf.bold('Affiliation'));

   for driver_rec in driver LOOP
      member := 'Yes';
      if driver_rec.person_id is null then
         member := 'No';
      end if;

      common.show_data_row (member, driver_rec.membership_descr || ' ' || driver_rec.membership_number);
   end loop;

   htp.tableClose;

end show_membership_fields;

-- *********************************************************************************************

procedure show_country_tz_fields is

cursor driver is
select	*
from	persons
where	person_id = common.gbl_pid;

driver_rec driver%ROWTYPE;
country_descr country_codes.country_descr%TYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   htp.tableOpen(cattributes=>'class="profile"');
   common.show_title_sep (2, htf.anchor
			('profile.edit_country_tz_info', 'Citizenship Information'));

   country_descr := common.decode_value ('country_descr', 'country_codes',
					'country_code', driver_rec.country_code);
   common.show_data_row ('Country', country_descr);
   common.show_data_row ('Time Zone', driver_rec.tz_name);
   common.show_data_row ('Date Format', nvl (driver_rec.date_format_code, common.date_fmt_str$) ||
			htf.br || common.local_time (sys_extract_utc (SYSTIMESTAMP)) );
   htp.tableClose;

end show_country_tz_fields;

-- *********************************************************************************************

procedure show_mailing_lists is

cursor driver is
select	l.person_id, c.conference_descr
from	mailing_lists		l,
	conference_codes	c
where	c.discontinued		is null
and	l.conference_code(+)	= c.conference_code
and	l.person_id(+)		= common.gbl_pid
order by c.conference_code;

list varchar2(3);

begin

  -- htp.tableOpen (cattributes=>'CELLPADDING="3"');
   htp.tableOpen(cattributes=>'class="profile"');
   common.show_title_sep (2, htf.anchor
			('profile.edit_mailing_lists', 'Mailing Lists'));
   common.show_data_row ('List', htf.bold ('Conference'));

   for driver_rec in driver LOOP
      list := 'Yes';
      if driver_rec.person_id is null then
         list := 'No';
      end if;

      common.show_data_row (list, driver_rec.conference_descr);
   end loop;

   htp.tableClose;

end show_mailing_lists;

-- *********************************************************************************************

procedure show_person_name_fields is

cursor driver is
select	p.*,
	(select g.gender_descr from gender_codes g where g.gender_code = p.gender) gender_descr
from	persons		p
where	person_id	= common.gbl_pid;

rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into rec;
   close driver;

   htp.tableOpen(cattributes=>'class="profile"');
   common.show_title_sep (2, htf.anchor('profile.edit_account_info', 'User Information'));

   common.show_data_row ('Last (Family) Name',	rec.lname);
   common.show_data_row ('First (Given) Name',	rec.fname);
   common.show_data_row ('Middle Name',		rec.mname);
   common.show_data_row ('Initials',		rec.initials);
   common.show_data_row ('Gender',		rec.gender_descr);
   htp.tableClose;

end show_person_name_fields;

-- *********************************************************************************************

procedure show_profiles is

cursor driver is
select	*
from	profiles
where	person_id = common.gbl_pid
and	deleted is null
order by sort_order nulls last, profile_id;

cursor	C2 is
select	admin_comments
from	persons
where	person_id = common.gbl_pid;

affil_id	integer;
profile_cnt	integer := profile_count (common.gbl_pid);
buffer		varchar2(1000) := null;
comments	persons.admin_comments%TYPE;

begin

   htp.tableOpen;
   for driver_rec in driver LOOP
      affil_id := common.decode_value ('affiliation_id', 'addresses', 'address_id', driver_rec.address_id);

      if profile_cnt > 1 then
         if affil_id = private_addr$ then
            buffer := common.space2$ ||
			htf.anchor (common.repo_profile_URL$ || 'profile.del_priv_addr' ||
			'?URL=' || common.server || common.vdir$ ||
			'&cpid=' || common.encrypt (common.gbl_pid) ||
			'&addr_id=' || driver_rec.address_id, 'Delete Private Address');
         else
            buffer := common.space2$ ||
            htf.anchor ('profile.delete_profile?prof_id=' || driver_rec.profile_id, 'Delete Affiliation');
         end if;
      end if;

      htp.tableRowOpen ('LEFT', 'TOP');
      htp.p('<th colspan=2>User Affiliation<br/>');

      if affil_id = private_addr$ then
         htp.tableRowOpen();
         htp.tableData (htf.anchor ('profile.priv_addr?addr_id=' || driver_rec.address_id,
			'Edit Private Address') || buffer, cattributes=>'colspan=2');
         htp.tableRowClose();
      else
         htp.tableRowOpen();
         htp.tableData (htf.anchor ('profile.edit_profile?prof_id=' || driver_rec.profile_id,
			'Edit Affiliation') || buffer, cattributes=>'colspan=2');
         htp.tableRowClose();
      end if;

      htp.p('</th>');
      htp.tableRowClose;

      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData (common.get_affil_name (affil_id, htf.br) || htf.br ||
		common.get_address (driver_rec.address_id, htf.br));

      htp.p ('<TD>');
      htp.tableOpen(cattributes=>'class="profile"');
			common.show_data_row ('Email Address', driver_rec.email_address);
      if affil_id <> private_addr$ then
         common.show_data_row ('Mail Stop', driver_rec.mail_stop);
         common.show_data_row ('PO Box', driver_rec.po_box);
      end if;

      common.show_data_row ('Telephone', driver_rec.phone_number);
      htp.tableClose;
      htp.p ('</TD>');
      htp.tableRowClose;
   end loop;

   htp.tableClose;

   htp.br;
   htp.bold('Note: ', cattributes=>'STYLE="COLOR:RED"');
   if profile_cnt = 1 then
      htp.p('Your profile must always contain at least one affiliation. If you have');
      htp.p('another affiliation or wish to delete this one, first create a new one then');
      htp.p('you may delete the unwanted one.');
   else
      htp.p('The order of your affiliations above will control the order they are displayed in author lists.');
      htp.br;
      htp.p('In addtion, the first affiliation will be used on');
      htp.bold('your badge at the conference.', cattributes=>'STYLE="COLOR:RED"');
      htp.p('To change the display order edit the affiliation then set the display order value.');
   end if;

   if NOT common.repo_is_remote then  -- repository
      if common.has_privs_to_page (common.repository_URL$, false) then
         open C2;
         fetch C2 into comments;
         close C2;

         htp.formOpen ('profile.admin');
         htp.bold ('Administrator Comments:');
         htp.formTextAreaOpen ('comments', 3, 50);
         htp.prn (comments);
         htp.formTextAreaClose;
         htp.formSubmit;
         htp.formClose;
      end if;
   end if;

end show_profiles;

-- *********************************************************************************************

procedure show_activity_log (pid integer) is

cursor driver is
select	*
from	activities
where	person_id = common.gbl_pid
order by activity_date desc;

begin

   htp.br;
   htp.p (common.font2 ('Activity Log'));
   htp.tableOpen ('BORDER', cattributes=>'CELLPADDING="3"');

   htp.tableRowOpen ('LEFT', 'BOTTOM');
   htp.tableHeader ('Activity');
   htp.tableHeader ('Performed By');
   htp.tableHeader ('Timestamp');
   htp.tableHeader ('IP Address');
   htp.tableRowClose;

   for driver_rec in driver LOOP
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData (common.decode_value ('activity_descr', 'activity_codes',
			'activity_code', driver_rec.activity_code) );
      htp.tableData (common.get_user_name (driver_rec.updated_by));
      htp.tableData (common.local_time (driver_rec.activity_date));
      htp.tableData (driver_rec.ip_address);
      htp.tableRowClose;
   end loop;

   htp.tableClose;

end show_activity_log;

-- *********************************************************************************************
-- *********************************************************************************************

procedure show_additional_attributes is

cursor driver is
select	pa.person_id, a.attribute_code, a.attribute_descr
from	person_attributes	pa,
	attribute_codes		a
where	pa.attribute_code(+)	= a.attribute_code
and	pa.person_id(+)		= common.gbl_pid
order by a.attribute_descr;

list varchar2(3);

begin

   htp.tableOpen (cattributes=>'class="profile"');
   common.show_title_sep (2, htf.anchor
			('profile.edit_addit_attr', 'Additional Attributes'));

   for driver_rec in driver LOOP
      list := 'Yes';
      if driver_rec.person_id is null then
         list := 'No';
      end if;

      common.show_data_row (list, driver_rec.attribute_descr);
   end loop;

   htp.tableClose;

end show_additional_attributes;

-- *********************************************************************************************
-- *********************************************************************************************

procedure authorize (pid integer, response varchar2) is

begin

   update persons
   set authorization_given = response
   where person_id = pid;

   common.redirect_URL (repo_save_URL$);

end authorize;

-- *********************************************************************************************
-- *********************************************************************************************

procedure repo_authorize (pid varchar2, URL varchar2, response varchar2) is

new_URL varchar2(500) := common.decrypt (URL);

begin

   if common.valid_referer (new_URL) then
      if common.valid_pid (pid) then
         update persons
         set	authorization_given	= response
         where	person_id		= common.decrypt (pid);

         common.redirect_URL (new_URL || 'profile.psync?pid=' || pid || '&code=' || prof_updated$);
      else
         common.redirect_URL ('profile.html');
      end if;
   else
      invalid_referer;
   end if;

end repo_authorize;

-- *********************************************************************************************
-- *********************************************************************************************

procedure affil_req_sync_complete (addr_id integer) is

cursor driver is
select	common.get_affil_name (affiliation_id, ', ', 'Y') affiliation,
	common.get_address (address_id, ', ') address
from	addresses
where	address_id = addr_id;

driver_rec driver%ROWTYPE;

begin

   if common.repo_db$ is null then
      insert into affiliations select * from repo_affiliations where affiliation_id =
		(select affiliation_id from repo_addresses where address_id = addr_id);
      insert into addresses select * from repo_addresses where address_id = addr_id;
   end if;

   open driver;
   fetch driver into driver_rec;
   close driver;

   common.public_header (new_affil$);
   htp.p (js$);
   htp.p ('<SCRIPT TYPE="text/javascript" language="Javascript" type="text/javascript">');
   htp.p ('<!--');
   htp.p ('var affils = new Array();');
   htp.p ('affils[' || addr_id || '] = new ImageConstruct ("' || driver_rec.affiliation || '", "' || driver_rec.address || '");');
   htp.p ('-->');
   htp.p ('</SCRIPT>');

   htp.header (3, 'New Affiliation Created.');
   htp.p ('<INPUT TYPE="button" VALUE="Continue" onClick="javascript:setValue(' || addr_id || ');">');
   htp.bold ('You must click the continue button to add this affiliation to your profile.', cattributes=>common.red$);
   htp.para;
   common.footer;

end affil_req_sync_complete;

-- *********************************************************************************************

function new_affil (affil common.ident_arr, this_affil_type varchar2,
		addr common.ident_arr, this_country varchar2) return integer is

affil_id integer;
addr_id integer;

begin

   select affiliation_id_seq.nextval into affil_id from dual;
   select address_id_seq.nextval into addr_id from dual;

   insert into affiliations (affiliation_id, affil_abbrev, name1, name2,
				department, web_site, affil_type_code)
   values (affil_id, trim(affil(1)), trim(affil(2)), trim(affil(3)), trim(affil(4)),
				trim(affil(5)), this_affil_type);

   insert into addresses (address_id, address1, address2, address3, po_box, town,
				postal_code, zip_code, country_code, affiliation_id)
   values (addr_id, trim(addr(1)), trim(addr(2)), trim(addr(3)),
				trim(addr(4)), trim(addr(5)), trim(addr(6)), trim(addr(7)),
				this_country, affil_id);
   return addr_id;

end new_affil;

-- *********************************************************************************************

function validate_addr (addr common.ident_arr, this_country varchar2) return varchar2 is

err_msg varchar2(4000) := null;

begin

   if trim (addr(1)) || trim (addr(2)) || trim (addr(3)) || trim (addr(4)) is null then
      err_msg := err_msg || htf.header (3, 'You must supply an address, or PO Box.');
   end if;

   if trim (addr(5)) is null then
      err_msg := err_msg || htf.header (3, 'Town is required');
   end if;

   if trim (addr(6)) is null then
      err_msg := err_msg || htf.header (3, 'Postal Code is required');
   end if;

   if trim (addr(7)) is null then
      err_msg := err_msg || htf.header (3, 'Zip Code is required');
   end if;

   if this_country is null then
      err_msg := err_msg || htf.header (3, 'You must supply the country.');
   end if;

   return err_msg;

end validate_addr;

-- *********************************************************************************************

procedure affil_req_save (pid varchar2, URL varchar2, affil common.ident_arr,
			this_affil_type varchar2, addr common.ident_arr, this_country varchar2) is

rid		integer;
addr_id		integer;
err_msg		varchar2(4000);
person_id$	constant integer := common.decrypt(pid);
return_URL	varchar2(200) := common.decrypt(URL);

begin

   if common.valid_referer (return_URL) then

      if trim (affil(2)) is null then
         err_msg := err_msg || htf.header (3, 'You must supply a name.');
      end if;

      if trim (this_affil_type) is null then
         err_msg := err_msg || htf.header (3, 'You must supply a type.');
      end if;

      err_msg := err_msg || validate_addr (addr, this_country);

      if err_msg is null then
         select affil_request_id_seq.nextval
         into	rid
         from	dual;

	 addr_id := new_affil (affil, this_affil_type, addr, this_country);
         check_CTX_index;

         insert into affil_requests (AFFIL_REQUEST_ID, REQUESTOR_ID, REQUEST_DATE, IP_ADDRESS, ADDRESS_ID)
         values (rid, nvl (person_id$, 1), common.get_UTC_time, owa_util.get_cgi_env ('REMOTE_ADDR'), addr_id);

         send_mail (common.new_affil_email$, 'New Affiliation Request',
		'A request for a new affiliation is waiting for your approval.' || common.eol2$ ||
		common.repo_profile_URL$ || 'affil_reqs.html' || common.eol2$ ||
		'Originating URL is: ' || return_URL, pid=>person_id$);

         common.redirect_URL (return_URL || 'profile.affil_req_sync_complete?addr_id=' || addr_id);

      else
         common.public_header (rpt_title$);
         htp.header (3, 'ERROR - Missing Data');
         htp.p (err_msg);
         htp.para;
         htp.p (common.click_back$);
         htp.para;
         common.footer;

      end if;

   else
      invalid_referer;
   end if;

end affil_req_save;

-- *********************************************************************************************
-- *********************************************************************************************

procedure affil_req is

begin

   common.public_header (new_affil$);

   if common.repo_is_remote then -- Conference DB; updates to profile in repo only
      htp.formOpen (common.repo_profile_URL$ || 'profile.affil_req_save',
		'POST', cattributes=>'NAME="NEW_AFFIL"');
   else
      htp.formOpen ('profile.affil_req_save', 'POST', cattributes=>'NAME="NEW_AFFIL"');
   end if;

   htp.formHidden ('pid', common.encrypt (common.gbl_pid));
   htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));

   htp.tableOpen;

   common.show_data_row (null, htf.header (3, 'Enter Your Affiliation Data'));
   repository.affil (-999, include_comment=>false);
   repository.affil_addr (-999);

   common.show_data_row (common.red ('* Required'), htf.formSubmit);
   common.show_data_row (null, 'In addition, Address or PO Box is required.');
   htp.tableClose;
   htp.formClose;
   common.form_focus ('NEW_AFFIL', 'affil(0)');

   common.footer;

end affil_req;

-- *********************************************************************************************
-- *********************************************************************************************

procedure del_person2 (pid integer) is

cursor driver is
select	count(1)
from	authors
where	profile_id in
(	select	profile_id
	from	profiles
where	person_id = pid);

cursor	C2 is
select	'delete from ' || table_name ||' where ' ||column_name || '=' || pid CMD
from	user_cons_columns
where	constraint_name in
(	select	constraint_name
	from	user_constraints
	where	r_constraint_name = 'PERSONS_PK');

icount integer;

begin

   if common.header (rpt_title$) then
      open driver;
      fetch driver into icount;
      close driver;

      if icount = 0 then
         delete from favorite_authors where profile_id in
         (select profile_id from profiles where person_id = pid);

         for C2_rec in C2 loop
            execute immediate C2_rec.CMD;
         end loop;
         delete from persons where person_id = pid;

         htp.header (3, 'Person Deleted From JACoW Repository');
         htp.formOpen ('profile.find_repo', 'POST');
         htp.formSubmit (null, 'Continue');
         htp.formClose;
      else
         htp.header (3, 'Unable to this Individual', cattributes=>common.red$);
         htp.p ('This profile is in use on ' || icount || ' contribution(s).');
         htp.para;
         htp.formOpen (repo_save_URL$, 'POST');
         htp.formSubmit (null, 'Continue');
         htp.formClose;
      end if;

      htp.para;
      common.footer;
   end if;

end del_person2;

-- *********************************************************************************************

procedure del_person (pid integer) is

begin

   if common.header (rpt_title$) then
      htp.header (3, 'Are you sure you wish to delete ' || common.get_user_name (pid) || '''s profile?');
      htp.formOpen ('profile.del_person2', 'POST');
      htp.formHidden ('pid', pid);
      htp.formSubmit (null, 'Yes');
      htp.formClose;
      common.footer;
   end if;

end del_person;

-- *********************************************************************************************
-- *********************************************************************************************

procedure check_profile_sync is

-- Check the last update dates against the main repository. Sync if necessary.

cursor conf_cursor is
select	greatest (max (p.update_date), max (pro.update_date)) last_update
from	persons		p,
	profiles	pro
where	p.person_id	= common.gbl_pid
and	pro.person_id	= p.person_id;

cursor repo_cursor is
select	greatest (max (p.update_date), max (pro.update_date)) last_update
from	REPO_persons	p,
	REPO_profiles	pro
where	p.person_id	= common.gbl_pid
and	pro.person_id	= p.person_id;

last_conf_update date;
last_repo_update date;

begin

   open conf_cursor;
   fetch conf_cursor into last_conf_update;
   close conf_cursor;

   open repo_cursor;
   fetch repo_cursor into last_repo_update;
   close repo_cursor;

   if last_repo_update > last_conf_update then
      sync.one_person (common.gbl_pid);
   end if;

end check_profile_sync;

-- *********************************************************************************************

procedure my_profile is

begin

   common.get_gbl_pid;
   common.gbl_pid := common.gbl_priv_pid;
   common.write_cookie (common.cookie_name$, common.gbl_pid);
   common.redirect_URL (repo_save_URL$);

end my_profile;

-- *********************************************************************************************

procedure visa_invite_prompt is

requires_invite	persons.requires_invitation%TYPE :=
			common.decode_value ('requires_invitation', 'persons',
			'person_id', common.gbl_pid);

begin

   if common.invite_letter$ = 'Y' then
      htp.formOpen ('profile.invite', 'POST');
      htp.p ('Do you require an invitation letter for requesting a VISA?');
      htp.p (common.radio_yes_no ('invite', NVL (requires_invite, 'N'), false) );
      htp.formSubmit;
      htp.formClose;
      htp.para;
   end if;

end visa_invite_prompt;

-- *********************************************************************************************

procedure manage2 is

URL		varchar2(500);
pwd		number;

begin

   if common.gbl_priv_pid = common.admin_pid$ and common.gbl_pid is null then
      htp.header (3, 'The JACoW Account has no profile to edit. ' ||
         'Use "Profile Maintenance" to select a profile to modify.', cattributes=>common.red$);

   elsif common.gbl_pid is not null then

--    check_profile_sync;

      if common.user_is_JACoW_admin then
         common.js$;
         htp.p('<span class=subtitle>Profile of: ' || common.get_user_name (common.gbl_pid) || '</span>');
         htp.br;
      end if;

      if common.gbl_priv_pid is null AND
         common.decode_value ('authorization_given', 'persons', 'person_id', common.gbl_pid) is null then

         if common.repo_is_remote then -- Conference DB; updates to profile in repo only
            htp.formOpen (common.repo_profile_URL$ || 'profile.repo_authorize', 'POST');
            htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
            htp.formHidden ('pid', common.encrypt (common.gbl_pid));
         else
            htp.formOpen ('profile.authorize', 'POST');
            htp.formHidden ('pid', common.gbl_pid);
         end if;

         htp.bold ('Do you authorize JACoW to use your profile information for use in JACoW supported conferences?');
         htp.br;
         htp.formRadio ('response', 'Y', 'SELECTED');
         htp.p ('Yes');
         htp.p (common.space2$);
         htp.formRadio ('response', 'N');
         htp.p ('No');
         htp.p (common.space2$);
         htp.formSubmit;
         htp.formClose;
      end if;

      htp.anchor ('profile.edit_profile?prof_id=', 'Add Another Affiliation');
      htp.p (common.space2$);

      htp.anchor ('profile.priv_addr?addr_id=', 'Add A Private Address');
      htp.p (common.space2$);

      registration.show_links (registration.show_on_profile$);

      if common.user_is_JACoW_admin then
         if NOT common.repo_is_remote then
            htp.anchor ('profile.del_person?pid=' || common.gbl_pid, 'Delete Person');
            htp.p (common.space2$);
         end if;

      elsif common.standalone_DB$ = 'Y' OR common.repo_db$ is null then
         htp.anchor (user_home_URL$, 'Manage Abstracts');
         htp.p (common.space2$);
      end if;

      pwd := common.decode_value ('password', 'persons', 'person_id', common.gbl_pid);
      URL := common.sserver || common.vdir$ || 'profile.lost_pwd2?p=' || common.gbl_pid || '&h=' || pwd;
      htp.anchor (URL, 'Change Password');
      htp.para;

-- **********

      visa_invite_prompt;
      show_profiles;
      htp.hr;

-- **********

      htp.tableOpen (cattributes=>'border=1px CELLPADDING="5"');
      htp.tableRowOpen ('LEFT', 'TOP');

      htp.p ('<TD>');
      show_person_name_fields;
      htp.p ('</TD>');

      htp.p ('<TD>');
      show_country_tz_fields;
      htp.p ('</TD>');
      htp.tableRowClose;

      htp.tableRowOpen ();
      htp.p ('<TD rowspan="2">');
      show_membership_fields;

      if common.user_is_jacow_admin then
         show_additional_attributes;
      end if;

      htp.p ('</TD>');

      htp.p ('<TD>');
      show_mailing_lists;
      htp.p ('</TD>');
      htp.tableRowClose;

      htp.tableClose;

      if common.has_privs_to_page (common.jacow_admin$, false) OR
	 common.has_privs_to_page ('affil_reqs.html', false) then
         htp.hr;
         show_activity_log (common.gbl_pid);
      end if;

   end if;

end manage2;

-- *********************************************************************************************

procedure manage is

cursor driver is
select	*
from	unavailable_times
where	common.get_UTC_time between beg_date and end_date;

driver_rec	driver%ROWTYPE;
rec_found	boolean := false;
URL		varchar2(500) := null;

begin

   URL := common.get_cookie ('URL');
   if URL is not null then
      common.write_cookie ('URL', null);
      common.redirect_URL (URL);

   else
      common.get_gbl_pid;
      common.public_header (rpt_title$);

      open driver;
      fetch driver into driver_rec;
      rec_found := driver%FOUND;
      close driver;

      if rec_found then
         htp.header (3, 'Updates to your Profile are not available.', cattributes=>common.red$);
         htp.bold ('Updates to profiles are not available from ' ||
         common.local_time (driver_rec.beg_date) || ' until ' ||
         common.local_time (driver_rec.end_date) || '.');
         htp.br;
         htp.bold ('Reason:');
         htp.bold (driver_rec.reason);
         htp.para;
      else
         manage2;
      end if;

      common.footer;
   end if;

end manage;

-- *********************************************************************************************
-- *********************************************************************************************

procedure redirect_login (URL varchar2) is

begin

   if URL is NOT null then
      common.redirect_URL (common.server(true) || common.vdir$ || URL);

   elsif common.has_privs_to_page (common.repository_URL$, false) then
      common.redirect_URL (common.server(true) || common.vdir$ || common.repository_URL$);

   elsif common.has_privs_to_page (common.editor_page$, false) then
      common.redirect_URL (common.server(true) || common.vdir$ || common.editor_page$);

   elsif common.has_privs_to_page (common.QA_page$, false) then
      common.redirect_URL (common.server(true) || common.vdir$ || common.QA_page$);

   elsif common.has_privs_to_page (common.sort_file_page$, false) then
      common.redirect_URL (common.server(true) || common.vdir$ || search_URL$);

   elsif common.repo_is_remote then -- this is a conference database
      common.redirect_URL (common.server(true) || common.vdir$ || user_home_URL$);

   else -- this is the repository database
      common.redirect_URL (common.server(true) || common.vdir$ || repo_save_URL$);

   end if;

end redirect_login;

-- *********************************************************************************************

procedure set_SPMS_privs (privs common.ident_arr, URL varchar2) is

priv_active boolean := false;

begin

   common.get_gbl_pid;
   delete from person_privs where person_id = common.gbl_pid;

   for i in 2..privs.COUNT LOOP
      insert into person_privs (person_id, privilege_code)
				values (common.gbl_pid, privs(i) );

      priv_active := true;
   end LOOP;

   if priv_active then
      owa_util.mime_header('text/html', FALSE);
      owa_cookie.send (common.cookie_priv$, common.encrypt (common.gbl_pid));
      owa_util.http_header_close;

      common.gbl_priv_pid := common.gbl_pid;
   end if;

   redirect_login (URL);

end set_SPMS_privs;

-- *********************************************************************************************

procedure prompt_SPMS_privs (URL varchar2 default null) is

cursor driver is
select	DISTINCT
	pc.privilege_code, pc.privilege_descr,
	decode (pp.person_id, null,null, 'CHECKED') checked
from	person_privs		pp,
	privilege_codes		pc,
	function_privileges	fp,
	user_functions		uf
where	uf.person_id		= common.gbl_pid
and	fp.function_code	= uf.function_code
and	pc.privilege_code	= fp.privilege_code
and	pp.person_id(+)		= common.gbl_pid
and	pp.privilege_code(+)	= pc.privilege_code
order by pc.privilege_descr;

begin

   common.public_header (rpt_title$);
   htp.formOpen ('profile.set_SPMS_privs', 'POST');
   htp.formHidden ('privs', 'dummy');
   htp.formHidden ('URL', URL);
   htp.header (3, 'Please select the privileges you want enabled');

   for driver_rec in driver LOOP
      htp.formCheckBox ('privs', driver_rec.privilege_code, driver_rec.checked);
      htp.p (driver_rec.privilege_descr);
      htp.br;
   end loop;

   htp.formSubmit;
   htp.formClose;
   common.footer;

end prompt_SPMS_privs;

-- *********************************************************************************************

procedure login_verify (URL varchar2, uid varchar2, pwd varchar2, action varchar2) is

cursor driver is
select	person_id
from	persons
where	user_id		= upper (uid)
and	password	= gen_password_hash (uid, pwd)
UNION
select	common.admin_pid$ person_id
from	control
where	'JACOW'		= upper (uid)
and	jacow_pwd	= common.encrypt (pwd);

driver_rec driver%ROWTYPE;
rec_found boolean;

begin

   if action = forgot_pwd$ then
      lost_pwd (common.get_user_PID (uid));

   elsif common.secure_login then
      open driver;
      fetch driver into driver_rec;
      rec_found := driver%FOUND;
      close driver;

      if rec_found then
         owa_util.mime_header('text/html', FALSE);
         owa_cookie.send (common.cookie_name$, common.encrypt (driver_rec.person_id) );
         common.gbl_pid := driver_rec.person_id;
         common.gbl_priv_pid := driver_rec.person_id;

         if driver_rec.person_id = common.admin_pid$ then
            owa_cookie.send (common.cookie_priv$, common.encrypt (driver_rec.person_id) );
            owa_util.http_header_close;
            redirect_login (URL);

         elsif common.privileged_user (driver_rec.person_id) then
            owa_util.http_header_close;
            prompt_SPMS_privs (URL);
         else
            owa_util.http_header_close;
            redirect_login (URL);
         end if;

      else
         common.public_header (rpt_title$);
         htp.header (3, 'Invalid Username or Password');
         htp.bold (common.click_back$);
         htp.para;
         common.footer;
      end if; -- rec_found

   else
      common.redirect_URL (common.sserver || common.vdir$ || 'profile.html');
   end if;

end login_verify;

-- *********************************************************************************************
-- *********************************************************************************************

procedure show_browswer_requirments is

begin

   htp.bold ('Browser Requirements', cattributes=>common.red$);
   htp.ulistOpen;
   htp.listItem ('Netscape 6 (or higher) or MS Internet Explorer 4 (or higher)', cattributes=>common.red$);
   htp.listItem ('Session Cookies', cattributes=>common.red$);
   htp.listItem ('JavaScript', cattributes=>common.red$);
   htp.ulistClose;

end show_browswer_requirments;

-- *********************************************************************************************
-- *********************************************************************************************

procedure new_account is

begin

   common.public_header (rpt_title$);
   htp.header (3, 'Finding a Profile');

   htp.anchor (common.repo_URL$, common.repo_URL_text$);
   htp.p ('contains profiles of authors active in the accelerator field. It is used in');
   htp.p ('connection with accelerator conference programme management, and may be');
   htp.p ('used in the form of mailing lists to inform the community of forthcoming');
   htp.p ('conferences.');
   htp.para;

   htp.p ('Please first check whether a profile has been created for you. Enter your');
   htp.p ('family name or e-mail address and use the search function below:');
   htp.ulistOpen;
   htp.listItem ('if the search result is positive, select your profile, choose a ' ||
		'username and password, verify and if necessary correct existing ' ||
		'data, and submit the form, which will ensure future access and the ' ||
		'possibility to make modifications;');
   htp.listItem ('if the search result is negative, select Create a New Profile, and ' ||
		'proceed to create a new account and associated profile.');

   htp.ulistClose;
   htp.para;

   find_user;
   show_browswer_requirments;
   common.footer;

end new_account;

-- *********************************************************************************************
-- *********************************************************************************************

procedure repo_new_vendor (URL varchar2, this_user_id varchar2, pwd1 varchar2, pwd2 varchar2,
			this_lname varchar2, this_fname varchar2, orig_addr_id number, this_addr_id number) is

cursor driver is
select	1
from	profiles
where	email_address = lower (trim (this_user_id))
and	deleted is null;

-- Note: A vendor's user ID is their email address.

null_array	common.ident_arr;
dummy		integer;
rec_found	boolean;
new_URL	varchar2(500) := URL;

begin

   if common.valid_referer (new_URL) then
      open driver;
      fetch driver into dummy;
      rec_found := driver%FOUND;
      close driver;

      if rec_found then
         common.public_header (rpt_title$);
         htp.header (3, 'This Account Already Exists', cattributes=>common.red$);
         htp.formOpen ('profile.send_password');
         htp.formHidden ('URL', 'profile.vlogin');
         htp.formSubmit (null, 'Email My Password To Me');
         common.footer;
      else
         save_new_account (new_URL, null, null, this_user_id, pwd1, pwd2,
		this_lname, this_fname, null, null, null, orig_addr_id,
		this_addr_id, this_user_id, null, null, null, null, null, null_array, null, null,
		null, null_array, null_array, null_array, true, null);
      end if;
   else
      invalid_referer;
   end if;

end repo_new_vendor;

-- *********************************************************************************************
-- *********************************************************************************************

procedure new_vendor is

begin

   common.public_header (rpt_title$);
   htp.p (js$);

   if common.acct_instr$ is not null then
      htp.anchor2 (common.acct_instr$, common.font2 ('Instructions'), null, '_new');
   end if;

   htp.formOpen (common.repo_profile_URL$ || 'profile.repo_new_vendor', 'POST',
	cattributes=>'NAME="edt_profile" onSubmit="return validateAcctInfo(''V'')"');
   htp.formHidden ('URL', common.server||common.vdir$);
   htp.tableOpen;

   get_user_pwd (null, true);
   get_account_info (true);
   show_affil_addr_popup (null, true);
   common.show_data_row (common.red ('* Required Fields'), htf.formSubmit);

   htp.tableClose;
   htp.formClose;
   htp.para;
   common.footer;

end new_vendor;

-- *********************************************************************************************
-- *********************************************************************************************

procedure del_priv_addr (URL varchar2, cpid varchar2, addr_id integer) is

cursor	driver (pid integer) is
select	1
from	conf_roles
where	profile_id	= 
	(	select	profile_id
		from	profiles
		where	person_id	= pid
		and	address_id	= addr_id);

pid$		constant integer := common.decrypt (cpid);
rec_found	boolean;
dummy		integer;

begin

   open driver (pid$);
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   if rec_found then
      update profiles
      set    deleted = sysdate
      where  person_id = pid$
      and    address_id = addr_id;
   else
      delete from profiles
      where person_id = pid$
      and address_id = addr_id;

      delete from addresses
      where address_id = addr_id;
   end if;

   common.redirect_URL (URL || 'profile.psync?pid=' || cpid || '&code=' || prof_updated$);

end del_priv_addr;

-- *********************************************************************************************
-- *********************************************************************************************

procedure priv_addr_save (URL varchar2, addr_id integer, cpid varchar2, cppid varchar2,
			email varchar2, phone varchar2, fax varchar2, curr common.ident_arr,
			addr common.ident_arr, this_country varchar2) is

err_msg		varchar2(4000);
new_addr_id	integer;
new_addr	common.ident_arr;
prof_id		integer;

begin

   err_msg := validate_addr (addr, this_country);

   if err_msg is null then
      common.gbl_pid := common.decrypt (cpid);
      common.gbl_priv_pid := common.decrypt (cppid);
      for i in 1..addr.COUNT LOOP
         new_addr(i) := trim (addr(i));
      end loop;

      if addr_id is null then -- new private address
         select address_id_seq.nextval into new_addr_id from dual;

         insert into addresses (address_id, address1, address2, address3, po_box, town,
		postal_code, zip_code, country_code, affiliation_id)
         values (new_addr_id, new_addr(1), new_addr(2), new_addr(3), new_addr(4),
		new_addr(5), new_addr(6), new_addr(7), this_country, private_addr$);

         insert into profiles (person_id, address_id, email_address,
				phone_number, fax_number)
         values (common.gbl_pid, new_addr_id, trim(email), trim(phone), trim(fax));
      else
         update	addresses
         set	address1	= new_addr(1),
		address2	= new_addr(2),
		address3	= new_addr(3),
		po_box		= new_addr(4),
		town		= new_addr(5),
		postal_code	= new_addr(6),
		zip_code	= new_addr(7),
		country_code	= this_country
         where	address_id	= addr_id;

         prof_id := common.decode_value ('profile_id', 'profiles', 'address_id', addr_id);

         update profiles
         set	email_address	= trim(email),
		phone_number	= trim(phone),
		fax_number	= trim(fax)
         where profile_id	= prof_id;
      end if;

      set_current_addr_flag (prof_id, curr);
      common.redirect_URL (URL || 'profile.psync' ||
			'?pid=' || common.encrypt(common.gbl_pid) ||
			'&code=' || prof_updated$);
   else
      common.public_header (rpt_title$);
      htp.p (err_msg);
      htp.p (common.click_back$);
      common.footer;
   end if;

end priv_addr_save;

-- *********************************************************************************************
-- *********************************************************************************************

procedure priv_addr (addr_id integer) is

cursor driver is
select	*
from	profiles
where	address_id	= addr_id
and	deleted		is null;

driver_rec driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   common.public_header (rpt_title$);
   htp.header (3, 'Private Address');

-- updates to profiles occur in the Repository, not the conference
   htp.formOpen (common.repo_profile_URL$ || 'profile.priv_addr_save', 'POST');
   htp.formHidden ('URL', common.server || common.vdir$);
   htp.formHidden ('addr_id', addr_id);
   htp.formHidden ('cpid', common.encrypt (common.gbl_pid));
   htp.formHidden ('cppid', common.encrypt (common.gbl_priv_pid));
   htp.tableOpen;

   get_profile_addr (driver_rec.email_address, driver_rec.mail_stop, driver_rec.po_box,
			driver_rec.phone_number, driver_rec.fax_number, driver_rec.sort_order,
			driver_rec.current_address, true);
   repository.affil_addr (addr_id); -- full mailing address prompts

   common.show_data_row (null, htf.formSubmit);
   htp.tableClose;
   htp.formClose;
   common.footer;

end priv_addr;

-- *********************************************************************************************
-- *********************************************************************************************

procedure login_header (URL varchar2) is

buffer varchar2(300) := null;

begin

   common.delete_cookies;
   common.public_header (rpt_title$);

   if common.login_info_URL$ is not null AND common.login_info_text$ is not null then
      htp.anchor (common.login_info_URL$, common.login_info_text$);
      htp.para;
   end if;

   htp.formOpen (common.sserver || common.vdir$ || 'profile.login_verify', 'POST',
		cattributes=>'NAME="LOGIN"');
   htp.formHidden ('URL', URL);
   htp.tableOpen;
   common.show_data_row ('Username', htf.formText ('uid', 30, 30) );
   common.show_data_row ('Password', htf.formPassword ('pwd', 30, 30) );

   if common.use_SSL$ = 'Y' then
      buffer := htf.bold ('Note: ') || 'This site uses SSL to encrypt your username and password before transmission.';
   end if;

   common.show_data_row (htf.formSubmit ('action', 'Login'), buffer);
   common.show_data_row (htf.formSubmit ('action', forgot_pwd$),
			'You must enter your username name to retrieve your password.');

   htp.tableClose;
   htp.formClose;
   common.form_focus ('LOGIN', 'uid');

   htp.hr;
   htp.bold ('Are you a new user?');
   htp.para;
   htp.p ('Every user requires an account (i.e. username and password) to access the system.');
   htp.p (common.space2$);
   htp.p (common.conf_title$);
   htp.p ('requires that you submit your PROFILE DATA when an account is created.');
   htp.p (common.space2$);
   htp.p ('Profile data is basically first and middle names, family name,');
   htp.p ('e-mail address, affiliation and other related information.');

end login_header;

-- *********************************************************************************************

procedure login (URL varchar2) is

begin

   login_header (URL);
   htp.p (common.space2$);
   htp.p ('Your profile may exist if you are a coauthor on an existing contribution.');

   htp.formOpen ('profile.new_account', 'POST');
   htp.formSubmit (null, 'Search for a Profile, Create a Profile/Account');
   htp.formClose;

   show_browswer_requirments;
   common.footer;

end login;

-- *********************************************************************************************

procedure vlogin is

buffer varchar2(300) := null;

begin

   login_header (null);
   htp.formOpen ('profile.new_vendor', 'POST');
   htp.formSubmit (null, 'New Account');
   htp.formClose;

   show_browswer_requirments;
   common.footer;

end vlogin;

-- *********************************************************************************************

procedure html is

begin

   login (null);

end html;

-- *********************************************************************************************

function get_lnames (names varchar2) return lnames is

arr_names	lnames;
counter		number := 0;
l_data		long;
size$		number := 0;
start$		number := 0;
word		long;

begin

   counter :=1;
   l_data := trim(names);
   loop
      word := common.stringTokenizer(l_data, counter , '%') ;
      arr_names(counter-1) := word;
      exit when word is null;
      counter := counter+1;
   end loop;

   return arr_names;

end get_lnames;

-- *********************************************************************************************

end profile;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
