create or replace package referee as

   procedure html;
   procedure view_abs (abs_id integer);
   procedure edit (abs_id integer);
   procedure save (abs_id integer, code varchar2, this_comment varchar2, this_note varchar2);
   procedure list_by_person;
   procedure list_by_paper;
   procedure list_missing;
   procedure dots;
   procedure all_dots;
   procedure show_abstract_log (aid integer);
   procedure show_referees (aid integer, text_only boolean default false);

   function assigned (abs_id integer) return varchar2;
   function get_dot_status (abs_id integer) return varchar2;
   function is_a_referee return boolean;
   function js$ return varchar2;
   function papers_assigned (pid integer) return integer;

end referee;
/

show error
