-- SPMS - Scientific Programme Management System
-- see at the bottom of this file for licensing
-- and copyright information

set define off

Create or Replace package reg_rpt as

   	procedure summary;
    procedure budget;
    procedure counts;
    procedure stats2;
   	procedure stats2_rpt(this_page		common.ident_arr,
			this_meta_data		common.ident_arr,
			this_poplist_id		common.ident_arr,
			this_fee_matrix_id	common.ident_arr);

	function abstract_registered (aid integer) return varchar2;


function get_fee_matrix_id_descr (ID integer, sep varchar2) return varchar2;
function get_pop_id_descr (ID integer) return varchar2;

procedure paying_summary;


end reg_rpt;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
