--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package repatriate_search as

   procedure details (abs_id integer);
   procedure results (auth varchar2, affil varchar2, keyw varchar2, present varchar2, ptype varchar2, main varchar2, sub varchar2, role varchar2, conf varchar2, srt common.ident_arr);
   procedure roles (role varchar2, conf varchar2);

   procedure html;
   procedure html (pid varchar2);

   function get_sort_name (abs_id integer, code varchar2) return varchar2;
   function get_sort_affil (abs_id integer, code varchar2) return varchar2;
   function get_conf_sdate (ID integer) return varchar2;

end repatriate_search;
/
show error
