create or replace package body SPMS as

-- ****************************************************************

procedure abstract_keywords (pid varchar2, keyword varchar2) is


begin

   insert into abstract_keywords (abstract_id, keyword_code)
   select a.abstract_id, k.keyword_code
   from   keyword_codes		k,
	  abstracts		a,
	  abstract_sessions	sa
   where  sa.paper_id		= pid
   and	  a.abstract_id		= sa.abstract_id
   and    k.keyword_descr	= keyword;

end abstract_keywords;

-- ****************************************************************

procedure xml (flag varchar2 default null) is

begin

   if flag = 'P' then
      XML2.all_papers;
   else
      XML2.full (true);
   end if;

end xml;

-- ****************************************************************

procedure ics is

begin

   calendar.publish;

end ics;

-- ****************************************************************

end SPMS;
/
show error

--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

