--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package sync as

   procedure repo;
   procedure one_person (pid integer);
   procedure initialize (rec in out conf_conferences%ROWTYPE);
   procedure set_last_sync_ID (conf_id integer, last_id integer);
   procedure merge_profile (old_profile_id integer, new_profile_id integer);
   procedure push_XML_data;

   function get_last_sync_ID (conf_id integer) return integer;
   function get_next_time return date;

end sync;
/
show error
