--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package XML2 as

cursor driver is select * from sessions;

   procedure full (full_export boolean);
   procedure session (sid varchar2);
   procedure one_session (rec driver%ROWTYPE);
   procedure all_papers;
   procedure paper (AID integer);
   procedure print_xml_fom_sql (sql_stmt varchar2, label varchar2);
   procedure author (fn varchar2, ln varchar2);
   procedure push_xml_data (conf_id number, tname varchar2, sql_stmt varchar2);

   procedure header;
   procedure footer;

end XML2;
/
show error
