-- SPMS - Scientific Programme Management System
-- see at the bottom of this file for licensing
-- and copyright information

set define off

Create or Replace PACKAGE Xtract AS

  type assoc_arr is table of varchar2(5000) index by varchar2(1024);

  procedure regstats;
  procedure attendees;

  procedure dates( chk varchar2 default '-', format varchar2 default 'csv' );
  procedure abstractsubmissions ( chk varchar2 default '-', format varchar2 default 'csv' );
  procedure filesuploaded ( chk varchar2 default '-', what varchar2 default 'papercode' );

  procedure getboothstatus(mdc varchar2, chk varchar2 default '-');


-- IMPORT procedures!

  procedure posterpolicesetstatus ( chk varchar2 default '-', pid number,
    aid number,
    pp poster_logs.posted%type default 'Y',
    pm poster_logs.manned%type default 'Y',
    ps poster_logs.satisfactory%type default 'Y',
    pt poster_logs.picture%type default 'Y',
    co poster_logs.comments%type default '' );



end xtract;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
