--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package affil_reqs as

   procedure html;
   procedure accept (req_id integer);
   procedure affil_search (req_id integer);
   procedure affil_search1 (req_id integer);
   procedure affil_search2 (req_id integer);

   procedure edit_req (req_id integer);
   procedure save_req (req_id integer, txt varchar2);
   procedure del_req (req_id integer);
   procedure del_req2 (addr_id integer);

   procedure save (req_id integer, pid integer, affil common.ident_arr, this_affil_type varchar2,
			addr common.ident_arr, this_country varchar2, comments varchar2);
   procedure save2 (req_id integer, pid integer, affil common.ident_arr, this_affil_type varchar2,
			addr common.ident_arr, this_country varchar2, comments varchar2);
   procedure merge (from_id integer, to_id integer, req_id integer);

end affil_reqs;
/
show error
