--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package authorize as

   procedure html;
   procedure add_priv (this_function varchar2, this_privilege varchar2);
   procedure add_user (this_function varchar2, uid varchar2);
   procedure del_priv (fcode varchar2, pcode varchar2);
   procedure del_user (fcode varchar2, pid number);
   procedure xls (fcode varchar2);
   procedure bulk_roles;
   procedure bulk_save (this_function varchar2, emails varchar2);

end authorize;
/
show error
