set define off

Create or Replace package cc_vendor as

   hh$		   boolean := false;
   sqid 	   number := -1;

   procedure forwarder (pid integer, total_amt number, reg_id common.ident_arr,
			amt common.ident_arr,
			return_URL in out varchar2, hh boolean default false, page_id number default null);
   procedure IPN (name_array owa.vc_arr, value_array owa.vc_arr);
   procedure IPN_redirected (pid varchar2,page_id number default null);
   procedure set_ipn_hh_data(pid integer,start_Date date,end_Date date,config varchar2,
			  hotel_id integer,confirmed varchar2,deposit number,room_id integer,choice_order varchar2,date_Record date,paycode varchar2 default null,status varchar2 default null);
   procedure save_ipn_hh_data;
   procedure send_hh_cc_payment_mail(seq number default -1);

end cc_vendor;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
