--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

prompt 
prompt Enter the schmea name that owns the repository.
prompt Note.  Run this script in the repository instance in a confernece
prompt        where the conference database is on a remote server
prompt        (not within the local instance).
prompt 

accept repo_schema_owner prompt 'Repository Schema Owner: '

set heading off feedback off pagesize 0 termout off lines 500 verify off

spool t.sql

select	'create synonym ' || object_name || ' for &repo_schema_owner..' || object_name || ';'
from	all_objects
where	owner		= upper ('&repo_schema_owner')
and	object_name	not like 'DR$%'
and	object_type	in ('TABLE', 'VIEW')
and	object_name	NOT in
(	select	synonym_name
	from	user_synonyms);

spool off

set heading on feedback on termout on pagesize 999 lines 80

set define on

spool Create_Synonyms.log
@t
spool off
