--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

spool Create_Sequences.log

create sequence person_id_seq;
create sequence profile_id_seq;
create sequence address_id_seq;
create sequence affiliation_id_seq;
create sequence abstract_id_seq start with 1001;
create sequence mail_blats_id_seq;
create sequence log_id_seq;
create sequence file_id_seq;
create sequence eclass_code_seq;
create sequence affil_request_id_seq;
create sequence conf_abstract_id_seq;
create sequence email_id_seq;
create sequence unavailable_time_seq;
create sequence meta_data_seq;
create sequence page_id_seq;
create sequence page_data_id;
create sequence poplist_item_id_seq;
create sequence item_id_seq;
create sequence daily_event_id_seq;
create sequence fee_matrix_id_seq;
create sequence credit_card_id_seq;
create sequence payment_id_seq;
create sequence registration_id_seq;
create sequence checkbox_item_id_seq;
create sequence class_session_id_seq;
create sequence payment_vendor_var_ID_SEQ;
create sequence keyword_code_seq;

CREATE SEQUENCE HOTEL_CAT_SEQ;
CREATE SEQUENCE HOTEL_PAY_SQ START WITH 21;
CREATE SEQUENCE HOTEL_ROOMTYPE_SEQ; 
CREATE SEQUENCE HOTEL_SEQ_ID;
CREATE SEQUENCE REGISTRANTS_CHOICE_SQ; 
CREATE SEQUENCE ROOM_DEPOSIT_SQ;  
CREATE SEQUENCE ROOM_TYPES_SQ; 
CREATE SEQUENCE ROOM_HOTELS_SEQ; 
create sequence TEMP_REGISTRANTS_CHOICES_SQ;
create sequence MISC_PAGE_SQ;

create sequence EXPORT_TEMPLATES_SQ;
CREATE SEQUENCE CHOICE_SEQUENCE_SEQ;
create sequence bypass_id_seq;
create sequence application_id_seq;

create sequence sync_id_seq;
create sequence abstract_session_seq;

spool off
