prompt Granting Select on Repository to &1 Conference

set heading off feedback off pagesize 0 termout off lines 500 verify off

spool &1..sql

select	'grant select on ' || table_name || ' to &1.;'
from	user_tables
where	table_name	not like 'DR$%'
and	table_name	not like 'CONTROL'
and	table_name	not in
(
	select	table_name
	from	user_tab_privs
	where	grantee = upper ('&1')
);

select	'grant select on ' || view_name || ' to &1.;'
from	user_views
where	view_name	not in
(
	select	table_name
	from	user_tab_privs
	where	grantee = upper ('&1')
);

select	'grant execute on ' || object_name || ' to &1;'
from	user_objects
where	object_type	= 'PACKAGE'
and	object_name	in ('REPATRIATE', 'SYNC', 'XML_PKG');

spool off

set heading on feedback on termout on pagesize 999 lines 80

@&1..sql

prompt Grants to &1 complete.