--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>set define off

create or replace package maint as

   procedure tab (tab_name varchar2, order_by varchar2 default null, action varchar2 default null);
   procedure del (tab_name varchar2, col_name varchar2, value varchar2);
   procedure save (tab_name varchar2, order_by varchar2 default null, pkey_pos varchar2, action varchar2 default null,
			col_name common.ident_arr, data_type common.ident_arr,
			nullable common.ident_arr, value common.ident_arr);
   procedure menu (ID integer default 0);
   procedure header (rpt_title varchar2, body_open boolean default true);

end maint;
/
show error
set define on
