set define off

Create or Replace package reg_form_maint as

	empty_arr		   	owa_util.ident_arr;

   procedure html;
   procedure del (meta_code varchar2);
   procedure new (cat_code varchar2, page_code varchar2);
   procedure edit (meta_code integer);
   procedure fields (cat_code varchar2);
   procedure save (promp varchar2, short_prompt varchar2, this_data_type varchar2,
		this_display varchar2, fee1 varchar2, fee2 varchar2, cutoff varchar2,
		mlen varchar2, vlen varchar2, crypt common.ident_arr, freeze common.ident_arr,
		single common.ident_arr, req varchar2, this_reg_cat varchar2, flen varchar2, page_code varchar2);
   procedure upd (code varchar2, promp varchar2, short_prompt varchar2, this_data_type varchar2,
		fee1 varchar2, fee2 varchar2, cutoff varchar2, this_display varchar2,
		mlen varchar2, vlen varchar2, req varchar2, maxchk varchar2,
		this_reg_cat varchar2, flen varchar2, crypt common.ident_arr,
		freeze common.ident_arr, single common.ident_arr, maxsps varchar2 default null);
   procedure list_pages(action varchar2 default null);
   procedure pedit  (pid integer, cat_code varchar2 default null);
   procedure pedit1 (pid integer, cat_code varchar2 default null);
   procedure pedit2 (pid integer);
   procedure pdel (pid integer);
   procedure pflag (pid integer, flag varchar2);
   procedure psave (name varchar2, pid integer, pdid common.ident_arr,
		this_meta_data common.ident_arr, txt common.ident_arr, sort common.ident_arr);
   procedure preturn (ID integer);
   procedure preturn_save (ID integer, URL varchar2);
   procedure popup (meta_code integer);
   procedure popup_save (meta_code integer, item_id common.ident_arr, lvalue common.ident_arr,
			fee1 common.ident_arr, fee2 common.ident_arr, srt_ord common.ident_arr);
   procedure fee_matrix;
   procedure fee_matrix_edit (this_meta_data common.ident_arr);
   procedure fee_matrix_save (row_ids common.ident_arr, col_ids common.ident_arr,
					fee1 common.ident_arr, fee2 common.ident_arr);
   procedure pattrib (PID integer);
   procedure pattr_save (pid integer, pname varchar2, email varchar2, maxr varchar2, txt varchar2,
			eURL varchar2, bURL varchar2, hide_inv varchar2,
			incl_rpt varchar2, incl_stats varchar2);
   procedure list_fields(cat_code varchar2);
   procedure registration_opening_text;
   procedure show_lookup_groups(cat_code varchar2);
   procedure add_available_payments(pid number,action varchar2);
   procedure add_selected_payments(selected owa_util.ident_arr default empty_arr, action varchar2, pid number);
   procedure show_selected_payments(pid number);

   procedure test;

end reg_form_maint;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
