--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package repo_email as

   procedure html;

   procedure step2 (this_conference common.ident_arr, this_membership common.ident_arr,
		this_affiliation common.ident_arr, this_country common.ident_arr,
		this_region common.ident_arr, this_affil_type common.ident_arr,
		attrib common.ident_arr, subject varchar2, message varchar2);

   procedure step3 (this_conference common.ident_arr, this_membership common.ident_arr,
		this_affiliation common.ident_arr, this_country common.ident_arr,
		this_region common.ident_arr, this_affil_type common.ident_arr,
		attrib common.ident_arr, subject varchar2, message varchar2, submit varchar2);

   procedure init_variables;

   function replace_variables (message long) return long;

   driver_rec	persons%ROWTYPE;

end repo_email;
/
show error
