
--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace procedure seed_app_privs (app_name$ varchar2, priv$ varchar2) is

app_id	integer;

begin

   insert into applications
   select application_id_seq.nextval, lower (app_name$)
   from	  dual
   where  not exists
	(	select	1
		from	applications
		where	application_name = app_name$);

   insert into application_privs
   select application_id, priv$
   from	  applications
   where  application_name = app_name$;

end seed_app_privs;
/
show erro
